using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Text.RegularExpressions;

namespace Calibration
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_Calibration : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox TB_Values;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Button B_StartCalibration;
		private System.Windows.Forms.Button B_BreakCalibration;
		private System.Windows.Forms.Button B_NextCalibrationStep;
		internal System.Windows.Forms.GroupBox GB_ModuleSelectionBox;
		internal System.Windows.Forms.Button B_GetModuleInformation;
		internal System.Windows.Forms.Label L_MXModuleIdentifier;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		internal System.Windows.Forms.Label label3;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.TextBox TB_IPAddress_3;
		internal System.Windows.Forms.TextBox TB_IPAddress_2;
		internal System.Windows.Forms.TextBox TB_IPAddress_1;
		internal System.Windows.Forms.TextBox TB_IPAddress_0;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.GroupBox GB_TransducerSelectionBox;
		private System.Windows.Forms.Label label7;
		internal System.Windows.Forms.Label L_NbrOfTransducerType;
		internal System.Windows.Forms.Label label6;
		internal System.Windows.Forms.ComboBox CB_TransducerType;
		internal System.Windows.Forms.TextBox TB_TransducerTypeInfo;
		private System.Windows.Forms.TextBox TB_Information;
		private System.Windows.Forms.Timer timer2;
		private System.Windows.Forms.GroupBox GB_ChannelSelection;
		internal System.Windows.Forms.Label label8;
		internal System.Windows.Forms.ComboBox CB_Channel;
		private System.ComponentModel.IContainer components;

		public F_Calibration()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_Calibration));
            this.B_StartCalibration = new System.Windows.Forms.Button();
            this.TB_Values = new System.Windows.Forms.TextBox();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.B_BreakCalibration = new System.Windows.Forms.Button();
            this.B_NextCalibrationStep = new System.Windows.Forms.Button();
            this.GB_ModuleSelectionBox = new System.Windows.Forms.GroupBox();
            this.B_GetModuleInformation = new System.Windows.Forms.Button();
            this.L_MXModuleIdentifier = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_TransducerSelectionBox = new System.Windows.Forms.GroupBox();
            this.TB_TransducerTypeInfo = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.L_NbrOfTransducerType = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_TransducerType = new System.Windows.Forms.ComboBox();
            this.TB_Information = new System.Windows.Forms.TextBox();
            this.timer2 = new System.Windows.Forms.Timer(this.components);
            this.GB_ChannelSelection = new System.Windows.Forms.GroupBox();
            this.CB_Channel = new System.Windows.Forms.ComboBox();
            this.label8 = new System.Windows.Forms.Label();
            this.GB_ModuleSelectionBox.SuspendLayout();
            this.GB_TransducerSelectionBox.SuspendLayout();
            this.GB_ChannelSelection.SuspendLayout();
            this.SuspendLayout();
            // 
            // B_StartCalibration
            // 
            this.B_StartCalibration.Enabled = false;
            this.B_StartCalibration.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StartCalibration.Location = new System.Drawing.Point(736, 232);
            this.B_StartCalibration.Name = "B_StartCalibration";
            this.B_StartCalibration.Size = new System.Drawing.Size(168, 32);
            this.B_StartCalibration.TabIndex = 17;
            this.B_StartCalibration.Text = "Start Calibration";
            this.B_StartCalibration.Click += new System.EventHandler(this.B_StartCalibration_Click);
            // 
            // TB_Values
            // 
            this.TB_Values.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Values.Location = new System.Drawing.Point(16, 232);
            this.TB_Values.Multiline = true;
            this.TB_Values.Name = "TB_Values";
            this.TB_Values.ReadOnly = true;
            this.TB_Values.Size = new System.Drawing.Size(512, 112);
            this.TB_Values.TabIndex = 18;
            // 
            // timer1
            // 
            this.timer1.Interval = 1;
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // B_BreakCalibration
            // 
            this.B_BreakCalibration.Enabled = false;
            this.B_BreakCalibration.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_BreakCalibration.Location = new System.Drawing.Point(736, 312);
            this.B_BreakCalibration.Name = "B_BreakCalibration";
            this.B_BreakCalibration.Size = new System.Drawing.Size(168, 32);
            this.B_BreakCalibration.TabIndex = 19;
            this.B_BreakCalibration.Text = "Break calibration";
            this.B_BreakCalibration.Click += new System.EventHandler(this.B_BreakCalibration_Click);
            // 
            // B_NextCalibrationStep
            // 
            this.B_NextCalibrationStep.Enabled = false;
            this.B_NextCalibrationStep.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_NextCalibrationStep.Location = new System.Drawing.Point(736, 272);
            this.B_NextCalibrationStep.Name = "B_NextCalibrationStep";
            this.B_NextCalibrationStep.Size = new System.Drawing.Size(168, 32);
            this.B_NextCalibrationStep.TabIndex = 20;
            this.B_NextCalibrationStep.Text = "Next step";
            this.B_NextCalibrationStep.Click += new System.EventHandler(this.B_NextCalibrationStep_Click);
            // 
            // GB_ModuleSelectionBox
            // 
            this.GB_ModuleSelectionBox.Controls.Add(this.B_GetModuleInformation);
            this.GB_ModuleSelectionBox.Controls.Add(this.L_MXModuleIdentifier);
            this.GB_ModuleSelectionBox.Controls.Add(this.label5);
            this.GB_ModuleSelectionBox.Controls.Add(this.label4);
            this.GB_ModuleSelectionBox.Controls.Add(this.label3);
            this.GB_ModuleSelectionBox.Controls.Add(this.label2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleSelectionBox.Controls.Add(this.label1);
            this.GB_ModuleSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_ModuleSelectionBox.Location = new System.Drawing.Point(16, 8);
            this.GB_ModuleSelectionBox.Name = "GB_ModuleSelectionBox";
            this.GB_ModuleSelectionBox.Size = new System.Drawing.Size(512, 216);
            this.GB_ModuleSelectionBox.TabIndex = 135;
            this.GB_ModuleSelectionBox.TabStop = false;
            this.GB_ModuleSelectionBox.Text = "Module selection";
            // 
            // B_GetModuleInformation
            // 
            this.B_GetModuleInformation.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_GetModuleInformation.Location = new System.Drawing.Point(384, 24);
            this.B_GetModuleInformation.Name = "B_GetModuleInformation";
            this.B_GetModuleInformation.Size = new System.Drawing.Size(112, 33);
            this.B_GetModuleInformation.TabIndex = 43;
            this.B_GetModuleInformation.Text = "&Connection to module";
            this.B_GetModuleInformation.Click += new System.EventHandler(this.B_GetModuleInformation_Click);
            // 
            // L_MXModuleIdentifier
            // 
            this.L_MXModuleIdentifier.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_MXModuleIdentifier.Location = new System.Drawing.Point(176, 72);
            this.L_MXModuleIdentifier.Name = "L_MXModuleIdentifier";
            this.L_MXModuleIdentifier.Size = new System.Drawing.Size(320, 120);
            this.L_MXModuleIdentifier.TabIndex = 42;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(132, 23);
            this.label5.TabIndex = 41;
            this.label5.Text = "MX Module Identifier :";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(328, 32);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 40;
            this.label4.Text = "-";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(272, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(216, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 38;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_3.Location = new System.Drawing.Point(336, 32);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_3.TabIndex = 37;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_2.Location = new System.Drawing.Point(288, 32);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_2.TabIndex = 36;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_1.Location = new System.Drawing.Point(232, 32);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_1.TabIndex = 35;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(176, 32);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_0.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 32);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(160, 16);
            this.label1.TabIndex = 33;
            this.label1.Text = "IP Address of the MX Module :";
            // 
            // GB_TransducerSelectionBox
            // 
            this.GB_TransducerSelectionBox.Controls.Add(this.TB_TransducerTypeInfo);
            this.GB_TransducerSelectionBox.Controls.Add(this.label7);
            this.GB_TransducerSelectionBox.Controls.Add(this.L_NbrOfTransducerType);
            this.GB_TransducerSelectionBox.Controls.Add(this.label6);
            this.GB_TransducerSelectionBox.Controls.Add(this.CB_TransducerType);
            this.GB_TransducerSelectionBox.Enabled = false;
            this.GB_TransducerSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_TransducerSelectionBox.Location = new System.Drawing.Point(536, 8);
            this.GB_TransducerSelectionBox.Name = "GB_TransducerSelectionBox";
            this.GB_TransducerSelectionBox.Size = new System.Drawing.Size(368, 216);
            this.GB_TransducerSelectionBox.TabIndex = 134;
            this.GB_TransducerSelectionBox.TabStop = false;
            this.GB_TransducerSelectionBox.Text = "Module transducer type selection";
            // 
            // TB_TransducerTypeInfo
            // 
            this.TB_TransducerTypeInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.TB_TransducerTypeInfo.Location = new System.Drawing.Point(16, 80);
            this.TB_TransducerTypeInfo.Multiline = true;
            this.TB_TransducerTypeInfo.Name = "TB_TransducerTypeInfo";
            this.TB_TransducerTypeInfo.ReadOnly = true;
            this.TB_TransducerTypeInfo.Size = new System.Drawing.Size(336, 128);
            this.TB_TransducerTypeInfo.TabIndex = 43;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(16, 48);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(144, 24);
            this.label7.TabIndex = 42;
            this.label7.Text = "Transducer type selection :";
            // 
            // L_NbrOfTransducerType
            // 
            this.L_NbrOfTransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_NbrOfTransducerType.Location = new System.Drawing.Point(160, 24);
            this.L_NbrOfTransducerType.Name = "L_NbrOfTransducerType";
            this.L_NbrOfTransducerType.Size = new System.Drawing.Size(24, 23);
            this.L_NbrOfTransducerType.TabIndex = 41;
            this.L_NbrOfTransducerType.Text = "0";
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(16, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(144, 23);
            this.label6.TabIndex = 40;
            this.label6.Text = "Nbr of transducer type       :";
            // 
            // CB_TransducerType
            // 
            this.CB_TransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.CB_TransducerType.Location = new System.Drawing.Point(160, 48);
            this.CB_TransducerType.Name = "CB_TransducerType";
            this.CB_TransducerType.Size = new System.Drawing.Size(192, 21);
            this.CB_TransducerType.TabIndex = 39;
            this.CB_TransducerType.SelectedIndexChanged += new System.EventHandler(this.CB_TransducerType_SelectedIndexChanged);
            // 
            // TB_Information
            // 
            this.TB_Information.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Information.Location = new System.Drawing.Point(16, 352);
            this.TB_Information.Multiline = true;
            this.TB_Information.Name = "TB_Information";
            this.TB_Information.ReadOnly = true;
            this.TB_Information.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.TB_Information.Size = new System.Drawing.Size(888, 160);
            this.TB_Information.TabIndex = 136;
            // 
            // timer2
            // 
            this.timer2.Interval = 600;
            this.timer2.Tick += new System.EventHandler(this.timer2_Tick);
            // 
            // GB_ChannelSelection
            // 
            this.GB_ChannelSelection.Controls.Add(this.CB_Channel);
            this.GB_ChannelSelection.Controls.Add(this.label8);
            this.GB_ChannelSelection.Enabled = false;
            this.GB_ChannelSelection.Location = new System.Drawing.Point(536, 232);
            this.GB_ChannelSelection.Name = "GB_ChannelSelection";
            this.GB_ChannelSelection.Size = new System.Drawing.Size(192, 112);
            this.GB_ChannelSelection.TabIndex = 137;
            this.GB_ChannelSelection.TabStop = false;
            this.GB_ChannelSelection.Text = "Channel selection";
            // 
            // CB_Channel
            // 
            this.CB_Channel.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Channel.Location = new System.Drawing.Point(104, 40);
            this.CB_Channel.Name = "CB_Channel";
            this.CB_Channel.Size = new System.Drawing.Size(40, 21);
            this.CB_Channel.TabIndex = 127;
            this.CB_Channel.Text = "1";
            // 
            // label8
            // 
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(48, 45);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(58, 23);
            this.label8.TabIndex = 42;
            this.label8.Text = "Channel :";
            // 
            // F_Calibration
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(912, 526);
            this.Controls.Add(this.GB_ChannelSelection);
            this.Controls.Add(this.TB_Information);
            this.Controls.Add(this.GB_ModuleSelectionBox);
            this.Controls.Add(this.GB_TransducerSelectionBox);
            this.Controls.Add(this.B_NextCalibrationStep);
            this.Controls.Add(this.B_BreakCalibration);
            this.Controls.Add(this.TB_Values);
            this.Controls.Add(this.B_StartCalibration);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_Calibration";
            this.Text = "Calibration C#";
            this.Load += new System.EventHandler(this.F_Calibration_Load);
            this.Closed += new System.EventHandler(this.F_Calibration_Closed);
            this.GB_ModuleSelectionBox.ResumeLayout(false);
            this.GB_ModuleSelectionBox.PerformLayout();
            this.GB_TransducerSelectionBox.ResumeLayout(false);
            this.GB_TransducerSelectionBox.PerformLayout();
            this.GB_ChannelSelection.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_Calibration());
		}

		// Global Variable
		MXCommon.MXCommon MX_Global;
		MX3701.MX370x MX_370x;
		System.UInt64 ul_LastStatus = 0;
		double  d_CalibrationPosition = 0.0;
		double  d_CalirationRange = 0.0;

		int i_NbrOfChannel;
		
        /// <summary>
        /// Get the number of transducer channels
        /// </summary>
        /// <param name="s_ModuleType"></param>
        /// <param name="i_ChannelNumber"></param>
		private void v_GetNbrOfTransducerChannel (string s_ModuleType, out int i_ChannelNumber)
		{
            Match reg = null;
            i_ChannelNumber = -1;

            // Check the MX37XX-IO-TYPE
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-([0-9]+)-[a-zA-Z]+");
            if (reg.Success)
            {
                i_ChannelNumber = Convert.ToInt32(reg.Groups[1].Value);
                return;
            }

            // Check the MX37XX-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
            {
                i_ChannelNumber = Convert.ToInt32(reg.Groups[1].Value);
                return;
            }

            // Check the MSX-E37XX-DIO-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MSX-E37[0-9]+-DIO-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
            {
                i_ChannelNumber = Convert.ToInt32(reg.Groups[1].Value);
                return;
            }

            // Fail
            return;

		}


		private void F_Calibration_Load(object sender, System.EventArgs e)
		{
			MX_Global = new MXCommon.MXCommon();
			MX_370x = new MX3701.MX370x();
			MX_Global.Timeout = 2000;
			MX_370x.Timeout = 2000;
		}

		private void F_Calibration_Closed(object sender, System.EventArgs e)
		{
			
			if ((B_StartCalibration.Enabled == false) && ((B_BreakCalibration.Enabled == true)||(B_NextCalibrationStep.Enabled == true)))
			{
				B_BreakCalibration_Click (sender, e);
			}

			MX_370x = null;
			MX_Global = null;

			System.GC.Collect();
		}

		private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_0.SelectAll();
		}

		private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_1.SelectAll();
		}

		private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_2.SelectAll();
		}

		private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_3.SelectAll();
		}


		private UInt64 GetTransducerTypeInfo() 
		{
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex;
			byte[] pc_Name = new byte[255];
			UInt64 ul_CalibrationStatus;
			UInt64 ul_Type;
			UInt64 ul_Frequency;
			UInt64 ul_Impedance;
			double  d_Veff;
			double  d_Sensibility;
			UInt64 ul_SelectedTransducer;
			double  d_Range   = 0.0;

			ul_SelectedTransducer = Convert.ToUInt64(CB_TransducerType.SelectedIndex);

			TB_TransducerTypeInfo.Text = "";
			ul_TransducerSelectionIndex = 0;
			try
			{
				// Get the tranducer type information
				MX_370x.TransducerGetTypeInformation(ul_SelectedTransducer, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);

				// Display the transducer type information
				TB_TransducerTypeInfo.Text = "Transducer Selection Index : " + ul_TransducerSelectionIndex.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Name                                   : " + enc.GetString(pc_Name);
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Calibration status                  : " + ul_CalibrationStatus.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Type Value                          : " + ul_Type.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Frequency                           : " + ul_Frequency.ToString() + " Hz";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Impedance                          : " + ul_Impedance.ToString() + " Ohm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Nominal Voltage                  : " + d_Veff.ToString() + " V";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Sensibility                            : " + d_Sensibility.ToString() + " mV/V/mm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Range                                 : +/-" + d_Range.ToString() + " mm";
			}
			catch (Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			return (ul_TransducerSelectionIndex);
		}

		private void B_GetModuleInformation_Click(object sender, System.EventArgs e)
		{
			byte [] pb_ModuleType = new byte [200];
			UInt64 ul_NbrOfTransducerType = 0;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex = 0;
			Byte []pc_Name = new Byte[255];
			UInt64 ul_CalibrationStatus = 0;
			UInt64 ul_Type = 0;
			UInt64 ul_Frequency = 0;
			UInt64 ul_Impedance = 0;
			UInt64 ul_Cpt = 0;
			double d_Veff = 0;
			double d_Sensibility = 0;
			double  d_Range   = 0.0;
			
			MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "."+
				TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";

			MX_370x.Url = MX_Global.Url;
		
			try
			{
				// Get the module type
				MX_Global.GetModuleType(out pb_ModuleType);
				L_MXModuleIdentifier.Text = enc.GetString(pb_ModuleType);
                v_GetNbrOfTransducerChannel(enc.GetString(pb_ModuleType), out i_NbrOfChannel);
                if (i_NbrOfChannel <= 0)
                {
                    MessageBox.Show("Cannot find the number of transducer channels, assuming it is 16.");
                    i_NbrOfChannel = 16;
                }

				// Get the number of transducer type
				MX_370x.TransducerGetNbrOfType(out ul_NbrOfTransducerType);
				L_NbrOfTransducerType.Text = ul_NbrOfTransducerType.ToString();

				// Get the tranducer type information
				CB_TransducerType.Items.Clear();
				for (ul_Cpt = 0; ul_Cpt < ul_NbrOfTransducerType;ul_Cpt ++)
				{    
					MX_370x.TransducerGetTypeInformation (ul_Cpt,out ul_TransducerSelectionIndex,out pc_Name,out ul_CalibrationStatus,out ul_Type,out ul_Frequency,out ul_Impedance, out d_Veff, out d_Sensibility,out d_Range);
					CB_TransducerType.Items.Add (enc.GetString(pc_Name));
				}
				CB_TransducerType.SelectedIndex = 0;
				B_StartCalibration.Enabled = true;
				B_BreakCalibration.Enabled = false;
				B_NextCalibrationStep.Enabled = false;
				GB_TransducerSelectionBox.Enabled = true;
				GB_ChannelSelection.Enabled = true;
			}
			catch (Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}
		}

		private void CB_TransducerType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetTransducerTypeInfo();
		}


		private void B_StartCalibration_Click(object sender, System.EventArgs e)
		{
			int     i_SysError                 = 0;
			int     i_Error                    = 0;
			Byte []pc_Name                     = new Byte[255];
			UInt64 ul_Type                     = 0;
			UInt64 ul_Frequency                = 0;
			UInt64 ul_Impedance                = 0;
			UInt64 ul_CalibrationStatus        = 0;
			double d_Veff                      = 0.0;
			double d_Sensibility               = 0.0;
			double  d_Range                    = 0.0;
			UInt64 ul_SelectedTransducer       = Convert.ToUInt64 (CB_TransducerType.SelectedIndex);
			UInt64 ul_TransducerSelectionIndex = 0;

			
			TB_Values.Clear ();

			try
			{

				// Get the Transducer Index Selection 
				MX_370x.TransducerGetTypeInformation (ul_SelectedTransducer,out ul_TransducerSelectionIndex,out pc_Name,out ul_CalibrationStatus,out ul_Type,out ul_Frequency,out ul_Impedance, out d_Veff, out d_Sensibility,out d_Range);

				// Start the calibration from selected transducer type via channel 0
				i_Error = MX_370x.CalibrationStartWithPrimaryConnection (ul_TransducerSelectionIndex, Convert.ToUInt64 (CB_Channel.SelectedIndex), d_Range / 2, 0, out i_SysError);

				if (i_Error != 0)
				{
					TB_Values.Text="CalibrationStart Error : " + i_Error.ToString();
				}
				else
				{
					d_CalibrationPosition = d_Range / 2;
					d_CalirationRange = d_Range;
					ul_LastStatus = 0;
					timer1.Enabled = true;
					B_StartCalibration.Enabled = false;
					B_BreakCalibration.Enabled = true;
					GB_TransducerSelectionBox.Enabled = false;
					GB_ChannelSelection.Enabled = false;
				}
			}

			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}
		
		}


		private void B_NextCalibrationStep_Click(object sender, System.EventArgs e)
		{
			int i_Error;

			try
			{
				MX_370x.CalibrationNextStep (out i_Error);
			}

			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			timer2.Enabled = false;
			B_NextCalibrationStep.ForeColor = Color.Black;
		}


		private void B_BreakCalibration_Click(object sender, System.EventArgs e)
		{
			int i_Error;
			
			try
			{
				MX_370x.CalibrationBreak (out i_Error);
			}

			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			timer2.Enabled = false;
			GB_TransducerSelectionBox.Enabled = true;
			GB_ChannelSelection.Enabled = true;
			B_NextCalibrationStep.ForeColor = Color.Black;
		}


		private void timer1_Tick(object sender, System.EventArgs e)
		{
			int            i_Error;
			System.UInt64 ul_Status = 0;
			System.UInt64 ul_DigitalValue = 0;
			double         d_ChannelValue;
			System.Byte[]  b_SaveResponse = new System.Byte[200];
			MX3701.DefaultResponse s_DefaultResponse;
			
			try
			{
				/********************************
				 * Get calibration current status
				 *********************************/
				i_Error = MX_370x.CalibrationGetCurrentStatus (out ul_Status, out ul_DigitalValue);
           
				/***********************/
				/* Test if error occur */
				/***********************/

				if (i_Error != 0)
				{
					TB_Values.Text = TB_Values.Text + "SOAP connection error" + Environment.NewLine + "CalibrationGetCurrentStatus SOAP Error: " + i_Error.ToString() + Environment.NewLine;
					return;
				}
			}

			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message + Environment.NewLine;
			}

			/************************************
			* Test if start primary calibration 
			*************************************/
			if (((ul_Status == 1) || ((ul_Status == 2))) && (ul_LastStatus == 0))
			{
				TB_Information.Text = "Primary calibration started" + Environment.NewLine;

				if (ul_Status == 2)
				{
					ul_LastStatus = 1;
				}
			}

			/**************************************
			* Test if primary calibration started 
			***************************************/
			if ((ul_Status == 1) && (ul_LastStatus == 1))
			{
				/**************
				* Calculate V 
				***************/
				d_ChannelValue = (((2.8 * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - 2.8;
              
				TB_Values.Text = "Primary calibration : " + d_ChannelValue.ToString ("F") + "V";
			}

			/**********************************
			* Test if end primary calibration 
			***********************************/
			if ((ul_Status == 2) && (ul_LastStatus != 2))
			{
				TB_Information.Text = TB_Information.Text + "Primary calibration conclude" + Environment.NewLine;
				TB_Information.Text = TB_Information.Text + "Set the transducer connected to channel " + CB_Channel.SelectedIndex.ToString() + " to position 0 mm and click next" + Environment.NewLine;
				B_NextCalibrationStep.Enabled = true;
				timer2.Enabled = true;
			}

			/******************************************
			* Test if wait user set transducer to 0mm 
			*******************************************/
			if ((ul_Status == 2) && (ul_LastStatus == 2))
			{
				/*********************************
				* Calculate the position into mm 
				**********************************/
				d_ChannelValue = (((d_CalirationRange * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - d_CalirationRange;
              
				TB_Values.Text = "Transducer position = " + d_ChannelValue.ToString ("F4") + " mm";
			}

			/******************************************
			* Test if start null position calibration 
			*******************************************/
			if ((ul_Status == 3) && (ul_LastStatus != 3))
			{
				TB_Information.Text = TB_Information.Text + "Null position calibration started" + Environment.NewLine;
			}

			/************************************
			* Test if null position calibration 
			*************************************/
			if ((ul_Status == 3) && (ul_LastStatus == 3))
			{
				/*********************************
				* Calculate the position into mm 
				**********************************/
				d_ChannelValue = (((d_CalirationRange * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - d_CalirationRange;
              
				TB_Values.Text = "Transducer position = " + d_ChannelValue.ToString ("F4") + " mm";
			}

			/****************************************
			* Test if end user position calibration 
			*****************************************/
			if ((ul_Status == 4) && (ul_LastStatus != 4))
			{
				TB_Information.Text = TB_Information.Text + "Null position calibration conclude" + Environment.NewLine;
				TB_Information.Text = TB_Information.Text + "Set the transducer connected to channel " + CB_Channel.SelectedIndex.ToString () + " to position " + d_CalibrationPosition.ToString ("G4") + "mm and click next" + Environment.NewLine;
				B_NextCalibrationStep.Enabled = true;
				timer2.Enabled = true;
			}

			/****************************************************
			* Test if wait user set transducer to user position 
			*****************************************************/
			if ((ul_Status == 4) && (ul_LastStatus == 4))
			{
				/*********************************
				* Calculate the position into mm 
				**********************************/
				d_ChannelValue = (((d_CalirationRange * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - d_CalirationRange;
              
				TB_Values.Text = "Transducer position = " + d_ChannelValue.ToString ("F4") + " mm";
			}

			/******************************************
			* Test if start user position calibration 
			*******************************************/
			if ((ul_Status == 5) && (ul_LastStatus != 5))
			{
				TB_Information.Text = TB_Information.Text + "User position calibration started" + Environment.NewLine;
			}

			/************************************
			* Test if user position calibration 
			*************************************/
			if ((ul_Status == 5) && (ul_LastStatus == 5))
			{
				/*********************************
				* Calculate the position into mm 
				**********************************/
				d_ChannelValue = (((d_CalirationRange * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - d_CalirationRange;
              
				TB_Values.Text = "Transducer position = " + d_ChannelValue.ToString ("F4") + " mm";
			}

			/****************************************
			 * Test if end user position calibration 
			 ****************************************/
			if ((ul_Status == 7) && (ul_LastStatus != 7))
			{
				TB_Information.Text = TB_Information.Text + "User position calibration conclude" + Environment.NewLine;
				TB_Information.Text = TB_Information.Text + "Connect only one transducer and click next" + Environment.NewLine;
				B_NextCalibrationStep.Enabled = true;
				timer2.Enabled = true;
			}


			/******************************************************
			 * Test if wait that user connect only one transducer 
			 ******************************************************/
			if ((ul_Status == 8) && (ul_LastStatus != 8))
			{
				TB_Information.Text = TB_Information.Text + "Primary open line calibration started";
			}


			/*********************************************
			 * Test if primary open line test calibration
			 *********************************************/
			if ((ul_Status == 8) && (ul_LastStatus == 8))
			{
				/**************
				 * Calculate V 
				 ***************/

				d_ChannelValue = (((2.8 * 2.0) / (double) 0xFFFFFF) * (double) ul_DigitalValue) - 2.8;
              
				TB_Values.Text = "Primary open line calibration : " + d_ChannelValue.ToString ("F") + "V";
			}

			/**************************
			* Test if end calibration 
			***************************/
			if ((ul_Status == 6) && (ul_LastStatus != 6))
			{
				timer1.Enabled = false;
				B_StartCalibration.Enabled = true;
				B_BreakCalibration.Enabled = false;
				B_NextCalibrationStep.Enabled = false;
				GB_TransducerSelectionBox.Enabled = true;
				GB_ChannelSelection.Enabled = true;

				/*******************
				* Error management 
				********************/
				switch (ul_DigitalValue)
				{
					case 0:
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "Calibration conclude" + Environment.NewLine;

						try
						{
							/**********************************
							* Save transducer board data-base 
							***********************************/
							/***********************
							* Save all transducers 
							************************/
							s_DefaultResponse = MX_370x.DataBaseSaveTransducers (out b_SaveResponse);

							/***********************/
							/* Test if error occur */
							/***********************/

							if (s_DefaultResponse.iReturnValue != 0)
							{
								TB_Values.Text = TB_Values.Text + "DataBaseSaveTransducers SOAP Error: " + s_DefaultResponse.iReturnValue.ToString() + Environment.NewLine;
								return;
							}
						}

						catch(Exception ex)
						{
							TB_Values.Text = "Exception occur : " + ex.Message;
						}
						break;

					case 1:
						/***********************
						* Stop the calibration 
						************************/
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "!!!User have break the calibration";
						break;

					case 2:
					case 3:
					case 4:
					case 5:
					case 6:
					case 7:
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "Can not calibrate the primary feedback";
						break;

					case 8:
					case 9:
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "The 0mm position can not by found." + Environment.NewLine + "Restart the calibration and select a new position for the 0mm."; 
						break;

					case 10:
					case 11:
					case 12:
					case 13:
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "The user position can not by found." + Environment.NewLine + "Restart the calibration and select a new position";
						break;

					case 14:
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "Primary short circuit occur";
						break;

					default :
						/****************************
						* Format and show the error 
						*****************************/
						TB_Information.Text = TB_Information.Text + Environment.NewLine + "Calibration error -" + ul_DigitalValue.ToString();
						break;
				}
			}

			ul_LastStatus = ul_Status;

		}

		private void timer2_Tick(object sender, System.EventArgs e)
		{
			if (B_NextCalibrationStep.ForeColor == Color.Blue) 
				B_NextCalibrationStep.ForeColor = Color.Black;
			else
				B_NextCalibrationStep.ForeColor = Color.Blue;
		}

	}
}
