using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDIControls;
using AddiData.ADDISocket;
using System.Text.RegularExpressions;

namespace Sequence
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_Sequence : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button B_StopSequence;
		internal System.Windows.Forms.Button B_StartSequence;
		internal System.Windows.Forms.TextBox TB_Values;
		internal System.Windows.Forms.GroupBox GB_Sequence;
		internal System.Windows.Forms.TextBox TB_NbrMaxOfSeqToTransfer;
		internal System.Windows.Forms.Label label21;
		internal System.Windows.Forms.TextBox TB_NbrOfSequence;
		internal System.Windows.Forms.Label label20;
		internal System.Windows.Forms.GroupBox GB_Delay;
		internal System.Windows.Forms.TextBox TB_DelayValue;
		internal System.Windows.Forms.Label label18;
		internal System.Windows.Forms.ComboBox CB_DelayTimeUnit;
		internal System.Windows.Forms.Label label17;
		internal System.Windows.Forms.ComboBox CB_DelayMode;
		internal System.Windows.Forms.Label label14;
		internal System.Windows.Forms.GroupBox GB_DataFormat;
		internal System.Windows.Forms.CheckBox CHB_DataFormatInvertSign;
		internal System.Windows.Forms.CheckBox CHB_DataFormatSequenceCounter;
		internal System.Windows.Forms.CheckBox CHB_DataFormatAnalogValue;
		internal System.Windows.Forms.CheckBox CHB_DataFormatTimeStamp;
		internal System.Windows.Forms.GroupBox GB_Trigger;
		internal System.Windows.Forms.TextBox TB_NbrOfSeqForEachTrigger;
		internal System.Windows.Forms.Label label12;
		internal System.Windows.Forms.ComboBox CB_TriggerMode;
		internal System.Windows.Forms.Label label10;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.ComboBox CB_TriggerMask;
		internal System.Windows.Forms.TextBox TB_HardwareTriggerCount;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.ComboBox CB_HardwareTriggerEdge;
		private System.Windows.Forms.GroupBox GB_SequenceConfig;
		internal System.Windows.Forms.ComboBox CB_TimeDivision;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.ComboBox CB_Sequence15;
		internal System.Windows.Forms.ComboBox CB_Sequence14;
		internal System.Windows.Forms.ComboBox CB_Sequence13;
		internal System.Windows.Forms.ComboBox CB_Sequence12;
		internal System.Windows.Forms.ComboBox CB_Sequence11;
		internal System.Windows.Forms.ComboBox CB_Sequence10;
		internal System.Windows.Forms.ComboBox CB_Sequence9;
		internal System.Windows.Forms.ComboBox CB_Sequence8;
		internal System.Windows.Forms.ComboBox CB_Sequence7;
		internal System.Windows.Forms.ComboBox CB_Sequence6;
		internal System.Windows.Forms.ComboBox CB_Sequence5;
		internal System.Windows.Forms.ComboBox CB_Sequence4;
		internal System.Windows.Forms.ComboBox CB_Sequence3;
		internal System.Windows.Forms.ComboBox CB_Sequence2;
		internal System.Windows.Forms.ComboBox CB_Sequence1;
		internal System.Windows.Forms.ComboBox CB_Sequence0;
		private System.Windows.Forms.ComboBox CB_NbrOfChannels;
		private System.Windows.Forms.Label label13;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.GroupBox GB_ModuleSelectionBox;
		internal System.Windows.Forms.Button B_GetModuleInformation;
		internal System.Windows.Forms.Label L_MXModuleIdentifier;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		internal System.Windows.Forms.Label label3;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.TextBox TB_IPAddress_3;
		internal System.Windows.Forms.TextBox TB_IPAddress_2;
		internal System.Windows.Forms.TextBox TB_IPAddress_1;
		internal System.Windows.Forms.TextBox TB_IPAddress_0;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.GroupBox GB_TransducerSelectionBox;
		internal System.Windows.Forms.TextBox TB_TransducerTypeInfo;
		private System.Windows.Forms.Label label7;
		internal System.Windows.Forms.Label L_NbrOfTransducerType;
		internal System.Windows.Forms.Label label6;
		internal System.Windows.Forms.ComboBox CB_TransducerType;
        private System.Windows.Forms.Timer DisplayTimer;
        private Panel panel1;
        private RadioButton RB_DisplayAll;
        private RadioButton RB_DisplayLast;
        internal CheckBox CHB_DataFormatRelativeTimeStamp;
		private System.ComponentModel.IContainer components;

		public F_Sequence()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_Sequence));
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.B_StopSequence = new System.Windows.Forms.Button();
            this.B_StartSequence = new System.Windows.Forms.Button();
            this.TB_Values = new System.Windows.Forms.TextBox();
            this.GB_Sequence = new System.Windows.Forms.GroupBox();
            this.TB_NbrMaxOfSeqToTransfer = new System.Windows.Forms.TextBox();
            this.label21 = new System.Windows.Forms.Label();
            this.TB_NbrOfSequence = new System.Windows.Forms.TextBox();
            this.label20 = new System.Windows.Forms.Label();
            this.GB_Delay = new System.Windows.Forms.GroupBox();
            this.TB_DelayValue = new System.Windows.Forms.TextBox();
            this.label18 = new System.Windows.Forms.Label();
            this.CB_DelayTimeUnit = new System.Windows.Forms.ComboBox();
            this.label17 = new System.Windows.Forms.Label();
            this.CB_DelayMode = new System.Windows.Forms.ComboBox();
            this.label14 = new System.Windows.Forms.Label();
            this.GB_DataFormat = new System.Windows.Forms.GroupBox();
            this.CHB_DataFormatInvertSign = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatSequenceCounter = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatAnalogValue = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatRelativeTimeStamp = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatTimeStamp = new System.Windows.Forms.CheckBox();
            this.GB_Trigger = new System.Windows.Forms.GroupBox();
            this.TB_NbrOfSeqForEachTrigger = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.CB_TriggerMode = new System.Windows.Forms.ComboBox();
            this.label10 = new System.Windows.Forms.Label();
            this.Label11 = new System.Windows.Forms.Label();
            this.CB_TriggerMask = new System.Windows.Forms.ComboBox();
            this.TB_HardwareTriggerCount = new System.Windows.Forms.TextBox();
            this.Label15 = new System.Windows.Forms.Label();
            this.Label16 = new System.Windows.Forms.Label();
            this.CB_HardwareTriggerEdge = new System.Windows.Forms.ComboBox();
            this.GB_SequenceConfig = new System.Windows.Forms.GroupBox();
            this.CB_TimeDivision = new System.Windows.Forms.ComboBox();
            this.Label19 = new System.Windows.Forms.Label();
            this.CB_Sequence15 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence14 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence13 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence12 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence11 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence10 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence9 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence8 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence7 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence6 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence5 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence4 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence3 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence2 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence1 = new System.Windows.Forms.ComboBox();
            this.CB_Sequence0 = new System.Windows.Forms.ComboBox();
            this.CB_NbrOfChannels = new System.Windows.Forms.ComboBox();
            this.label13 = new System.Windows.Forms.Label();
            this.Label9 = new System.Windows.Forms.Label();
            this.GB_ModuleSelectionBox = new System.Windows.Forms.GroupBox();
            this.B_GetModuleInformation = new System.Windows.Forms.Button();
            this.L_MXModuleIdentifier = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_TransducerSelectionBox = new System.Windows.Forms.GroupBox();
            this.TB_TransducerTypeInfo = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.L_NbrOfTransducerType = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_TransducerType = new System.Windows.Forms.ComboBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.RB_DisplayAll = new System.Windows.Forms.RadioButton();
            this.RB_DisplayLast = new System.Windows.Forms.RadioButton();
            this.GB_Sequence.SuspendLayout();
            this.GB_Delay.SuspendLayout();
            this.GB_DataFormat.SuspendLayout();
            this.GB_Trigger.SuspendLayout();
            this.GB_SequenceConfig.SuspendLayout();
            this.GB_ModuleSelectionBox.SuspendLayout();
            this.GB_TransducerSelectionBox.SuspendLayout();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // B_StopSequence
            // 
            this.B_StopSequence.Enabled = false;
            this.B_StopSequence.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StopSequence.Location = new System.Drawing.Point(600, 536);
            this.B_StopSequence.Name = "B_StopSequence";
            this.B_StopSequence.Size = new System.Drawing.Size(304, 32);
            this.B_StopSequence.TabIndex = 141;
            this.B_StopSequence.Text = "Stop Sequence";
            this.B_StopSequence.Click += new System.EventHandler(this.B_StopSequence_Click);
            // 
            // B_StartSequence
            // 
            this.B_StartSequence.Enabled = false;
            this.B_StartSequence.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StartSequence.Location = new System.Drawing.Point(600, 472);
            this.B_StartSequence.Name = "B_StartSequence";
            this.B_StartSequence.Size = new System.Drawing.Size(304, 32);
            this.B_StartSequence.TabIndex = 140;
            this.B_StartSequence.Text = "Start Sequence";
            this.B_StartSequence.Click += new System.EventHandler(this.B_StartSequence_Click);
            // 
            // TB_Values
            // 
            this.TB_Values.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.TB_Values.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Values.Location = new System.Drawing.Point(11, 49);
            this.TB_Values.Multiline = true;
            this.TB_Values.Name = "TB_Values";
            this.TB_Values.ReadOnly = true;
            this.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_Values.Size = new System.Drawing.Size(888, 107);
            this.TB_Values.TabIndex = 139;
            // 
            // GB_Sequence
            // 
            this.GB_Sequence.Controls.Add(this.TB_NbrMaxOfSeqToTransfer);
            this.GB_Sequence.Controls.Add(this.label21);
            this.GB_Sequence.Controls.Add(this.TB_NbrOfSequence);
            this.GB_Sequence.Controls.Add(this.label20);
            this.GB_Sequence.Location = new System.Drawing.Point(16, 336);
            this.GB_Sequence.Name = "GB_Sequence";
            this.GB_Sequence.Size = new System.Drawing.Size(272, 104);
            this.GB_Sequence.TabIndex = 138;
            this.GB_Sequence.TabStop = false;
            this.GB_Sequence.Text = "Sequence configuration";
            // 
            // TB_NbrMaxOfSeqToTransfer
            // 
            this.TB_NbrMaxOfSeqToTransfer.Location = new System.Drawing.Point(144, 72);
            this.TB_NbrMaxOfSeqToTransfer.Name = "TB_NbrMaxOfSeqToTransfer";
            this.TB_NbrMaxOfSeqToTransfer.Size = new System.Drawing.Size(80, 20);
            this.TB_NbrMaxOfSeqToTransfer.TabIndex = 22;
            this.TB_NbrMaxOfSeqToTransfer.Text = "10";
            // 
            // label21
            // 
            this.label21.Location = new System.Drawing.Point(8, 64);
            this.label21.Name = "label21";
            this.label21.Size = new System.Drawing.Size(112, 24);
            this.label21.TabIndex = 21;
            this.label21.Text = "Nbr max of sequence to transfer :";
            // 
            // TB_NbrOfSequence
            // 
            this.TB_NbrOfSequence.Location = new System.Drawing.Point(144, 24);
            this.TB_NbrOfSequence.Name = "TB_NbrOfSequence";
            this.TB_NbrOfSequence.Size = new System.Drawing.Size(80, 20);
            this.TB_NbrOfSequence.TabIndex = 20;
            this.TB_NbrOfSequence.Text = "0";
            // 
            // label20
            // 
            this.label20.Location = new System.Drawing.Point(8, 24);
            this.label20.Name = "label20";
            this.label20.Size = new System.Drawing.Size(96, 24);
            this.label20.TabIndex = 15;
            this.label20.Text = "Nbr of sequence (0=continuous) :";
            // 
            // GB_Delay
            // 
            this.GB_Delay.Controls.Add(this.TB_DelayValue);
            this.GB_Delay.Controls.Add(this.label18);
            this.GB_Delay.Controls.Add(this.CB_DelayTimeUnit);
            this.GB_Delay.Controls.Add(this.label17);
            this.GB_Delay.Controls.Add(this.CB_DelayMode);
            this.GB_Delay.Controls.Add(this.label14);
            this.GB_Delay.Location = new System.Drawing.Point(600, 336);
            this.GB_Delay.Name = "GB_Delay";
            this.GB_Delay.Size = new System.Drawing.Size(304, 120);
            this.GB_Delay.TabIndex = 137;
            this.GB_Delay.TabStop = false;
            this.GB_Delay.Text = "Delay configuration";
            // 
            // TB_DelayValue
            // 
            this.TB_DelayValue.Enabled = false;
            this.TB_DelayValue.Location = new System.Drawing.Point(112, 88);
            this.TB_DelayValue.Name = "TB_DelayValue";
            this.TB_DelayValue.Size = new System.Drawing.Size(80, 20);
            this.TB_DelayValue.TabIndex = 20;
            this.TB_DelayValue.Text = "20";
            // 
            // label18
            // 
            this.label18.Location = new System.Drawing.Point(8, 96);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(96, 16);
            this.label18.TabIndex = 16;
            this.label18.Text = "Delay time value :";
            // 
            // CB_DelayTimeUnit
            // 
            this.CB_DelayTimeUnit.Enabled = false;
            this.CB_DelayTimeUnit.Items.AddRange(new object[] {
            "ms",
            "s"});
            this.CB_DelayTimeUnit.Location = new System.Drawing.Point(112, 56);
            this.CB_DelayTimeUnit.Name = "CB_DelayTimeUnit";
            this.CB_DelayTimeUnit.Size = new System.Drawing.Size(80, 21);
            this.CB_DelayTimeUnit.TabIndex = 15;
            this.CB_DelayTimeUnit.Text = "ms";
            // 
            // label17
            // 
            this.label17.Location = new System.Drawing.Point(8, 64);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(88, 16);
            this.label17.TabIndex = 14;
            this.label17.Text = "Delay time unit :";
            // 
            // CB_DelayMode
            // 
            this.CB_DelayMode.Items.AddRange(new object[] {
            "No delay",
            "Delay mode 1",
            "Delay mode 2"});
            this.CB_DelayMode.Location = new System.Drawing.Point(112, 24);
            this.CB_DelayMode.Name = "CB_DelayMode";
            this.CB_DelayMode.Size = new System.Drawing.Size(144, 21);
            this.CB_DelayMode.TabIndex = 13;
            this.CB_DelayMode.Text = "No delay";
            this.CB_DelayMode.SelectedIndexChanged += new System.EventHandler(this.CB_DelayMode_SelectedIndexChanged);
            // 
            // label14
            // 
            this.label14.Location = new System.Drawing.Point(8, 29);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(72, 16);
            this.label14.TabIndex = 12;
            this.label14.Text = "Delay mode :";
            // 
            // GB_DataFormat
            // 
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatInvertSign);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatSequenceCounter);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatAnalogValue);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatRelativeTimeStamp);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatTimeStamp);
            this.GB_DataFormat.Location = new System.Drawing.Point(16, 448);
            this.GB_DataFormat.Name = "GB_DataFormat";
            this.GB_DataFormat.Size = new System.Drawing.Size(272, 120);
            this.GB_DataFormat.TabIndex = 136;
            this.GB_DataFormat.TabStop = false;
            this.GB_DataFormat.Text = "Data format";
            // 
            // CHB_DataFormatInvertSign
            // 
            this.CHB_DataFormatInvertSign.Location = new System.Drawing.Point(16, 75);
            this.CHB_DataFormatInvertSign.Name = "CHB_DataFormatInvertSign";
            this.CHB_DataFormatInvertSign.Size = new System.Drawing.Size(144, 24);
            this.CHB_DataFormatInvertSign.TabIndex = 3;
            this.CHB_DataFormatInvertSign.Text = "Invert the value sign";
            // 
            // CHB_DataFormatSequenceCounter
            // 
            this.CHB_DataFormatSequenceCounter.Location = new System.Drawing.Point(16, 33);
            this.CHB_DataFormatSequenceCounter.Name = "CHB_DataFormatSequenceCounter";
            this.CHB_DataFormatSequenceCounter.Size = new System.Drawing.Size(144, 24);
            this.CHB_DataFormatSequenceCounter.TabIndex = 2;
            this.CHB_DataFormatSequenceCounter.Text = "With Sequence counter";
            // 
            // CHB_DataFormatAnalogValue
            // 
            this.CHB_DataFormatAnalogValue.Location = new System.Drawing.Point(16, 54);
            this.CHB_DataFormatAnalogValue.Name = "CHB_DataFormatAnalogValue";
            this.CHB_DataFormatAnalogValue.Size = new System.Drawing.Size(144, 24);
            this.CHB_DataFormatAnalogValue.TabIndex = 1;
            this.CHB_DataFormatAnalogValue.Text = "Convert in metric value";
            // 
            // CHB_DataFormatRelativeTimeStamp
            // 
            this.CHB_DataFormatRelativeTimeStamp.AutoSize = true;
            this.CHB_DataFormatRelativeTimeStamp.Location = new System.Drawing.Point(16, 99);
            this.CHB_DataFormatRelativeTimeStamp.Name = "CHB_DataFormatRelativeTimeStamp";
            this.CHB_DataFormatRelativeTimeStamp.Size = new System.Drawing.Size(138, 17);
            this.CHB_DataFormatRelativeTimeStamp.TabIndex = 0;
            this.CHB_DataFormatRelativeTimeStamp.Text = "With relative time stamp";
            this.CHB_DataFormatRelativeTimeStamp.CheckedChanged += new System.EventHandler(this.CHB_DataFormatRelativeTimeStamp_CheckedChanged);
            // 
            // CHB_DataFormatTimeStamp
            // 
            this.CHB_DataFormatTimeStamp.Location = new System.Drawing.Point(16, 12);
            this.CHB_DataFormatTimeStamp.Name = "CHB_DataFormatTimeStamp";
            this.CHB_DataFormatTimeStamp.Size = new System.Drawing.Size(104, 24);
            this.CHB_DataFormatTimeStamp.TabIndex = 0;
            this.CHB_DataFormatTimeStamp.Text = "With time stamp";
            this.CHB_DataFormatTimeStamp.CheckedChanged += new System.EventHandler(this.CHB_DataFormatTimeStamp_CheckedChanged);
            // 
            // GB_Trigger
            // 
            this.GB_Trigger.Controls.Add(this.TB_NbrOfSeqForEachTrigger);
            this.GB_Trigger.Controls.Add(this.label12);
            this.GB_Trigger.Controls.Add(this.CB_TriggerMode);
            this.GB_Trigger.Controls.Add(this.label10);
            this.GB_Trigger.Controls.Add(this.Label11);
            this.GB_Trigger.Controls.Add(this.CB_TriggerMask);
            this.GB_Trigger.Controls.Add(this.TB_HardwareTriggerCount);
            this.GB_Trigger.Controls.Add(this.Label15);
            this.GB_Trigger.Controls.Add(this.Label16);
            this.GB_Trigger.Controls.Add(this.CB_HardwareTriggerEdge);
            this.GB_Trigger.Location = new System.Drawing.Point(296, 336);
            this.GB_Trigger.Name = "GB_Trigger";
            this.GB_Trigger.Size = new System.Drawing.Size(296, 232);
            this.GB_Trigger.TabIndex = 135;
            this.GB_Trigger.TabStop = false;
            this.GB_Trigger.Text = "Trigger configuration";
            // 
            // TB_NbrOfSeqForEachTrigger
            // 
            this.TB_NbrOfSeqForEachTrigger.Enabled = false;
            this.TB_NbrOfSeqForEachTrigger.Location = new System.Drawing.Point(184, 184);
            this.TB_NbrOfSeqForEachTrigger.Name = "TB_NbrOfSeqForEachTrigger";
            this.TB_NbrOfSeqForEachTrigger.Size = new System.Drawing.Size(80, 20);
            this.TB_NbrOfSeqForEachTrigger.TabIndex = 17;
            this.TB_NbrOfSeqForEachTrigger.Text = "1";
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(32, 176);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(128, 24);
            this.label12.TabIndex = 16;
            this.label12.Text = "Nbr of Sequence to acquire for each trigger :";
            // 
            // CB_TriggerMode
            // 
            this.CB_TriggerMode.Enabled = false;
            this.CB_TriggerMode.Items.AddRange(new object[] {
            "Single shot",
            "Sequence"});
            this.CB_TriggerMode.Location = new System.Drawing.Point(184, 136);
            this.CB_TriggerMode.Name = "CB_TriggerMode";
            this.CB_TriggerMode.Size = new System.Drawing.Size(80, 21);
            this.CB_TriggerMode.TabIndex = 15;
            this.CB_TriggerMode.Text = "Single shot";
            this.CB_TriggerMode.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerMode_SelectedIndexChanged);
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(32, 144);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(128, 16);
            this.label10.TabIndex = 14;
            this.label10.Text = "Trigger mode :";
            // 
            // Label11
            // 
            this.Label11.Location = new System.Drawing.Point(32, 24);
            this.Label11.Name = "Label11";
            this.Label11.Size = new System.Drawing.Size(80, 18);
            this.Label11.TabIndex = 7;
            this.Label11.Text = "Trigger mask :";
            // 
            // CB_TriggerMask
            // 
            this.CB_TriggerMask.Items.AddRange(new object[] {
            "No trigger",
            "Digital input trigger",
            "Synchro trigger"});
            this.CB_TriggerMask.Location = new System.Drawing.Point(112, 16);
            this.CB_TriggerMask.Name = "CB_TriggerMask";
            this.CB_TriggerMask.Size = new System.Drawing.Size(152, 21);
            this.CB_TriggerMask.TabIndex = 6;
            this.CB_TriggerMask.Text = "No trigger";
            this.CB_TriggerMask.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerMask_SelectedIndexChanged);
            // 
            // TB_HardwareTriggerCount
            // 
            this.TB_HardwareTriggerCount.Enabled = false;
            this.TB_HardwareTriggerCount.Location = new System.Drawing.Point(184, 96);
            this.TB_HardwareTriggerCount.Name = "TB_HardwareTriggerCount";
            this.TB_HardwareTriggerCount.Size = new System.Drawing.Size(80, 20);
            this.TB_HardwareTriggerCount.TabIndex = 11;
            this.TB_HardwareTriggerCount.Text = "1";
            // 
            // Label15
            // 
            this.Label15.Location = new System.Drawing.Point(32, 96);
            this.Label15.Name = "Label15";
            this.Label15.Size = new System.Drawing.Size(128, 16);
            this.Label15.TabIndex = 10;
            this.Label15.Text = "Hardware trigger Count :";
            // 
            // Label16
            // 
            this.Label16.Location = new System.Drawing.Point(32, 64);
            this.Label16.Name = "Label16";
            this.Label16.Size = new System.Drawing.Size(128, 16);
            this.Label16.TabIndex = 9;
            this.Label16.Text = "Hardware trigger edge :";
            // 
            // CB_HardwareTriggerEdge
            // 
            this.CB_HardwareTriggerEdge.Enabled = false;
            this.CB_HardwareTriggerEdge.Items.AddRange(new object[] {
            "Rising edge",
            "Falling edge",
            "Both edge"});
            this.CB_HardwareTriggerEdge.Location = new System.Drawing.Point(184, 56);
            this.CB_HardwareTriggerEdge.Name = "CB_HardwareTriggerEdge";
            this.CB_HardwareTriggerEdge.Size = new System.Drawing.Size(80, 21);
            this.CB_HardwareTriggerEdge.TabIndex = 8;
            this.CB_HardwareTriggerEdge.Text = "Rising edge";
            // 
            // GB_SequenceConfig
            // 
            this.GB_SequenceConfig.Controls.Add(this.CB_TimeDivision);
            this.GB_SequenceConfig.Controls.Add(this.Label19);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence15);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence14);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence13);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence12);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence11);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence10);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence9);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence8);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence7);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence6);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence5);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence4);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence3);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence2);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence1);
            this.GB_SequenceConfig.Controls.Add(this.CB_Sequence0);
            this.GB_SequenceConfig.Controls.Add(this.CB_NbrOfChannels);
            this.GB_SequenceConfig.Controls.Add(this.label13);
            this.GB_SequenceConfig.Controls.Add(this.Label9);
            this.GB_SequenceConfig.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_SequenceConfig.Location = new System.Drawing.Point(16, 224);
            this.GB_SequenceConfig.Name = "GB_SequenceConfig";
            this.GB_SequenceConfig.Size = new System.Drawing.Size(888, 96);
            this.GB_SequenceConfig.TabIndex = 134;
            this.GB_SequenceConfig.TabStop = false;
            this.GB_SequenceConfig.Text = "Sequence channel configuration";
            // 
            // CB_TimeDivision
            // 
            this.CB_TimeDivision.Items.AddRange(new object[] {
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16",
            "17",
            "18",
            "19",
            "20",
            "21",
            "22",
            "23",
            "24",
            "25",
            "26",
            "27",
            "28",
            "29",
            "30",
            "31",
            "32",
            "33",
            "34",
            "35",
            "36",
            "37",
            "38",
            "39",
            "40",
            "41",
            "42",
            "43",
            "44",
            "45",
            "46",
            "47",
            "48",
            "49",
            "50",
            "51",
            "52",
            "53",
            "54",
            "55",
            "56",
            "57",
            "58",
            "59",
            "60",
            "61",
            "62",
            "63",
            "64",
            "65",
            "66",
            "67",
            "68",
            "69",
            "70",
            "71",
            "72",
            "73",
            "74",
            "75",
            "76",
            "77",
            "78",
            "79",
            "80",
            "81",
            "82",
            "83",
            "84",
            "85",
            "86",
            "87",
            "88",
            "89",
            "90",
            "91",
            "92",
            "93",
            "94",
            "95",
            "96",
            "97",
            "98",
            "99",
            "100",
            "101",
            "102",
            "103",
            "104",
            "105",
            "106",
            "107",
            "108",
            "109",
            "110",
            "111",
            "112",
            "113",
            "114",
            "115",
            "116",
            "117",
            "118",
            "119",
            "120",
            "121",
            "122",
            "123",
            "124",
            "125",
            "126",
            "127",
            "128",
            "129",
            "130",
            "131",
            "132",
            "133",
            "134",
            "135",
            "136",
            "137",
            "138",
            "139",
            "140",
            "141",
            "142",
            "143",
            "144",
            "145",
            "146",
            "147",
            "148",
            "149",
            "150",
            "151",
            "152",
            "153",
            "154",
            "155",
            "156",
            "157",
            "158",
            "159",
            "160",
            "161",
            "162",
            "163",
            "164",
            "165",
            "166",
            "167",
            "168",
            "169",
            "170",
            "171",
            "172",
            "173",
            "174",
            "175",
            "176",
            "177",
            "178",
            "179",
            "180",
            "181",
            "182",
            "183",
            "184",
            "185",
            "186",
            "187",
            "188",
            "189",
            "190",
            "191",
            "192",
            "193",
            "194",
            "195",
            "196",
            "197",
            "198",
            "199",
            "200",
            "201",
            "202",
            "203",
            "204",
            "205",
            "206",
            "207",
            "208",
            "209",
            "210",
            "211",
            "212",
            "213",
            "214",
            "215",
            "216",
            "217",
            "218",
            "219",
            "220",
            "221",
            "222",
            "223",
            "224",
            "225",
            "226",
            "227",
            "228",
            "229",
            "230",
            "231",
            "232",
            "233",
            "234",
            "235",
            "236",
            "237",
            "238",
            "239",
            "240",
            "241",
            "242",
            "243",
            "244",
            "245",
            "246",
            "247",
            "248",
            "249",
            "250",
            "251",
            "252",
            "253",
            "254",
            "255"});
            this.CB_TimeDivision.Location = new System.Drawing.Point(432, 24);
            this.CB_TimeDivision.Name = "CB_TimeDivision";
            this.CB_TimeDivision.Size = new System.Drawing.Size(48, 21);
            this.CB_TimeDivision.TabIndex = 143;
            this.CB_TimeDivision.Text = "15";
            // 
            // Label19
            // 
            this.Label19.Location = new System.Drawing.Point(224, 24);
            this.Label19.Name = "Label19";
            this.Label19.Size = new System.Drawing.Size(224, 16);
            this.Label19.TabIndex = 142;
            this.Label19.Text = "Frequency time division factor (minimal 5) :";
            // 
            // CB_Sequence15
            // 
            this.CB_Sequence15.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence15.Location = new System.Drawing.Point(840, 64);
            this.CB_Sequence15.Name = "CB_Sequence15";
            this.CB_Sequence15.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence15.TabIndex = 141;
            this.CB_Sequence15.Text = "16";
            // 
            // CB_Sequence14
            // 
            this.CB_Sequence14.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence14.Location = new System.Drawing.Point(792, 64);
            this.CB_Sequence14.Name = "CB_Sequence14";
            this.CB_Sequence14.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence14.TabIndex = 140;
            this.CB_Sequence14.Text = "15";
            // 
            // CB_Sequence13
            // 
            this.CB_Sequence13.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence13.Location = new System.Drawing.Point(744, 64);
            this.CB_Sequence13.Name = "CB_Sequence13";
            this.CB_Sequence13.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence13.TabIndex = 139;
            this.CB_Sequence13.Text = "14";
            // 
            // CB_Sequence12
            // 
            this.CB_Sequence12.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence12.Location = new System.Drawing.Point(696, 64);
            this.CB_Sequence12.Name = "CB_Sequence12";
            this.CB_Sequence12.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence12.TabIndex = 138;
            this.CB_Sequence12.Text = "13";
            // 
            // CB_Sequence11
            // 
            this.CB_Sequence11.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence11.Location = new System.Drawing.Point(648, 64);
            this.CB_Sequence11.Name = "CB_Sequence11";
            this.CB_Sequence11.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence11.TabIndex = 137;
            this.CB_Sequence11.Text = "12";
            // 
            // CB_Sequence10
            // 
            this.CB_Sequence10.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence10.Location = new System.Drawing.Point(600, 64);
            this.CB_Sequence10.Name = "CB_Sequence10";
            this.CB_Sequence10.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence10.TabIndex = 136;
            this.CB_Sequence10.Text = "11";
            // 
            // CB_Sequence9
            // 
            this.CB_Sequence9.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence9.Location = new System.Drawing.Point(552, 64);
            this.CB_Sequence9.Name = "CB_Sequence9";
            this.CB_Sequence9.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence9.TabIndex = 135;
            this.CB_Sequence9.Text = "10";
            // 
            // CB_Sequence8
            // 
            this.CB_Sequence8.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence8.Location = new System.Drawing.Point(504, 64);
            this.CB_Sequence8.Name = "CB_Sequence8";
            this.CB_Sequence8.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence8.TabIndex = 134;
            this.CB_Sequence8.Text = "9";
            // 
            // CB_Sequence7
            // 
            this.CB_Sequence7.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence7.Location = new System.Drawing.Point(456, 64);
            this.CB_Sequence7.Name = "CB_Sequence7";
            this.CB_Sequence7.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence7.TabIndex = 133;
            this.CB_Sequence7.Text = "8";
            // 
            // CB_Sequence6
            // 
            this.CB_Sequence6.Items.AddRange(new object[] {
             "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence6.Location = new System.Drawing.Point(408, 64);
            this.CB_Sequence6.Name = "CB_Sequence6";
            this.CB_Sequence6.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence6.TabIndex = 132;
            this.CB_Sequence6.Text = "7";
            // 
            // CB_Sequence5
            // 
            this.CB_Sequence5.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence5.Location = new System.Drawing.Point(360, 64);
            this.CB_Sequence5.Name = "CB_Sequence5";
            this.CB_Sequence5.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence5.TabIndex = 131;
            this.CB_Sequence5.Text = "6";
            // 
            // CB_Sequence4
            // 
            this.CB_Sequence4.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence4.Location = new System.Drawing.Point(312, 64);
            this.CB_Sequence4.Name = "CB_Sequence4";
            this.CB_Sequence4.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence4.TabIndex = 130;
            this.CB_Sequence4.Text = "5";
            // 
            // CB_Sequence3
            // 
            this.CB_Sequence3.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence3.Location = new System.Drawing.Point(264, 64);
            this.CB_Sequence3.Name = "CB_Sequence3";
            this.CB_Sequence3.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence3.TabIndex = 129;
            this.CB_Sequence3.Text = "4";
            // 
            // CB_Sequence2
            // 
            this.CB_Sequence2.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence2.Location = new System.Drawing.Point(216, 64);
            this.CB_Sequence2.Name = "CB_Sequence2";
            this.CB_Sequence2.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence2.TabIndex = 128;
            this.CB_Sequence2.Text = "3";
            // 
            // CB_Sequence1
            // 
            this.CB_Sequence1.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence1.Location = new System.Drawing.Point(168, 64);
            this.CB_Sequence1.Name = "CB_Sequence1";
            this.CB_Sequence1.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence1.TabIndex = 127;
            this.CB_Sequence1.Text = "2";
            // 
            // CB_Sequence0
            // 
            this.CB_Sequence0.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_Sequence0.Location = new System.Drawing.Point(120, 64);
            this.CB_Sequence0.Name = "CB_Sequence0";
            this.CB_Sequence0.Size = new System.Drawing.Size(40, 21);
            this.CB_Sequence0.TabIndex = 126;
            this.CB_Sequence0.Text = "1";
            // 
            // CB_NbrOfChannels
            // 
            this.CB_NbrOfChannels.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16"});
            this.CB_NbrOfChannels.Location = new System.Drawing.Point(168, 24);
            this.CB_NbrOfChannels.Name = "CB_NbrOfChannels";
            this.CB_NbrOfChannels.Size = new System.Drawing.Size(40, 21);
            this.CB_NbrOfChannels.TabIndex = 125;
            this.CB_NbrOfChannels.Text = "16";
            this.CB_NbrOfChannels.SelectedIndexChanged += new System.EventHandler(this.CB_NbrOfChannels_SelectedIndexChanged);
            // 
            // label13
            // 
            this.label13.Location = new System.Drawing.Point(8, 24);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(208, 16);
            this.label13.TabIndex = 124;
            this.label13.Text = "Nbr of channel in the sequence :";
            // 
            // Label9
            // 
            this.Label9.Location = new System.Drawing.Point(8, 64);
            this.Label9.Name = "Label9";
            this.Label9.Size = new System.Drawing.Size(104, 16);
            this.Label9.TabIndex = 123;
            this.Label9.Text = "Channel  selection:";
            // 
            // GB_ModuleSelectionBox
            // 
            this.GB_ModuleSelectionBox.Controls.Add(this.B_GetModuleInformation);
            this.GB_ModuleSelectionBox.Controls.Add(this.L_MXModuleIdentifier);
            this.GB_ModuleSelectionBox.Controls.Add(this.label5);
            this.GB_ModuleSelectionBox.Controls.Add(this.label4);
            this.GB_ModuleSelectionBox.Controls.Add(this.label3);
            this.GB_ModuleSelectionBox.Controls.Add(this.label2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleSelectionBox.Controls.Add(this.label1);
            this.GB_ModuleSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_ModuleSelectionBox.Location = new System.Drawing.Point(16, 8);
            this.GB_ModuleSelectionBox.Name = "GB_ModuleSelectionBox";
            this.GB_ModuleSelectionBox.Size = new System.Drawing.Size(512, 208);
            this.GB_ModuleSelectionBox.TabIndex = 133;
            this.GB_ModuleSelectionBox.TabStop = false;
            this.GB_ModuleSelectionBox.Text = "Module selection";
            // 
            // B_GetModuleInformation
            // 
            this.B_GetModuleInformation.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_GetModuleInformation.Location = new System.Drawing.Point(384, 24);
            this.B_GetModuleInformation.Name = "B_GetModuleInformation";
            this.B_GetModuleInformation.Size = new System.Drawing.Size(112, 33);
            this.B_GetModuleInformation.TabIndex = 43;
            this.B_GetModuleInformation.Text = "&Connection to module";
            this.B_GetModuleInformation.Click += new System.EventHandler(this.B_GetModuleInformation_Click);
            // 
            // L_MXModuleIdentifier
            // 
            this.L_MXModuleIdentifier.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_MXModuleIdentifier.Location = new System.Drawing.Point(176, 72);
            this.L_MXModuleIdentifier.Name = "L_MXModuleIdentifier";
            this.L_MXModuleIdentifier.Size = new System.Drawing.Size(320, 120);
            this.L_MXModuleIdentifier.TabIndex = 42;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(132, 23);
            this.label5.TabIndex = 41;
            this.label5.Text = "MX Module Identifier :";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(328, 32);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 40;
            this.label4.Text = "-";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(272, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(216, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 38;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_3.Location = new System.Drawing.Point(336, 32);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_3.TabIndex = 37;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_2.Location = new System.Drawing.Point(288, 32);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_2.TabIndex = 36;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_1.Location = new System.Drawing.Point(232, 32);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_1.TabIndex = 35;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(176, 32);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_0.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 32);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(160, 16);
            this.label1.TabIndex = 33;
            this.label1.Text = "IP Address of the MX Module :";
            // 
            // GB_TransducerSelectionBox
            // 
            this.GB_TransducerSelectionBox.Controls.Add(this.TB_TransducerTypeInfo);
            this.GB_TransducerSelectionBox.Controls.Add(this.label7);
            this.GB_TransducerSelectionBox.Controls.Add(this.L_NbrOfTransducerType);
            this.GB_TransducerSelectionBox.Controls.Add(this.label6);
            this.GB_TransducerSelectionBox.Controls.Add(this.CB_TransducerType);
            this.GB_TransducerSelectionBox.Enabled = false;
            this.GB_TransducerSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_TransducerSelectionBox.Location = new System.Drawing.Point(536, 8);
            this.GB_TransducerSelectionBox.Name = "GB_TransducerSelectionBox";
            this.GB_TransducerSelectionBox.Size = new System.Drawing.Size(368, 208);
            this.GB_TransducerSelectionBox.TabIndex = 132;
            this.GB_TransducerSelectionBox.TabStop = false;
            this.GB_TransducerSelectionBox.Text = "Module transducer type selection";
            // 
            // TB_TransducerTypeInfo
            // 
            this.TB_TransducerTypeInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.TB_TransducerTypeInfo.Location = new System.Drawing.Point(16, 80);
            this.TB_TransducerTypeInfo.Multiline = true;
            this.TB_TransducerTypeInfo.Name = "TB_TransducerTypeInfo";
            this.TB_TransducerTypeInfo.ReadOnly = true;
            this.TB_TransducerTypeInfo.Size = new System.Drawing.Size(336, 112);
            this.TB_TransducerTypeInfo.TabIndex = 43;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(16, 48);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(144, 24);
            this.label7.TabIndex = 42;
            this.label7.Text = "Transducer type selection :";
            // 
            // L_NbrOfTransducerType
            // 
            this.L_NbrOfTransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_NbrOfTransducerType.Location = new System.Drawing.Point(160, 24);
            this.L_NbrOfTransducerType.Name = "L_NbrOfTransducerType";
            this.L_NbrOfTransducerType.Size = new System.Drawing.Size(24, 23);
            this.L_NbrOfTransducerType.TabIndex = 41;
            this.L_NbrOfTransducerType.Text = "0";
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(16, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(144, 23);
            this.label6.TabIndex = 40;
            this.label6.Text = "Nbr of transducer type       :";
            // 
            // CB_TransducerType
            // 
            this.CB_TransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.CB_TransducerType.Location = new System.Drawing.Point(160, 48);
            this.CB_TransducerType.Name = "CB_TransducerType";
            this.CB_TransducerType.Size = new System.Drawing.Size(192, 21);
            this.CB_TransducerType.TabIndex = 39;
            this.CB_TransducerType.SelectedIndexChanged += new System.EventHandler(this.CB_TransducerType_SelectedIndexChanged);
            // 
            // panel1
            // 
            this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.panel1.Controls.Add(this.RB_DisplayAll);
            this.panel1.Controls.Add(this.RB_DisplayLast);
            this.panel1.Controls.Add(this.TB_Values);
            this.panel1.Location = new System.Drawing.Point(5, 574);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(912, 165);
            this.panel1.TabIndex = 142;
            // 
            // RB_DisplayAll
            // 
            this.RB_DisplayAll.AutoSize = true;
            this.RB_DisplayAll.Location = new System.Drawing.Point(166, 16);
            this.RB_DisplayAll.Name = "RB_DisplayAll";
            this.RB_DisplayAll.Size = new System.Drawing.Size(130, 17);
            this.RB_DisplayAll.TabIndex = 141;
            this.RB_DisplayAll.TabStop = true;
            this.RB_DisplayAll.Text = "Display all acquisitions";
            this.RB_DisplayAll.UseVisualStyleBackColor = true;
            // 
            // RB_DisplayLast
            // 
            this.RB_DisplayLast.AutoSize = true;
            this.RB_DisplayLast.Checked = true;
            this.RB_DisplayLast.Location = new System.Drawing.Point(11, 16);
            this.RB_DisplayLast.Name = "RB_DisplayLast";
            this.RB_DisplayLast.Size = new System.Drawing.Size(153, 17);
            this.RB_DisplayLast.TabIndex = 140;
            this.RB_DisplayLast.TabStop = true;
            this.RB_DisplayLast.Text = "Display only last acquisition";
            this.RB_DisplayLast.UseVisualStyleBackColor = true;
            // 
            // F_Sequence
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(944, 742);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.B_StopSequence);
            this.Controls.Add(this.B_StartSequence);
            this.Controls.Add(this.GB_Sequence);
            this.Controls.Add(this.GB_Delay);
            this.Controls.Add(this.GB_DataFormat);
            this.Controls.Add(this.GB_Trigger);
            this.Controls.Add(this.GB_SequenceConfig);
            this.Controls.Add(this.GB_ModuleSelectionBox);
            this.Controls.Add(this.GB_TransducerSelectionBox);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_Sequence";
            this.Text = "Sequence C#";
            this.Load += new System.EventHandler(this.F_Sequence_Load);
            this.Closed += new System.EventHandler(this.F_Sequence_Closed);
            this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.F_Sequence_FormClosed);
            this.GB_Sequence.ResumeLayout(false);
            this.GB_Sequence.PerformLayout();
            this.GB_Delay.ResumeLayout(false);
            this.GB_Delay.PerformLayout();
            this.GB_DataFormat.ResumeLayout(false);
            this.GB_DataFormat.PerformLayout();
            this.GB_Trigger.ResumeLayout(false);
            this.GB_Trigger.PerformLayout();
            this.GB_SequenceConfig.ResumeLayout(false);
            this.GB_ModuleSelectionBox.ResumeLayout(false);
            this.GB_ModuleSelectionBox.PerformLayout();
            this.GB_TransducerSelectionBox.ResumeLayout(false);
            this.GB_TransducerSelectionBox.PerformLayout();
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_Sequence());
		}

		// Global Variable
		MXCommon.MXCommon MX_Global;
		MX370x.MX370x MX_370x;

		ComboBox[]        s_CB_Sequence;
        int               NbrOfChannels   = 0;
        Socket            SocketClient    = null;
        UInt64            DataFormat      = 0;
        String            DisplayText     = "";
        AsyncClientStream Client          = null;
        bool              DisplayOnlyLast = true;
        int               DataStreamNbrOfValues;
		
        /// <summary>
        /// Get the number of transducer channels
        /// </summary>
        /// <param name="s_ModuleType"></param>
        /// <returns></returns>
		private int i_GetNbrOfTransducerChannel (string s_ModuleType)
		{
            Match reg = null;

            // Check the MX37XX-IO-TYPE
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-([0-9]+)-[a-zA-Z]+");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Check the MX37XX-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Check the MSX-E37XX-DIO-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MSX-E37[0-9]+-DIO-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Fail
            return -1;

		}

		private UInt64 GetTransducerTypeInfo() 
		{
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex;
			byte[] pc_Name = new byte[255];
			UInt64 ul_CalibrationStatus;
			UInt64 ul_Type;
			UInt64 ul_Frequency;
			UInt64 ul_Impedance;
			double  d_Veff;
			double  d_Range;
			double  d_Sensibility;
			UInt64 ul_SelectedTransducer;

			ul_SelectedTransducer = Convert.ToUInt64(CB_TransducerType.SelectedIndex);

			TB_TransducerTypeInfo.Text = "";
			ul_TransducerSelectionIndex = 0;
			try
			{
				// Get the tranducer type information
				MX_370x.TransducerGetTypeInformation(ul_SelectedTransducer, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);

				// Display the transducer type information
				TB_TransducerTypeInfo.Text = "Transducer Selection Index : " + ul_TransducerSelectionIndex.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Name                                   : " + enc.GetString(pc_Name);
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Calibration status                  : " + ul_CalibrationStatus.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Type Value                          : " + ul_Type.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Frequency                           : " + ul_Frequency.ToString() + " Hz";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Impedance                          : " + ul_Impedance.ToString() + " Ohm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Nominal Voltage                  : " + d_Veff.ToString() + " V";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Sensibility                            : " + d_Sensibility.ToString() + " mV/V/mm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Range                                 : +/-" + d_Range.ToString() + " mm";
			}
			catch (Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			return (ul_TransducerSelectionIndex);
		}

		
		private void F_Sequence_Load(object sender, System.EventArgs e)
		{

			MX_Global = new MXCommon.MXCommon();
			MX_370x = new MX370x.MX370x();
			MX_Global.Timeout = 2000;
			MX_370x.Timeout = 2000;

		    s_CB_Sequence = new ComboBox[] {CB_Sequence0, CB_Sequence1, CB_Sequence2, CB_Sequence3, 
                                            CB_Sequence4, CB_Sequence5, CB_Sequence6, CB_Sequence7, 
                                            CB_Sequence8, CB_Sequence9, CB_Sequence10, CB_Sequence11, 
                                            CB_Sequence12, CB_Sequence13, CB_Sequence14, CB_Sequence15};
		}

		private void F_Sequence_Closed(object sender, System.EventArgs e)
		{
            DisplayTimer.Enabled = false;

			if ((B_StartSequence.Enabled == false) && (B_StopSequence.Enabled == true))
			{
				B_StopSequence_Click(sender,e);
			}
			
			MX_370x = null;
			MX_Global = null;

			System.GC.Collect();
		}

		private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_0.SelectAll();
		}

		private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_1.SelectAll();
		}

		private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_2.SelectAll();
		}

		private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_3.SelectAll();
		}

		private void CB_TriggerMask_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (CB_TriggerMask.SelectedIndex != 0)
			{
				CB_TriggerMode.Enabled = true;
			}
			else
			{
				CB_TriggerMode.Enabled = false;
				TB_NbrOfSeqForEachTrigger.Enabled = false;
				CB_HardwareTriggerEdge.Enabled = false;
				TB_HardwareTriggerCount.Enabled = false;
			}

			if (CB_TriggerMask.SelectedIndex == 1) 
			{
				CB_HardwareTriggerEdge.Enabled = true;
				TB_HardwareTriggerCount.Enabled = true;
			}

			if (CB_TriggerMask.SelectedIndex == 2) 
			{
				CB_HardwareTriggerEdge.Enabled = false;
				TB_HardwareTriggerCount.Enabled = false;
			}
		}

		private void CB_TriggerMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (CB_TriggerMode.SelectedIndex == 1) 
				TB_NbrOfSeqForEachTrigger.Enabled = true;
			else
				TB_NbrOfSeqForEachTrigger.Enabled = false;
		}

		private void B_GetModuleInformation_Click(object sender, System.EventArgs e)
		{
			byte [] pb_ModuleType = new byte [200];
			UInt64 ul_NbrOfTransducerType = 0;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex = 0;
			Byte []pc_Name = new Byte[255];
			UInt64 ul_CalibrationStatus = 0;
			UInt64 ul_Type = 0;
			UInt64 ul_Frequency = 0;
			UInt64 ul_Impedance = 0;
			UInt64 ul_Cpt = 0;
			double d_Veff = 0.0;
			double d_Sensibility = 0.0;
			double d_Range = 0.0;
			
			MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "."+ TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";

			MX_370x.Url = MX_Global.Url;
		
			try
			{
				// Get the module type
				MX_Global.GetModuleType(out pb_ModuleType);
				L_MXModuleIdentifier.Text = enc.GetString(pb_ModuleType);
				NbrOfChannels = i_GetNbrOfTransducerChannel (enc.GetString(pb_ModuleType));
                if (NbrOfChannels <= 0)
                {
                    MessageBox.Show("Cannot find the number of transducer channels, assuming it is 16.");
                    NbrOfChannels = 16;
                }

				// Get the number of transducer type
				MX_370x.TransducerGetNbrOfType(out ul_NbrOfTransducerType);
				L_NbrOfTransducerType.Text = ul_NbrOfTransducerType.ToString();

				// Get the tranducer type information
				CB_TransducerType.Items.Clear();
				for (ul_Cpt = 0; ul_Cpt < ul_NbrOfTransducerType;ul_Cpt ++)
				{    
					MX_370x.TransducerGetTypeInformation (ul_Cpt,out ul_TransducerSelectionIndex,out pc_Name,out ul_CalibrationStatus,out ul_Type,out ul_Frequency,out ul_Impedance, out d_Veff, out d_Sensibility,out d_Range);
					CB_TransducerType.Items.Add (enc.GetString(pc_Name));
				}
				CB_TransducerType.SelectedIndex = 0;
				B_StartSequence.Enabled = true;
				B_StopSequence.Enabled = false;
				GB_TransducerSelectionBox.Enabled = true;
			}
			catch (Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}
		}

		private void CB_TransducerType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetTransducerTypeInfo();
		}

		private void CB_NbrOfChannels_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int i_Cpt;

			if (s_CB_Sequence != null) 
			{
				for (i_Cpt = 0; i_Cpt < (CB_NbrOfChannels.SelectedIndex + 1); i_Cpt ++)
					s_CB_Sequence[i_Cpt].Enabled = true;

				for (i_Cpt = (CB_NbrOfChannels.SelectedIndex + 1); i_Cpt < 16; i_Cpt ++)
					s_CB_Sequence[i_Cpt].Enabled = false;
            
			}
		}

		private void CB_DelayMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (CB_DelayMode.SelectedIndex != 0) 
			{
				CB_DelayTimeUnit.Enabled = true;
				TB_DelayValue.Enabled = true;
			}
			else
			{
				CB_DelayTimeUnit.Enabled = false;
				TB_DelayValue.Enabled = false;
			}
		}

		private DateTime ConvertFromTime_T(long time_t)
		{
			DateTime netTimeT;
			DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
			long tickTotal;

			tickTotal = dt70.Ticks + (time_t * 10000000);
			netTimeT = new DateTime(tickTotal);
			return (netTimeT);
		}

        private void CHB_DataFormatTimeStamp_CheckedChanged(object sender, EventArgs e)
        {
            if (CHB_DataFormatTimeStamp.Checked == true) CHB_DataFormatRelativeTimeStamp.Checked = false;
        }

        private void CHB_DataFormatRelativeTimeStamp_CheckedChanged(object sender, EventArgs e)
        {
            if (CHB_DataFormatRelativeTimeStamp.Checked == true) CHB_DataFormatTimeStamp.Checked = false;
        }

		private void B_StartSequence_Click(object sender, System.EventArgs e)
		{
			int     i_Cpt;
			int     i_Error;
			int     i_SysError;
			UInt64 ul_SelectedTransducer;
			MX370x.unsignedLong16FixedArray ChannelList = new MX370x.unsignedLong16FixedArray();
			UInt64 TriggerAction;
			UInt64 ByTriggerNbrOfSeqToAcquire;
            Thread ClientThread;


            TriggerAction              = 0;
            ByTriggerNbrOfSeqToAcquire = 0;
            ChannelList.ulValue        = new UInt64[16];

            /* Create the client stream */
            Client = new AddiData.ADDISocket.AsyncClientStream();

            // Get the data format
            DataFormat = (Convert.ToUInt64(CHB_DataFormatTimeStamp.Checked) & 1);
            DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatRelativeTimeStamp.Checked) & 1) << 4);
            DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatSequenceCounter.Checked) & 1) << 1);
            DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatAnalogValue.Checked) & 1) << 2);
            DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatInvertSign.Checked) & 1) << 3);

            // Get the stream size
            DataStreamNbrOfValues   = (int)CB_NbrOfChannels.SelectedIndex + 1; 
            Client.SingleFramesSize = DataStreamNbrOfValues;
            Client.SingleFramesSize = Client.SingleFramesSize + (Convert.ToInt32(CHB_DataFormatTimeStamp.Checked) * 2);
            Client.SingleFramesSize = Client.SingleFramesSize + (Convert.ToInt32(CHB_DataFormatRelativeTimeStamp.Checked) * 2);
            Client.SingleFramesSize = Client.SingleFramesSize + (Convert.ToInt32(CHB_DataFormatSequenceCounter.Checked) * 1);
            Client.SingleFramesSize = Client.SingleFramesSize * 4;
            Client.NbrOfFrames = Convert.ToInt32(TB_NbrMaxOfSeqToTransfer.Text.ToString(), 10);

            // Get the selected transducer
            ul_SelectedTransducer = GetTransducerTypeInfo();

            // Sequence channel initialisation
            for (i_Cpt = 0; i_Cpt <= CB_NbrOfChannels.SelectedIndex; i_Cpt++)
            {
                ChannelList.ulValue[i_Cpt] = Convert.ToUInt64(s_CB_Sequence[i_Cpt].SelectedIndex);
            }

            // Test if used hardware trigger
            if (CB_TriggerMask.SelectedIndex == 1)
            {
                // Get the trigger action
                TriggerAction = Convert.ToUInt64(CB_TriggerMode.SelectedIndex) + 1;


                //Get the trigger level selection
                TriggerAction = TriggerAction + ((Convert.ToUInt64(CB_HardwareTriggerEdge.SelectedIndex) + 1) << 6);
            }

            // Test if used synchro trigger
            if (CB_TriggerMask.SelectedIndex == 2)
            {
                // Get the trigger action
                TriggerAction = (Convert.ToUInt64(CB_TriggerMode.SelectedIndex) + 1) << 8;
            }


            // Test if sequence trigger used
            if ((CB_TriggerMode.SelectedIndex == 1) && (CB_TriggerMask.SelectedIndex != 0))
            {
                // Get the number of sequence
                ByTriggerNbrOfSeqToAcquire = Convert.ToUInt64(TB_NbrOfSeqForEachTrigger.Text);
            }

			try
			{
                // Open the socket connection to receive the data
                SocketClient = null;
                SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                SocketClient.ReceiveBufferSize = 1048576;
                SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989);

                // Start the read socket and the user thread
                Client.Start(SocketClient);
                ClientThread = new Thread(ClientThreadFct);
                DisplayText = "";
                DisplayOnlyLast = RB_DisplayLast.Checked;

				//Init and start the auto refresh acquisition
				i_Error = MX_370x.TransducerInitAndStartSequence(ul_SelectedTransducer, 
																 Convert.ToUInt64(CB_NbrOfChannels.SelectedItem),
                                                                 ChannelList, 
																 Convert.ToUInt64(CB_TimeDivision.SelectedIndex + 5), 
																 Convert.ToUInt64(TB_NbrOfSequence.Text), 
																 Convert.ToUInt64(TB_NbrMaxOfSeqToTransfer.Text), 
																 Convert.ToUInt64(CB_DelayMode.SelectedIndex), 
																 Convert.ToUInt64(CB_DelayTimeUnit.SelectedIndex), 
																 Convert.ToUInt64(TB_DelayValue.Text),
                                                                 TriggerAction, 
																 Convert.ToUInt64(TB_HardwareTriggerCount.Text), 
																 0,
                                                                 Convert.ToUInt64(ByTriggerNbrOfSeqToAcquire),
                                                                 DataFormat, 
																 0, 
																 0, 
																 0, 
																 out i_SysError);

				// Test if no error occur
				if (i_Error != 0) 
				{
                    MessageBox.Show("TransducerInitAndStartSequence Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    DisplayTimer.Enabled = true;
                    ClientThread.Priority = ThreadPriority.Lowest;
                    ClientThread.Start();
                    B_StopSequence.Enabled = true;
					B_StartSequence.Enabled = false;
					GB_SequenceConfig.Enabled = false;
					GB_Sequence.Enabled = false;
					GB_DataFormat.Enabled = false;
					GB_Trigger.Enabled = false;
					GB_Delay.Enabled = false;
					GB_ModuleSelectionBox.Enabled = false;
                    RB_DisplayLast.Enabled = false;
                    RB_DisplayAll.Enabled = false;
				}
			}
            catch (Exception ex)
            {
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (B_StopSequence.Enabled == false)
            {
                B_StopSequence_Click(sender, null);
            }
        }

		private void B_StopSequence_Click(object sender, System.EventArgs e)
		{
            int syserrno = 0;
            int Error    = 0;

            DisplayTimer.Enabled = false;

            // Test if socket open
            if (SocketClient != null)
            {
                if (Client != null)
                    Client.Stoop();

                try
                {
                    // Close the socket connection
                    SocketClient.Shutdown(SocketShutdown.Both);
                    SocketClient.Close();
                    SocketClient = null;
                    System.GC.Collect();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            if (B_StopSequence.Enabled == true)
            {
                try
                {
    				Error = MX_370x.TransducerStopAndReleaseSequence(out syserrno);

	    			if (Error != 0) 
		    		{
			    		MessageBox.Show("TransducerStopAndReleaseSequence Error : " + Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				    }
			    }
			    catch (Exception ex)
			    {
				    MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			    }
            }

	        B_StartSequence.Enabled = true;
		    B_StopSequence.Enabled = false;
			GB_SequenceConfig.Enabled = true;
			GB_Sequence.Enabled = true;
			GB_DataFormat.Enabled = true;
			GB_Trigger.Enabled = true;
			GB_Delay.Enabled = true;
			GB_ModuleSelectionBox.Enabled = true;
            RB_DisplayLast.Enabled = true;
            RB_DisplayAll.Enabled = true;
        }

        private void ClientThreadFct()
        {
            byte[] SocketData;
            int StreamCounter = 0;
            int OutStringIndex = 0;
            int Offset = 0;
            int StartStreamCounter = 0;
            int   Counter = 0;
            ulong Value = 0;
            ulong SeqCounter = 0;
            ulong TimeStampLow = 0;
            ulong TimeStampHigh = 0;
            ulong TimeStampLowmus = 0;
            ulong TimeStampLowms = 0;
            Single sValue = 0;
            String[] sOutString;



            if (DisplayOnlyLast == true)
            {
                StartStreamCounter = Client.NbrOfFrames - 1;
                sOutString = new String[1];
            }
            else
            {
                StartStreamCounter = 0;
                sOutString = new String[Client.NbrOfFrames];
            }

            while ((SocketData = Client.ReadData()) != null)
            {

                for (StreamCounter = StartStreamCounter, OutStringIndex = 0; StreamCounter < Client.NbrOfFrames; StreamCounter++, OutStringIndex++)
                {
                    Offset = StreamCounter * Client.SingleFramesSize;
                    sOutString[OutStringIndex] = "";

                    // Test if time stamp
                    if (((DataFormat & 1) == 1) || ((DataFormat & 0x10) == 0x10))
                    {
                        TimeStampHigh = BitConverter.ToUInt32(SocketData, (int)(Offset + 0));
                        TimeStampLow = BitConverter.ToUInt32(SocketData, (int)(Offset + 4));
                        TimeStampLowms = (ulong)(TimeStampLow / 1000);
                        TimeStampLowmus = (ulong)(TimeStampLow % 1000);
                        sOutString[OutStringIndex] = "Time stamp: " + ConvertFromTime_T((long)TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3") + " ";
                        Offset = Offset + 8;
                    }

                    // Test if sequence counter
                    if ((DataFormat & 2) == 2)
                    {
                        SeqCounter = BitConverter.ToUInt32(SocketData, (int)(Offset + 0));
                        sOutString[OutStringIndex] = sOutString[OutStringIndex] + "Seq counter: " + SeqCounter.ToString() +  " ";
                        Offset = Offset + 4;
                    }

                    // Test if mm value
                    if ((DataFormat & 4) == 4)
                    {
                        sOutString[OutStringIndex] = sOutString[OutStringIndex] + "Channel mm value(s) :";
                        for (Counter = 0; Counter < DataStreamNbrOfValues; Counter++)
                        {
                            sValue = BitConverter.ToSingle(SocketData, Offset + (int)(Counter * 4));
                            sOutString[OutStringIndex] = sOutString[OutStringIndex] + " " + sValue.ToString("F4") + " ";
                        }
                    }
                    else
                    {
                        sOutString[OutStringIndex] = sOutString[OutStringIndex] + "Channel Hex value(s) :";
                        for (Counter = 0; Counter < DataStreamNbrOfValues; Counter++)
                        {
                            Value = BitConverter.ToUInt32(SocketData, Offset + (int)(Counter * 4));
                            sOutString[OutStringIndex] = sOutString[OutStringIndex] + " " + Value.ToString("X");
                        }
                    }

                    sOutString[OutStringIndex] = sOutString[OutStringIndex] + Environment.NewLine;
                }

                if (DisplayOnlyLast == true)
                {
                    DisplayText = String.Concat(sOutString);
                }
                else
                {
                    DisplayText += String.Concat(sOutString);
                }
            }
        }

        private void DisplayTimer_Tick(object sender, System.EventArgs e)
		{
            TB_Values.Text = DisplayText;
		}

        private void F_Sequence_FormClosed(object sender, FormClosedEventArgs e)
        {
            B_StopSequence_Click(sender, null);
        }
	}
}
