using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDIControls;
using AddiData.ADDISocket;
using AddiData;
using System.Text.RegularExpressions;


namespace AutoRefresh
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_AutoRefresh : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.GroupBox GB_Frequency;
		internal System.Windows.Forms.ComboBox CB_TimeDivision;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.GroupBox GB_Average;
		internal System.Windows.Forms.TextBox TB_AverageValue;
		internal System.Windows.Forms.ComboBox CB_AverageMode;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Button B_StopAutoRefresh;
		internal System.Windows.Forms.Button B_StartAutoRefresh;
        internal System.Windows.Forms.TextBox Display;
		internal System.Windows.Forms.GroupBox GB_DataFormat;
		internal System.Windows.Forms.CheckBox CHB_DataFormatInvertSign;
		internal System.Windows.Forms.CheckBox CHB_DataFormatAnalogValue;
		internal System.Windows.Forms.CheckBox CHB_DataFormatTimeStamp;
		internal System.Windows.Forms.GroupBox GB_Trigger;
		internal System.Windows.Forms.TextBox TB_NbrOfSeqForEachTrigger;
		internal System.Windows.Forms.Label label12;
		internal System.Windows.Forms.ComboBox CB_TriggerMode;
		internal System.Windows.Forms.Label label10;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.ComboBox CB_TriggerMask;
		internal System.Windows.Forms.TextBox TB_HardwareTriggerCount;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.ComboBox CB_HardwareTriggerEdge;
		private System.Windows.Forms.GroupBox GB_AutoRefreshConfig;
		internal System.Windows.Forms.CheckBox CHB_Channel15;
		internal System.Windows.Forms.CheckBox CHB_Channel14;
		internal System.Windows.Forms.CheckBox CHB_Channel13;
		internal System.Windows.Forms.CheckBox CHB_Channel12;
		internal System.Windows.Forms.CheckBox CHB_Channel11;
		internal System.Windows.Forms.CheckBox CHB_Channel10;
		internal System.Windows.Forms.CheckBox CHB_Channel9;
		internal System.Windows.Forms.CheckBox CHB_Channel8;
		internal System.Windows.Forms.CheckBox CHB_Channel7;
		internal System.Windows.Forms.CheckBox CHB_Channel6;
		internal System.Windows.Forms.CheckBox CHB_Channel5;
		internal System.Windows.Forms.CheckBox CHB_Channel4;
		internal System.Windows.Forms.CheckBox CHB_Channel3;
		internal System.Windows.Forms.CheckBox CHB_Channel2;
		internal System.Windows.Forms.CheckBox CHB_Channel1;
		internal System.Windows.Forms.CheckBox CHB_Channel0;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.GroupBox GB_ModuleSelectionBox;
		internal System.Windows.Forms.Button B_GetModuleInformation;
		internal System.Windows.Forms.Label L_MXModuleIdentifier;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		internal System.Windows.Forms.Label label3;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.TextBox TB_IPAddress_3;
		internal System.Windows.Forms.TextBox TB_IPAddress_2;
		internal System.Windows.Forms.TextBox TB_IPAddress_1;
		internal System.Windows.Forms.TextBox TB_IPAddress_0;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.GroupBox GB_TransducerSelectionBox;
		internal System.Windows.Forms.TextBox TB_TransducerTypeInfo;
		private System.Windows.Forms.Label label7;
		internal System.Windows.Forms.Label L_NbrOfTransducerType;
		internal System.Windows.Forms.Label label6;
		internal System.Windows.Forms.ComboBox CB_TransducerType;
		private System.Windows.Forms.Timer DisplayTimer;
        private GroupBox GB_AcquisitionMode;
        private RadioButton RB_DataServer;
        private RadioButton RB_SOAP;
        private System.Windows.Forms.Timer ReadTimer;
        private Label L_Info;
		private System.ComponentModel.IContainer components;

		public F_AutoRefresh()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_AutoRefresh));
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.GB_Frequency = new System.Windows.Forms.GroupBox();
            this.CB_TimeDivision = new System.Windows.Forms.ComboBox();
            this.Label19 = new System.Windows.Forms.Label();
            this.GB_Average = new System.Windows.Forms.GroupBox();
            this.TB_AverageValue = new System.Windows.Forms.TextBox();
            this.CB_AverageMode = new System.Windows.Forms.ComboBox();
            this.Label20 = new System.Windows.Forms.Label();
            this.Label21 = new System.Windows.Forms.Label();
            this.B_StopAutoRefresh = new System.Windows.Forms.Button();
            this.B_StartAutoRefresh = new System.Windows.Forms.Button();
            this.Display = new System.Windows.Forms.TextBox();
            this.GB_DataFormat = new System.Windows.Forms.GroupBox();
            this.CHB_DataFormatInvertSign = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatAnalogValue = new System.Windows.Forms.CheckBox();
            this.CHB_DataFormatTimeStamp = new System.Windows.Forms.CheckBox();
            this.GB_Trigger = new System.Windows.Forms.GroupBox();
            this.TB_NbrOfSeqForEachTrigger = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.CB_TriggerMode = new System.Windows.Forms.ComboBox();
            this.label10 = new System.Windows.Forms.Label();
            this.Label11 = new System.Windows.Forms.Label();
            this.CB_TriggerMask = new System.Windows.Forms.ComboBox();
            this.TB_HardwareTriggerCount = new System.Windows.Forms.TextBox();
            this.Label15 = new System.Windows.Forms.Label();
            this.Label16 = new System.Windows.Forms.Label();
            this.CB_HardwareTriggerEdge = new System.Windows.Forms.ComboBox();
            this.GB_AutoRefreshConfig = new System.Windows.Forms.GroupBox();
            this.CHB_Channel15 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel14 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel13 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel12 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel11 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel10 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel9 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel8 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel7 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel6 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel5 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel4 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel3 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel2 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel1 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel0 = new System.Windows.Forms.CheckBox();
            this.Label9 = new System.Windows.Forms.Label();
            this.GB_ModuleSelectionBox = new System.Windows.Forms.GroupBox();
            this.B_GetModuleInformation = new System.Windows.Forms.Button();
            this.L_MXModuleIdentifier = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_TransducerSelectionBox = new System.Windows.Forms.GroupBox();
            this.TB_TransducerTypeInfo = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.L_NbrOfTransducerType = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_TransducerType = new System.Windows.Forms.ComboBox();
            this.GB_AcquisitionMode = new System.Windows.Forms.GroupBox();
            this.RB_DataServer = new System.Windows.Forms.RadioButton();
            this.RB_SOAP = new System.Windows.Forms.RadioButton();
            this.ReadTimer = new System.Windows.Forms.Timer(this.components);
            this.L_Info = new System.Windows.Forms.Label();
            this.GB_Frequency.SuspendLayout();
            this.GB_Average.SuspendLayout();
            this.GB_DataFormat.SuspendLayout();
            this.GB_Trigger.SuspendLayout();
            this.GB_AutoRefreshConfig.SuspendLayout();
            this.GB_ModuleSelectionBox.SuspendLayout();
            this.GB_TransducerSelectionBox.SuspendLayout();
            this.GB_AcquisitionMode.SuspendLayout();
            this.SuspendLayout();
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // GB_Frequency
            // 
            this.GB_Frequency.Controls.Add(this.CB_TimeDivision);
            this.GB_Frequency.Controls.Add(this.Label19);
            this.GB_Frequency.Location = new System.Drawing.Point(600, 304);
            this.GB_Frequency.Name = "GB_Frequency";
            this.GB_Frequency.Size = new System.Drawing.Size(304, 56);
            this.GB_Frequency.TabIndex = 156;
            this.GB_Frequency.TabStop = false;
            this.GB_Frequency.Text = "Frequency time division configuration";
            // 
            // CB_TimeDivision
            // 
            this.CB_TimeDivision.Items.AddRange(new object[] {
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16",
            "17",
            "18",
            "19",
            "20",
            "21",
            "22",
            "23",
            "24",
            "25",
            "26",
            "27",
            "28",
            "29",
            "30",
            "31",
            "32",
            "33",
            "34",
            "35",
            "36",
            "37",
            "38",
            "39",
            "40",
            "41",
            "42",
            "43",
            "44",
            "45",
            "46",
            "47",
            "48",
            "49",
            "50",
            "51",
            "52",
            "53",
            "54",
            "55",
            "56",
            "57",
            "58",
            "59",
            "60",
            "61",
            "62",
            "63",
            "64",
            "65",
            "66",
            "67",
            "68",
            "69",
            "70",
            "71",
            "72",
            "73",
            "74",
            "75",
            "76",
            "77",
            "78",
            "79",
            "80",
            "81",
            "82",
            "83",
            "84",
            "85",
            "86",
            "87",
            "88",
            "89",
            "90",
            "91",
            "92",
            "93",
            "94",
            "95",
            "96",
            "97",
            "98",
            "99",
            "100",
            "101",
            "102",
            "103",
            "104",
            "105",
            "106",
            "107",
            "108",
            "109",
            "110",
            "111",
            "112",
            "113",
            "114",
            "115",
            "116",
            "117",
            "118",
            "119",
            "120",
            "121",
            "122",
            "123",
            "124",
            "125",
            "126",
            "127",
            "128",
            "129",
            "130",
            "131",
            "132",
            "133",
            "134",
            "135",
            "136",
            "137",
            "138",
            "139",
            "140",
            "141",
            "142",
            "143",
            "144",
            "145",
            "146",
            "147",
            "148",
            "149",
            "150",
            "151",
            "152",
            "153",
            "154",
            "155",
            "156",
            "157",
            "158",
            "159",
            "160",
            "161",
            "162",
            "163",
            "164",
            "165",
            "166",
            "167",
            "168",
            "169",
            "170",
            "171",
            "172",
            "173",
            "174",
            "175",
            "176",
            "177",
            "178",
            "179",
            "180",
            "181",
            "182",
            "183",
            "184",
            "185",
            "186",
            "187",
            "188",
            "189",
            "190",
            "191",
            "192",
            "193",
            "194",
            "195",
            "196",
            "197",
            "198",
            "199",
            "200",
            "201",
            "202",
            "203",
            "204",
            "205",
            "206",
            "207",
            "208",
            "209",
            "210",
            "211",
            "212",
            "213",
            "214",
            "215",
            "216",
            "217",
            "218",
            "219",
            "220",
            "221",
            "222",
            "223",
            "224",
            "225",
            "226",
            "227",
            "228",
            "229",
            "230",
            "231",
            "232",
            "233",
            "234",
            "235",
            "236",
            "237",
            "238",
            "239",
            "240",
            "241",
            "242",
            "243",
            "244",
            "245",
            "246",
            "247",
            "248",
            "249",
            "250",
            "251",
            "252",
            "253",
            "254",
            "255"});
            this.CB_TimeDivision.Location = new System.Drawing.Point(240, 24);
            this.CB_TimeDivision.Name = "CB_TimeDivision";
            this.CB_TimeDivision.Size = new System.Drawing.Size(48, 21);
            this.CB_TimeDivision.TabIndex = 147;
            this.CB_TimeDivision.Text = "15";
            // 
            // Label19
            // 
            this.Label19.Location = new System.Drawing.Point(13, 29);
            this.Label19.Name = "Label19";
            this.Label19.Size = new System.Drawing.Size(224, 16);
            this.Label19.TabIndex = 146;
            this.Label19.Text = "Frequency time division factor (minimal 5) :";
            // 
            // GB_Average
            // 
            this.GB_Average.Controls.Add(this.TB_AverageValue);
            this.GB_Average.Controls.Add(this.CB_AverageMode);
            this.GB_Average.Controls.Add(this.Label20);
            this.GB_Average.Controls.Add(this.Label21);
            this.GB_Average.Location = new System.Drawing.Point(16, 304);
            this.GB_Average.Name = "GB_Average";
            this.GB_Average.Size = new System.Drawing.Size(272, 112);
            this.GB_Average.TabIndex = 155;
            this.GB_Average.TabStop = false;
            this.GB_Average.Text = "Average configuration";
            // 
            // TB_AverageValue
            // 
            this.TB_AverageValue.Enabled = false;
            this.TB_AverageValue.Location = new System.Drawing.Point(128, 56);
            this.TB_AverageValue.Name = "TB_AverageValue";
            this.TB_AverageValue.Size = new System.Drawing.Size(104, 20);
            this.TB_AverageValue.TabIndex = 18;
            this.TB_AverageValue.Text = "1";
            // 
            // CB_AverageMode
            // 
            this.CB_AverageMode.Items.AddRange(new object[] {
            "No average",
            "per sequence",
            "per channel"});
            this.CB_AverageMode.Location = new System.Drawing.Point(128, 32);
            this.CB_AverageMode.Name = "CB_AverageMode";
            this.CB_AverageMode.Size = new System.Drawing.Size(104, 21);
            this.CB_AverageMode.TabIndex = 12;
            this.CB_AverageMode.Text = "No average";
            this.CB_AverageMode.SelectedIndexChanged += new System.EventHandler(this.CB_AverageMode_SelectedIndexChanged);
            // 
            // Label20
            // 
            this.Label20.Location = new System.Drawing.Point(32, 64);
            this.Label20.Name = "Label20";
            this.Label20.Size = new System.Drawing.Size(88, 16);
            this.Label20.TabIndex = 11;
            this.Label20.Text = "Average value :";
            // 
            // Label21
            // 
            this.Label21.Location = new System.Drawing.Point(32, 40);
            this.Label21.Name = "Label21";
            this.Label21.Size = new System.Drawing.Size(88, 16);
            this.Label21.TabIndex = 10;
            this.Label21.Text = "Average mode :";
            // 
            // B_StopAutoRefresh
            // 
            this.B_StopAutoRefresh.Enabled = false;
            this.B_StopAutoRefresh.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StopAutoRefresh.Location = new System.Drawing.Point(600, 504);
            this.B_StopAutoRefresh.Name = "B_StopAutoRefresh";
            this.B_StopAutoRefresh.Size = new System.Drawing.Size(304, 32);
            this.B_StopAutoRefresh.TabIndex = 154;
            this.B_StopAutoRefresh.Text = "Stop auto refresh";
            this.B_StopAutoRefresh.Click += new System.EventHandler(this.B_StopAutoRefresh_Click);
            // 
            // B_StartAutoRefresh
            // 
            this.B_StartAutoRefresh.Enabled = false;
            this.B_StartAutoRefresh.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StartAutoRefresh.Location = new System.Drawing.Point(600, 464);
            this.B_StartAutoRefresh.Name = "B_StartAutoRefresh";
            this.B_StartAutoRefresh.Size = new System.Drawing.Size(304, 32);
            this.B_StartAutoRefresh.TabIndex = 153;
            this.B_StartAutoRefresh.Text = "Start auto refresh";
            this.B_StartAutoRefresh.Click += new System.EventHandler(this.B_StartAutoRefresh_Click);
            // 
            // Display
            // 
            this.Display.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Display.Location = new System.Drawing.Point(16, 552);
            this.Display.Multiline = true;
            this.Display.Name = "Display";
            this.Display.ReadOnly = true;
            this.Display.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.Display.Size = new System.Drawing.Size(888, 144);
            this.Display.TabIndex = 152;
            // 
            // GB_DataFormat
            // 
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatInvertSign);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatAnalogValue);
            this.GB_DataFormat.Controls.Add(this.CHB_DataFormatTimeStamp);
            this.GB_DataFormat.Enabled = false;
            this.GB_DataFormat.Location = new System.Drawing.Point(16, 416);
            this.GB_DataFormat.Name = "GB_DataFormat";
            this.GB_DataFormat.Size = new System.Drawing.Size(272, 120);
            this.GB_DataFormat.TabIndex = 151;
            this.GB_DataFormat.TabStop = false;
            this.GB_DataFormat.Text = "Data format";
            // 
            // CHB_DataFormatInvertSign
            // 
            this.CHB_DataFormatInvertSign.Location = new System.Drawing.Point(64, 80);
            this.CHB_DataFormatInvertSign.Name = "CHB_DataFormatInvertSign";
            this.CHB_DataFormatInvertSign.Size = new System.Drawing.Size(144, 24);
            this.CHB_DataFormatInvertSign.TabIndex = 3;
            this.CHB_DataFormatInvertSign.Text = "Invert the value sign";
            // 
            // CHB_DataFormatAnalogValue
            // 
            this.CHB_DataFormatAnalogValue.Location = new System.Drawing.Point(64, 56);
            this.CHB_DataFormatAnalogValue.Name = "CHB_DataFormatAnalogValue";
            this.CHB_DataFormatAnalogValue.Size = new System.Drawing.Size(144, 24);
            this.CHB_DataFormatAnalogValue.TabIndex = 1;
            this.CHB_DataFormatAnalogValue.Text = "Convert in metric value";
            // 
            // CHB_DataFormatTimeStamp
            // 
            this.CHB_DataFormatTimeStamp.Location = new System.Drawing.Point(64, 32);
            this.CHB_DataFormatTimeStamp.Name = "CHB_DataFormatTimeStamp";
            this.CHB_DataFormatTimeStamp.Size = new System.Drawing.Size(104, 24);
            this.CHB_DataFormatTimeStamp.TabIndex = 0;
            this.CHB_DataFormatTimeStamp.Text = "With time stamp";
            // 
            // GB_Trigger
            // 
            this.GB_Trigger.Controls.Add(this.TB_NbrOfSeqForEachTrigger);
            this.GB_Trigger.Controls.Add(this.label12);
            this.GB_Trigger.Controls.Add(this.CB_TriggerMode);
            this.GB_Trigger.Controls.Add(this.label10);
            this.GB_Trigger.Controls.Add(this.Label11);
            this.GB_Trigger.Controls.Add(this.CB_TriggerMask);
            this.GB_Trigger.Controls.Add(this.TB_HardwareTriggerCount);
            this.GB_Trigger.Controls.Add(this.Label15);
            this.GB_Trigger.Controls.Add(this.Label16);
            this.GB_Trigger.Controls.Add(this.CB_HardwareTriggerEdge);
            this.GB_Trigger.Location = new System.Drawing.Point(296, 304);
            this.GB_Trigger.Name = "GB_Trigger";
            this.GB_Trigger.Size = new System.Drawing.Size(296, 232);
            this.GB_Trigger.TabIndex = 150;
            this.GB_Trigger.TabStop = false;
            this.GB_Trigger.Text = "Trigger configuration";
            // 
            // TB_NbrOfSeqForEachTrigger
            // 
            this.TB_NbrOfSeqForEachTrigger.Enabled = false;
            this.TB_NbrOfSeqForEachTrigger.Location = new System.Drawing.Point(184, 184);
            this.TB_NbrOfSeqForEachTrigger.Name = "TB_NbrOfSeqForEachTrigger";
            this.TB_NbrOfSeqForEachTrigger.Size = new System.Drawing.Size(80, 20);
            this.TB_NbrOfSeqForEachTrigger.TabIndex = 17;
            this.TB_NbrOfSeqForEachTrigger.Text = "1";
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(32, 176);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(128, 24);
            this.label12.TabIndex = 16;
            this.label12.Text = "Nbr of sequence to acquire for each trigger :";
            // 
            // CB_TriggerMode
            // 
            this.CB_TriggerMode.Enabled = false;
            this.CB_TriggerMode.Items.AddRange(new object[] {
            "Single shot",
            "Sequence"});
            this.CB_TriggerMode.Location = new System.Drawing.Point(184, 136);
            this.CB_TriggerMode.Name = "CB_TriggerMode";
            this.CB_TriggerMode.Size = new System.Drawing.Size(80, 21);
            this.CB_TriggerMode.TabIndex = 15;
            this.CB_TriggerMode.Text = "Single shot";
            this.CB_TriggerMode.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerMode_SelectedIndexChanged);
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(32, 144);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(128, 16);
            this.label10.TabIndex = 14;
            this.label10.Text = "Trigger mode :";
            // 
            // Label11
            // 
            this.Label11.Location = new System.Drawing.Point(32, 24);
            this.Label11.Name = "Label11";
            this.Label11.Size = new System.Drawing.Size(80, 18);
            this.Label11.TabIndex = 7;
            this.Label11.Text = "Trigger mask :";
            // 
            // CB_TriggerMask
            // 
            this.CB_TriggerMask.Items.AddRange(new object[] {
            "No trigger",
            "Digital input trigger",
            "Synchro trigger"});
            this.CB_TriggerMask.Location = new System.Drawing.Point(112, 16);
            this.CB_TriggerMask.Name = "CB_TriggerMask";
            this.CB_TriggerMask.Size = new System.Drawing.Size(152, 21);
            this.CB_TriggerMask.TabIndex = 6;
            this.CB_TriggerMask.Text = "No trigger";
            this.CB_TriggerMask.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerMask_SelectedIndexChanged);
            // 
            // TB_HardwareTriggerCount
            // 
            this.TB_HardwareTriggerCount.Enabled = false;
            this.TB_HardwareTriggerCount.Location = new System.Drawing.Point(184, 96);
            this.TB_HardwareTriggerCount.Name = "TB_HardwareTriggerCount";
            this.TB_HardwareTriggerCount.Size = new System.Drawing.Size(80, 20);
            this.TB_HardwareTriggerCount.TabIndex = 11;
            this.TB_HardwareTriggerCount.Text = "1";
            // 
            // Label15
            // 
            this.Label15.Location = new System.Drawing.Point(32, 96);
            this.Label15.Name = "Label15";
            this.Label15.Size = new System.Drawing.Size(128, 16);
            this.Label15.TabIndex = 10;
            this.Label15.Text = "Hardware trigger Count :";
            // 
            // Label16
            // 
            this.Label16.Location = new System.Drawing.Point(32, 64);
            this.Label16.Name = "Label16";
            this.Label16.Size = new System.Drawing.Size(128, 16);
            this.Label16.TabIndex = 9;
            this.Label16.Text = "Hardware trigger edge :";
            // 
            // CB_HardwareTriggerEdge
            // 
            this.CB_HardwareTriggerEdge.Enabled = false;
            this.CB_HardwareTriggerEdge.Items.AddRange(new object[] {
            "Rising edge",
            "Falling edge",
            "Both edge"});
            this.CB_HardwareTriggerEdge.Location = new System.Drawing.Point(184, 56);
            this.CB_HardwareTriggerEdge.Name = "CB_HardwareTriggerEdge";
            this.CB_HardwareTriggerEdge.Size = new System.Drawing.Size(80, 21);
            this.CB_HardwareTriggerEdge.TabIndex = 8;
            this.CB_HardwareTriggerEdge.Text = "Rising edge";
            // 
            // GB_AutoRefreshConfig
            // 
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel15);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel14);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel13);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel12);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel11);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel10);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel9);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel8);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel7);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel6);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel5);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel4);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel3);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel2);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel1);
            this.GB_AutoRefreshConfig.Controls.Add(this.CHB_Channel0);
            this.GB_AutoRefreshConfig.Controls.Add(this.Label9);
            this.GB_AutoRefreshConfig.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_AutoRefreshConfig.Location = new System.Drawing.Point(16, 224);
            this.GB_AutoRefreshConfig.Name = "GB_AutoRefreshConfig";
            this.GB_AutoRefreshConfig.Size = new System.Drawing.Size(888, 72);
            this.GB_AutoRefreshConfig.TabIndex = 149;
            this.GB_AutoRefreshConfig.TabStop = false;
            this.GB_AutoRefreshConfig.Text = "Auto refresh configuration";
            // 
            // CHB_Channel15
            // 
            this.CHB_Channel15.Location = new System.Drawing.Point(824, 32);
            this.CHB_Channel15.Name = "CHB_Channel15";
            this.CHB_Channel15.Size = new System.Drawing.Size(56, 24);
            this.CHB_Channel15.TabIndex = 159;
            this.CHB_Channel15.Text = "Ch 16";
            // 
            // CHB_Channel14
            // 
            this.CHB_Channel14.Location = new System.Drawing.Point(776, 32);
            this.CHB_Channel14.Name = "CHB_Channel14";
            this.CHB_Channel14.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel14.TabIndex = 158;
            this.CHB_Channel14.Text = "Ch 15";
            // 
            // CHB_Channel13
            // 
            this.CHB_Channel13.Location = new System.Drawing.Point(728, 32);
            this.CHB_Channel13.Name = "CHB_Channel13";
            this.CHB_Channel13.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel13.TabIndex = 157;
            this.CHB_Channel13.Text = "Ch 14";
            // 
            // CHB_Channel12
            // 
            this.CHB_Channel12.Location = new System.Drawing.Point(680, 32);
            this.CHB_Channel12.Name = "CHB_Channel12";
            this.CHB_Channel12.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel12.TabIndex = 156;
            this.CHB_Channel12.Text = "Ch 13";
            // 
            // CHB_Channel11
            // 
            this.CHB_Channel11.Location = new System.Drawing.Point(632, 32);
            this.CHB_Channel11.Name = "CHB_Channel11";
            this.CHB_Channel11.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel11.TabIndex = 155;
            this.CHB_Channel11.Text = "Ch 12";
            // 
            // CHB_Channel10
            // 
            this.CHB_Channel10.Location = new System.Drawing.Point(584, 32);
            this.CHB_Channel10.Name = "CHB_Channel10";
            this.CHB_Channel10.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel10.TabIndex = 154;
            this.CHB_Channel10.Text = "Ch 11";
            // 
            // CHB_Channel9
            // 
            this.CHB_Channel9.Location = new System.Drawing.Point(536, 32);
            this.CHB_Channel9.Name = "CHB_Channel9";
            this.CHB_Channel9.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel9.TabIndex = 153;
            this.CHB_Channel9.Text = "Ch 10";
            // 
            // CHB_Channel8
            // 
            this.CHB_Channel8.Location = new System.Drawing.Point(488, 32);
            this.CHB_Channel8.Name = "CHB_Channel8";
            this.CHB_Channel8.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel8.TabIndex = 152;
            this.CHB_Channel8.Text = "Ch 9";
            // 
            // CHB_Channel7
            // 
            this.CHB_Channel7.Location = new System.Drawing.Point(440, 32);
            this.CHB_Channel7.Name = "CHB_Channel7";
            this.CHB_Channel7.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel7.TabIndex = 151;
            this.CHB_Channel7.Text = "Ch 8";
            // 
            // CHB_Channel6
            // 
            this.CHB_Channel6.Location = new System.Drawing.Point(392, 32);
            this.CHB_Channel6.Name = "CHB_Channel6";
            this.CHB_Channel6.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel6.TabIndex = 150;
            this.CHB_Channel6.Text = "Ch 7";
            // 
            // CHB_Channel5
            // 
            this.CHB_Channel5.Location = new System.Drawing.Point(344, 32);
            this.CHB_Channel5.Name = "CHB_Channel5";
            this.CHB_Channel5.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel5.TabIndex = 149;
            this.CHB_Channel5.Text = "Ch 6";
            // 
            // CHB_Channel4
            // 
            this.CHB_Channel4.Location = new System.Drawing.Point(296, 32);
            this.CHB_Channel4.Name = "CHB_Channel4";
            this.CHB_Channel4.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel4.TabIndex = 148;
            this.CHB_Channel4.Text = "Ch 5";
            // 
            // CHB_Channel3
            // 
            this.CHB_Channel3.Location = new System.Drawing.Point(248, 32);
            this.CHB_Channel3.Name = "CHB_Channel3";
            this.CHB_Channel3.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel3.TabIndex = 147;
            this.CHB_Channel3.Text = "Ch 4";
            // 
            // CHB_Channel2
            // 
            this.CHB_Channel2.Location = new System.Drawing.Point(200, 32);
            this.CHB_Channel2.Name = "CHB_Channel2";
            this.CHB_Channel2.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel2.TabIndex = 146;
            this.CHB_Channel2.Text = "Ch 3";
            // 
            // CHB_Channel1
            // 
            this.CHB_Channel1.Location = new System.Drawing.Point(152, 32);
            this.CHB_Channel1.Name = "CHB_Channel1";
            this.CHB_Channel1.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel1.TabIndex = 145;
            this.CHB_Channel1.Text = "Ch 2";
            // 
            // CHB_Channel0
            // 
            this.CHB_Channel0.Checked = true;
            this.CHB_Channel0.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CHB_Channel0.Location = new System.Drawing.Point(104, 32);
            this.CHB_Channel0.Name = "CHB_Channel0";
            this.CHB_Channel0.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel0.TabIndex = 144;
            this.CHB_Channel0.Text = "Ch 1";
            // 
            // Label9
            // 
            this.Label9.Location = new System.Drawing.Point(8, 36);
            this.Label9.Name = "Label9";
            this.Label9.Size = new System.Drawing.Size(104, 20);
            this.Label9.TabIndex = 123;
            this.Label9.Text = "Channel selection:";
            // 
            // GB_ModuleSelectionBox
            // 
            this.GB_ModuleSelectionBox.Controls.Add(this.B_GetModuleInformation);
            this.GB_ModuleSelectionBox.Controls.Add(this.L_MXModuleIdentifier);
            this.GB_ModuleSelectionBox.Controls.Add(this.label5);
            this.GB_ModuleSelectionBox.Controls.Add(this.label4);
            this.GB_ModuleSelectionBox.Controls.Add(this.label3);
            this.GB_ModuleSelectionBox.Controls.Add(this.label2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleSelectionBox.Controls.Add(this.label1);
            this.GB_ModuleSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_ModuleSelectionBox.Location = new System.Drawing.Point(16, 8);
            this.GB_ModuleSelectionBox.Name = "GB_ModuleSelectionBox";
            this.GB_ModuleSelectionBox.Size = new System.Drawing.Size(512, 208);
            this.GB_ModuleSelectionBox.TabIndex = 148;
            this.GB_ModuleSelectionBox.TabStop = false;
            this.GB_ModuleSelectionBox.Text = "Module selection";
            // 
            // B_GetModuleInformation
            // 
            this.B_GetModuleInformation.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_GetModuleInformation.Location = new System.Drawing.Point(384, 24);
            this.B_GetModuleInformation.Name = "B_GetModuleInformation";
            this.B_GetModuleInformation.Size = new System.Drawing.Size(112, 33);
            this.B_GetModuleInformation.TabIndex = 43;
            this.B_GetModuleInformation.Text = "&Connection to module";
            this.B_GetModuleInformation.Click += new System.EventHandler(this.B_GetModuleInformation_Click);
            // 
            // L_MXModuleIdentifier
            // 
            this.L_MXModuleIdentifier.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_MXModuleIdentifier.Location = new System.Drawing.Point(176, 72);
            this.L_MXModuleIdentifier.Name = "L_MXModuleIdentifier";
            this.L_MXModuleIdentifier.Size = new System.Drawing.Size(320, 120);
            this.L_MXModuleIdentifier.TabIndex = 42;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(132, 23);
            this.label5.TabIndex = 41;
            this.label5.Text = "MX Module Identifier :";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(328, 32);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 40;
            this.label4.Text = "-";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(272, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(216, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 38;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_3.Location = new System.Drawing.Point(336, 32);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_3.TabIndex = 37;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_2.Location = new System.Drawing.Point(288, 32);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_2.TabIndex = 36;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_1.Location = new System.Drawing.Point(232, 32);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_1.TabIndex = 35;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(176, 32);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_0.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 32);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(160, 16);
            this.label1.TabIndex = 33;
            this.label1.Text = "IP Address of the MX Module :";
            // 
            // GB_TransducerSelectionBox
            // 
            this.GB_TransducerSelectionBox.Controls.Add(this.TB_TransducerTypeInfo);
            this.GB_TransducerSelectionBox.Controls.Add(this.label7);
            this.GB_TransducerSelectionBox.Controls.Add(this.L_NbrOfTransducerType);
            this.GB_TransducerSelectionBox.Controls.Add(this.label6);
            this.GB_TransducerSelectionBox.Controls.Add(this.CB_TransducerType);
            this.GB_TransducerSelectionBox.Enabled = false;
            this.GB_TransducerSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_TransducerSelectionBox.Location = new System.Drawing.Point(536, 8);
            this.GB_TransducerSelectionBox.Name = "GB_TransducerSelectionBox";
            this.GB_TransducerSelectionBox.Size = new System.Drawing.Size(368, 208);
            this.GB_TransducerSelectionBox.TabIndex = 147;
            this.GB_TransducerSelectionBox.TabStop = false;
            this.GB_TransducerSelectionBox.Text = "Module transducer type selection";
            // 
            // TB_TransducerTypeInfo
            // 
            this.TB_TransducerTypeInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.TB_TransducerTypeInfo.Location = new System.Drawing.Point(16, 80);
            this.TB_TransducerTypeInfo.Multiline = true;
            this.TB_TransducerTypeInfo.Name = "TB_TransducerTypeInfo";
            this.TB_TransducerTypeInfo.ReadOnly = true;
            this.TB_TransducerTypeInfo.Size = new System.Drawing.Size(336, 112);
            this.TB_TransducerTypeInfo.TabIndex = 43;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(16, 48);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(144, 24);
            this.label7.TabIndex = 42;
            this.label7.Text = "Transducer type selection :";
            // 
            // L_NbrOfTransducerType
            // 
            this.L_NbrOfTransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_NbrOfTransducerType.Location = new System.Drawing.Point(160, 24);
            this.L_NbrOfTransducerType.Name = "L_NbrOfTransducerType";
            this.L_NbrOfTransducerType.Size = new System.Drawing.Size(24, 23);
            this.L_NbrOfTransducerType.TabIndex = 41;
            this.L_NbrOfTransducerType.Text = "0";
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(16, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(144, 23);
            this.label6.TabIndex = 40;
            this.label6.Text = "Nbr of transducer type       :";
            // 
            // CB_TransducerType
            // 
            this.CB_TransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.CB_TransducerType.Location = new System.Drawing.Point(160, 48);
            this.CB_TransducerType.Name = "CB_TransducerType";
            this.CB_TransducerType.Size = new System.Drawing.Size(192, 21);
            this.CB_TransducerType.TabIndex = 39;
            this.CB_TransducerType.SelectedIndexChanged += new System.EventHandler(this.CB_TransducerType_SelectedIndexChanged);
            // 
            // GB_AcquisitionMode
            // 
            this.GB_AcquisitionMode.Controls.Add(this.L_Info);
            this.GB_AcquisitionMode.Controls.Add(this.RB_DataServer);
            this.GB_AcquisitionMode.Controls.Add(this.RB_SOAP);
            this.GB_AcquisitionMode.Location = new System.Drawing.Point(600, 368);
            this.GB_AcquisitionMode.Name = "GB_AcquisitionMode";
            this.GB_AcquisitionMode.Size = new System.Drawing.Size(301, 93);
            this.GB_AcquisitionMode.TabIndex = 157;
            this.GB_AcquisitionMode.TabStop = false;
            this.GB_AcquisitionMode.Text = "Acquisition mode";
            // 
            // RB_DataServer
            // 
            this.RB_DataServer.AutoSize = true;
            this.RB_DataServer.Location = new System.Drawing.Point(15, 42);
            this.RB_DataServer.Name = "RB_DataServer";
            this.RB_DataServer.Size = new System.Drawing.Size(167, 17);
            this.RB_DataServer.TabIndex = 1;
            this.RB_DataServer.TabStop = true;
            this.RB_DataServer.Text = "Acquisition via the data server";
            this.RB_DataServer.UseVisualStyleBackColor = true;
            this.RB_DataServer.CheckedChanged += new System.EventHandler(this.RB_DataServer_CheckedChanged);
            // 
            // RB_SOAP
            // 
            this.RB_SOAP.AutoSize = true;
            this.RB_SOAP.Checked = true;
            this.RB_SOAP.Location = new System.Drawing.Point(16, 21);
            this.RB_SOAP.Name = "RB_SOAP";
            this.RB_SOAP.Size = new System.Drawing.Size(184, 17);
            this.RB_SOAP.TabIndex = 0;
            this.RB_SOAP.TabStop = true;
            this.RB_SOAP.Text = "Acquisition via the SOAP function";
            this.RB_SOAP.UseVisualStyleBackColor = true;
            this.RB_SOAP.CheckedChanged += new System.EventHandler(this.RB_SOAP_CheckedChanged);
            // 
            // ReadTimer
            // 
            this.ReadTimer.Interval = 1;
            this.ReadTimer.Tick += new System.EventHandler(this.ReadTimer_Tick);
            // 
            // L_Info
            // 
            this.L_Info.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_Info.ForeColor = System.Drawing.Color.Navy;
            this.L_Info.Location = new System.Drawing.Point(33, 60);
            this.L_Info.Name = "L_Info";
            this.L_Info.Size = new System.Drawing.Size(254, 30);
            this.L_Info.TabIndex = 2;
            this.L_Info.Text = "It is recommended to set the blocking mode for the data server via the web page";
            this.L_Info.Visible = false;
            // 
            // F_AutoRefresh
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(944, 710);
            this.Controls.Add(this.GB_AcquisitionMode);
            this.Controls.Add(this.GB_Frequency);
            this.Controls.Add(this.GB_Average);
            this.Controls.Add(this.B_StopAutoRefresh);
            this.Controls.Add(this.B_StartAutoRefresh);
            this.Controls.Add(this.Display);
            this.Controls.Add(this.GB_DataFormat);
            this.Controls.Add(this.GB_Trigger);
            this.Controls.Add(this.GB_AutoRefreshConfig);
            this.Controls.Add(this.GB_ModuleSelectionBox);
            this.Controls.Add(this.GB_TransducerSelectionBox);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_AutoRefresh";
            this.Text = "Auto refresh C#";
            this.Load += new System.EventHandler(this.F_AutoRefresh_Load);
            this.Closed += new System.EventHandler(this.F_AutoRefresh_Closed);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.F_AutoRefresh_FormClosing);
            this.GB_Frequency.ResumeLayout(false);
            this.GB_Average.ResumeLayout(false);
            this.GB_Average.PerformLayout();
            this.GB_DataFormat.ResumeLayout(false);
            this.GB_Trigger.ResumeLayout(false);
            this.GB_Trigger.PerformLayout();
            this.GB_AutoRefreshConfig.ResumeLayout(false);
            this.GB_ModuleSelectionBox.ResumeLayout(false);
            this.GB_ModuleSelectionBox.PerformLayout();
            this.GB_TransducerSelectionBox.ResumeLayout(false);
            this.GB_TransducerSelectionBox.PerformLayout();
            this.GB_AcquisitionMode.ResumeLayout(false);
            this.GB_AcquisitionMode.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_AutoRefresh());
		}


		// Global Variable
		MXCommon.MXCommon MX_Global;
		MX370x.MX370x     MX_370x;
		Socket            SocketClient = null;
        String            DisplayText  = "";
        AsyncClientStream Client       = null;

        UInt64  ChannelMask;
        UInt32  NbrOfChannel;
        UInt32  DataStreamNbrOfChannel;
		UInt64  DataFormat;
		int     SocketRequestBytes;
		CheckBox[] s_CHB_AutoRefresh;

        /// <summary>
        /// Get the number of transducers of the system (i.e. The number of available acquisition channels)
        /// </summary>
        /// <param name="s_ModuleType">A string that represents the module type (obtain it using GetModuleType function)</param>
        /// <returns></returns>
		private UInt32 ul_GetNbrOfTransducerChannel (string s_ModuleType)
		{
            Match reg = null;

            // Check the MX37XX-IO-TYPE
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-([0-9]+)-[a-zA-Z]+");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Check the MX37XX-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Check the MSX-E37XX-DIO-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MSX-E37[0-9]+-DIO-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Fail
            return 0;
		}

		
		private void F_AutoRefresh_Load(object sender, System.EventArgs e)
		{
			MX_Global = new MXCommon.MXCommon();
			MX_370x = new MX370x.MX370x();
			MX_Global.Timeout = 2000;
			MX_370x.Timeout = 2000;

			s_CHB_AutoRefresh = new CheckBox[] {CHB_Channel0, CHB_Channel1, CHB_Channel2, CHB_Channel3, 
                                                CHB_Channel4, CHB_Channel5, CHB_Channel6, CHB_Channel7, 
                                                CHB_Channel8, CHB_Channel9, CHB_Channel10, CHB_Channel11, 
                                                CHB_Channel12, CHB_Channel13, CHB_Channel14, CHB_Channel15};
		}

		private void F_AutoRefresh_Closed(object sender, System.EventArgs e)
		{
			DisplayTimer.Enabled = false;

			if ((B_StartAutoRefresh.Enabled == false) && (B_StopAutoRefresh.Enabled == true))
			{
				B_StopAutoRefresh_Click(sender,e);
			}
			MX_370x = null;
			MX_Global = null;

			System.GC.Collect();
		}

		private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_0.SelectAll();
		}

		private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_1.SelectAll();
		}

		private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_2.SelectAll();
		}

		private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_3.SelectAll();
		}

		private UInt64 GetTransducerTypeInfo() 
		{
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex;
			byte[] pc_Name = new byte[255];
			UInt64 ul_CalibrationStatus;
			UInt64 ul_Type;
			UInt64 ul_Frequency;
			UInt64 ul_Impedance;
			double  d_Veff;
			double  d_Range;
			double  d_Sensibility;
			UInt64 ul_SelectedTransducer;

			ul_SelectedTransducer = Convert.ToUInt64(CB_TransducerType.SelectedIndex);

			TB_TransducerTypeInfo.Text = "";
			ul_TransducerSelectionIndex = 0;
			try
			{
				// Get the tranducer type information
				MX_370x.TransducerGetTypeInformation(ul_SelectedTransducer, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);

				// Display the transducer type information
				TB_TransducerTypeInfo.Text = "Transducer Selection Index : " + ul_TransducerSelectionIndex.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Name                                   : " + enc.GetString(pc_Name);
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Calibration status                  : " + ul_CalibrationStatus.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Type Value                          : " + ul_Type.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Frequency                           : " + ul_Frequency.ToString() + " Hz";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Impedance                          : " + ul_Impedance.ToString() + " Ohm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Nominal Voltage                  : " + d_Veff.ToString() + " V";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Sensibility                            : " + d_Sensibility.ToString() + " mV/V/mm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Range                                 : +/-" + d_Range.ToString() + " mm";
			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}

			return (ul_TransducerSelectionIndex);
		}

		private void B_GetModuleInformation_Click(object sender, System.EventArgs e)
		{
			byte [] pb_ModuleType = new byte [200];
			UInt64 ul_NbrOfTransducerType = 0;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex = 0;
			Byte []pc_Name = new Byte[255];
			UInt64 ul_CalibrationStatus = 0;
			UInt64 ul_Type = 0;
			UInt64 ul_Frequency = 0;
			UInt64 ul_Impedance = 0;
			UInt64 Cpt = 0;
			double d_Veff = 0.0;
			double d_Sensibility = 0.0;
			double d_Range = 0.0;
			
			MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
			MX_370x.Url = MX_Global.Url;
		
			try
			{
				// Get the module type
				MX_Global.GetModuleType(out pb_ModuleType);
				L_MXModuleIdentifier.Text = enc.GetString(pb_ModuleType);

                // Get the number of transducer channels
                NbrOfChannel = ul_GetNbrOfTransducerChannel(enc.GetString(pb_ModuleType));
                if (NbrOfChannel <= 0)
                {
                    MessageBox.Show("Cannot find the number of transducer channels, assuming it is 16.");
                    NbrOfChannel = 16;
                }

				// Get the number of transducer type
				MX_370x.TransducerGetNbrOfType(out ul_NbrOfTransducerType);
				L_NbrOfTransducerType.Text = ul_NbrOfTransducerType.ToString();

				// Get the tranducer type information
				CB_TransducerType.Items.Clear();
                for (Cpt = 0; Cpt < ul_NbrOfTransducerType; Cpt++)
				{
                    MX_370x.TransducerGetTypeInformation(Cpt, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);
					CB_TransducerType.Items.Add (enc.GetString(pc_Name));
				}
				CB_TransducerType.SelectedIndex = 0;
				B_StartAutoRefresh.Enabled = true;
				B_StopAutoRefresh.Enabled = false;
				GB_TransducerSelectionBox.Enabled = true;

                for (Cpt = 0; Cpt < NbrOfChannel; Cpt++)
				{
                    s_CHB_AutoRefresh[Cpt].Enabled = true;
                    s_CHB_AutoRefresh[Cpt].Checked = true;
				}

                for (Cpt = NbrOfChannel; Cpt < 16; Cpt++)
				{
                    s_CHB_AutoRefresh[Cpt].Enabled = false;
                    s_CHB_AutoRefresh[Cpt].Checked = false;
				}
			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		private void CB_TransducerType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetTransducerTypeInfo();
		}

		private void CB_AverageMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
	        if (CB_AverageMode.SelectedIndex != 0) 
		        TB_AverageValue.Enabled = true;
	        else
		        TB_AverageValue.Enabled = false;
		}

		private void CB_TriggerMask_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (CB_TriggerMask.SelectedIndex != 0)
			{
				CB_TriggerMode.Enabled = true;
			}
			else
			{
				CB_TriggerMode.Enabled = false;
				TB_NbrOfSeqForEachTrigger.Enabled = false;
				CB_HardwareTriggerEdge.Enabled = false;
				TB_HardwareTriggerCount.Enabled = false;
			}

			if (CB_TriggerMask.SelectedIndex == 1) 
			{
				CB_HardwareTriggerEdge.Enabled = true;
				TB_HardwareTriggerCount.Enabled = true;
			}

			if (CB_TriggerMask.SelectedIndex == 2) 
			{
				CB_HardwareTriggerEdge.Enabled = false;
				TB_HardwareTriggerCount.Enabled = false;
			}
		}

		private void CB_TriggerMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
	        if (CB_TriggerMode.SelectedIndex == 1) 
		        TB_NbrOfSeqForEachTrigger.Enabled = true;
	        else
		        TB_NbrOfSeqForEachTrigger.Enabled = false;
		}

		private DateTime ConvertFromTime_T(long time_t)
		{
			DateTime netTimeT;
			DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
			long tickTotal;

			tickTotal = dt70.Ticks + (time_t * 10000000);
			netTimeT = new DateTime(tickTotal);
			return (netTimeT);
		}

		private void B_StartAutoRefresh_Click(object sender, System.EventArgs e)
		{
			int     i_Error;
			int     i_SysError;
            UInt64 Cpt;
			UInt64 ul_SelectedTransducer;
			UInt64 ul_TriggerAction;
			UInt64 ul_ByTriggerNbrOfSeqToAcquire;
            Thread ClientThread;


            DataFormat = 0;
            ChannelMask = 0;
			ul_TriggerAction = 0;
			SocketRequestBytes = 4;
			ul_ByTriggerNbrOfSeqToAcquire = 0;
            DataStreamNbrOfChannel = 0;

			try
			{
				// Get the selected transducer
				ul_SelectedTransducer = GetTransducerTypeInfo();

				// Get the auto refresh channel mask
                for (Cpt = 0; Cpt < NbrOfChannel; Cpt++)
				{
                    ChannelMask = ChannelMask + ((Convert.ToUInt64(s_CHB_AutoRefresh[Cpt].Checked) & 1) * Convert.ToUInt64(Math.Pow(2, Cpt)));
                    SocketRequestBytes = SocketRequestBytes + (4 * (Convert.ToInt32(s_CHB_AutoRefresh[Cpt].Checked) & 1));
                    DataStreamNbrOfChannel = DataStreamNbrOfChannel + (Convert.ToUInt32(s_CHB_AutoRefresh[Cpt].Checked) & 1);
				}

				// Test if used hardware trigger
				if (CB_TriggerMask.SelectedIndex == 1) 
				{
					// Get the trigger action
					ul_TriggerAction = Convert.ToUInt64 (CB_TriggerMode.SelectedIndex) + 1;

					//Get the trigger level selection
					ul_TriggerAction = ul_TriggerAction + ((Convert.ToUInt64 (CB_HardwareTriggerEdge.SelectedIndex) + 1) << 6);
				}

				// Test if used synchro trigger
				if (CB_TriggerMask.SelectedIndex == 2) 
				{
					// Get the trigger action
					ul_TriggerAction = (Convert.ToUInt64 (CB_TriggerMode.SelectedIndex) + 1) << 8;
				}


				// Test if AutoRefresh trigger used
				if ((CB_TriggerMode.SelectedIndex == 1) && (CB_TriggerMask.SelectedIndex != 0)) 
				{
					// Get the number of AutoRefresh
					ul_ByTriggerNbrOfSeqToAcquire = Convert.ToUInt64(TB_NbrOfSeqForEachTrigger.Text);
				}

                // Get the data format
                DataFormat = (Convert.ToUInt64(CHB_DataFormatTimeStamp.Checked) & 1);
                DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatAnalogValue.Checked) & 1) << 1);
                DataFormat = DataFormat + ((Convert.ToUInt64(CHB_DataFormatInvertSign.Checked) & 1) << 2);
                SocketRequestBytes = SocketRequestBytes + (8 * (Convert.ToInt32(CHB_DataFormatTimeStamp.Checked) & 1));

                SocketClient = null;
                ClientThread = null;

                // Test if receive data via the data server
                if (RB_DataServer.Checked == true)
                {
                    /* Create the client stream */
                    Client = new AddiData.ADDISocket.AsyncClientStream();

                    // DATA FORMAT CONFIGURATION
                    Client.SingleFramesSize = SocketRequestBytes;
                    Client.NbrOfFrames = 1;


                    // Open the socket connection to receive the data
                    SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                    SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989);
                    SocketClient.ReceiveBufferSize = 1048576;

                    // Start the first read socket 
                    // Start the read socket and the user thread
                    Client.Start(SocketClient);
                    ClientThread = new Thread(ClientThreadFct);
                }

                DisplayText = "";

				//Init and start the auto refresh acquisition
				i_Error = MX_370x.TransducerInitAndStartAutoRefresh(ul_SelectedTransducer,
                                                                    ChannelMask, 
					                                                Convert.ToUInt64(CB_AverageMode.SelectedIndex), 
					                                                Convert.ToUInt64(TB_AverageValue.Text), 
					                                                Convert.ToUInt64(CB_TimeDivision.SelectedItem), 
					                                                Convert.ToUInt64(ul_TriggerAction), 
					                                                Convert.ToUInt64(TB_HardwareTriggerCount.Text), 
					                                                0, 
					                                                ul_ByTriggerNbrOfSeqToAcquire,
                                                                    DataFormat, 
					                                                0, 
					                                                0, 
					                                                0, 
					                                                out i_SysError);

				// Test if no error occur
				if (i_Error == 0) 
				{
					DisplayTimer.Enabled = true;

                    // Test if receive data via the data server
                    if (RB_DataServer.Checked == true)
                    {
                        ClientThread.Priority = ThreadPriority.Lowest;
                        ClientThread.Start();
                    }
                    else
                    {
                        ReadTimer.Enabled = true;
                    }
                    B_StopAutoRefresh.Enabled = true;
					B_StartAutoRefresh.Enabled = false;
					GB_AutoRefreshConfig.Enabled = false;
					GB_Average.Enabled = false;
					GB_DataFormat.Enabled = false;
					GB_Trigger.Enabled = false;
					GB_ModuleSelectionBox.Enabled = false;
					GB_Frequency.Enabled = false;
					GB_Average.Enabled = false;
                    GB_AcquisitionMode.Enabled = false;
				}
				else
				{
					MessageBox.Show ("TransducerInitAndStartAutoRefresh Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (B_StopAutoRefresh.Enabled == false)
            {
                B_StopAutoRefresh_Click(sender, null);
            }
		}

		private void B_StopAutoRefresh_Click(object sender, System.EventArgs e)
		{
			int syserrno = 0;
			int i_Error = 0;

            DisplayTimer.Enabled = false;
            ReadTimer.Enabled    = false;

            // Test if socket open
            if (SocketClient != null)
            {
                if (Client != null)
                    Client.Stoop();

                try
                {
                    // Close the socket connection
                    SocketClient.Disconnect(false);
                    SocketClient.Close();
                    SocketClient = null;
                    System.GC.Collect();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            if (B_StopAutoRefresh.Enabled == true)
            {
                try
                {
                    // Stop and release the acquisition
                    i_Error = MX_370x.TransducerStopAndReleaseAutoRefresh(out syserrno);
                    if (i_Error != 0)
                    {
                        MessageBox.Show ("TransducerStopAndReleaseAutoRefresh Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show ("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }

                B_StartAutoRefresh.Enabled = true;
                B_StopAutoRefresh.Enabled = false;
                GB_AutoRefreshConfig.Enabled = true;
                GB_Average.Enabled = true;
                GB_Trigger.Enabled = true;
                GB_ModuleSelectionBox.Enabled = true;
                GB_Frequency.Enabled = true;
                GB_Average.Enabled = true;
                GB_AcquisitionMode.Enabled = true;

                // Test if receive data via the data server
                if (RB_DataServer.Checked == true)
                {
                    GB_DataFormat.Enabled = true;
                }
            }
		}



        private void ClientThreadFct()
        {
            String sOutString;
            UInt32 Value = 0;
            UInt32 Counter = 0;
            Single sValue = 0;
            ulong TimeStampLow = 0;
            ulong TimeStampHigh = 0;
            ulong TimeStampLowmus = 0;
            ulong TimeStampLowms = 0;
            int   StreamDataIndex = 0;
            byte[] SocketData = new byte[Client.SingleFramesSize];


            while ((SocketData = Client.ReadData()) != null)
            {
                sOutString = "";
                StreamDataIndex = 0;

                // Test if time stampe used
                if ((DataFormat & 1) == 1)
                {
                    TimeStampHigh = BitConverter.ToUInt32(SocketData, (int)(0));
                    TimeStampLow = BitConverter.ToUInt32(SocketData, (int)(4));
                    TimeStampLowms = (ulong)(TimeStampLow / 1000);
                    TimeStampLowmus = (ulong)(TimeStampLow % 1000);
                    sOutString = sOutString + "Time stamp: " + ConvertFromTime_T((long)TimeStampHigh).ToString() + "." + TimeStampLowms.ToString("D3") + "." + TimeStampLowmus.ToString("D3") + Environment.NewLine;
                    StreamDataIndex = 8;
                }

                // Get the auto refresh counter value
                Value = BitConverter.ToUInt32(SocketData, StreamDataIndex);
                sOutString = sOutString + "Counter: " + Value.ToString() + Environment.NewLine;
                StreamDataIndex = StreamDataIndex + 4;

                // Test if convert to mm
                if ((DataFormat & 2) == 2)
                {
                    sOutString = sOutString + "Channel value(s) :";
                    for (Counter = 0; Counter < DataStreamNbrOfChannel; Counter++)
                    {
                        sValue = BitConverter.ToSingle(SocketData, (int)((Counter * 4) + StreamDataIndex));
                        sOutString = sOutString + " " + sValue.ToString("F4") + " mm";
                    }
                }
                else
                {
                    sOutString = sOutString + "Channel value(s) :";
                    for (Counter = 0; Counter < DataStreamNbrOfChannel; Counter++)
                    {
                        Value = BitConverter.ToUInt32(SocketData, (int)((Counter * 4) + StreamDataIndex));
                        sOutString = sOutString + " " + Value.ToString("X") + " Hex";
                    }
                }

                DisplayText = sOutString;
            }
        }

        private void ReadTimer_Tick(object sender, EventArgs e)
        {
		    ulong[] Values = new ulong [17];
            int    i_Error;
            UInt32 Cpt;
            UInt32 TestChannel;
            String sOutString;

            // Read the auto refresh value
            i_Error = MX_370x.TransducerGetAutoRefreshValues(out Values);

            // Test if error occur
            if (i_Error != 0)
            {
                B_StopAutoRefresh_Click(sender, null);
                MessageBox.Show("TransducerGetAutoRefreshValues Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                // Get the auto refresh counter value
                sOutString = "Counter: " + Values[0].ToString() + Environment.NewLine + "Channel value(s) :";

				// Get the auto refresh channel mask
                for (Cpt = 0, TestChannel = 1; Cpt < NbrOfChannel; Cpt++, TestChannel = TestChannel * 2)
                {
                    // Test if channel used
                    if ((ChannelMask & TestChannel) != 0)
                    {
                        sOutString = sOutString + " " + Values[Cpt + 1].ToString("X") + " Hex";
                    }
                }

                DisplayText = sOutString;
            }
        }																																																										

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            Display.Text = DisplayText;
        }

        private void F_AutoRefresh_FormClosing(object sender, FormClosingEventArgs e)
        {
            B_StopAutoRefresh_Click(sender, null);
        }

        private void RB_SOAP_CheckedChanged(object sender, EventArgs e)
        {
            GB_DataFormat.Enabled = false;
            L_Info.Visible = false;
        }

        private void RB_DataServer_CheckedChanged(object sender, EventArgs e)
        {
            GB_DataFormat.Enabled = true;
            L_Info.Visible = true;
        }
	}
}
