using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Text.RegularExpressions;

namespace Diagnostic
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_Diagnostic : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox TB_Values;
		private System.Windows.Forms.Timer timer1;
		internal System.Windows.Forms.GroupBox GB_ModuleSelectionBox;
		internal System.Windows.Forms.Button B_GetModuleInformation;
		internal System.Windows.Forms.Label L_MXModuleIdentifier;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		internal System.Windows.Forms.Label label3;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.TextBox TB_IPAddress_3;
		internal System.Windows.Forms.TextBox TB_IPAddress_2;
		internal System.Windows.Forms.TextBox TB_IPAddress_1;
		internal System.Windows.Forms.TextBox TB_IPAddress_0;
		internal System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox GB_PrimaryBox;
		private System.Windows.Forms.Button B_RearmPrimary;
		private System.Windows.Forms.Button B_PrimaryShortCircuitTest;
		private System.Windows.Forms.Button B_PrimaryConnectionTest;
		private System.Windows.Forms.Button B_InitPrimaryConnectionTest;
		private System.Windows.Forms.GroupBox GB_SecondaryBox;
		private System.Windows.Forms.Button B_SecondaryShortCircuitTest;
		private System.Windows.Forms.Button B_SecondaryConnectionTest;
		private System.Windows.Forms.NumericUpDown NUD_ChannelSelection;
		private System.Windows.Forms.Label l_ChannelSelection;
		private System.Windows.Forms.GroupBox GB_EventBox;
		private System.Windows.Forms.Button B_Start;
		private System.Windows.Forms.Button B_Stop;
		private System.Windows.Forms.TextBox TB_Event;
		private System.ComponentModel.IContainer components;

		public F_Diagnostic()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_Diagnostic));
            this.TB_Values = new System.Windows.Forms.TextBox();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.GB_ModuleSelectionBox = new System.Windows.Forms.GroupBox();
            this.B_GetModuleInformation = new System.Windows.Forms.Button();
            this.L_MXModuleIdentifier = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_PrimaryBox = new System.Windows.Forms.GroupBox();
            this.B_RearmPrimary = new System.Windows.Forms.Button();
            this.B_PrimaryShortCircuitTest = new System.Windows.Forms.Button();
            this.B_PrimaryConnectionTest = new System.Windows.Forms.Button();
            this.B_InitPrimaryConnectionTest = new System.Windows.Forms.Button();
            this.GB_SecondaryBox = new System.Windows.Forms.GroupBox();
            this.NUD_ChannelSelection = new System.Windows.Forms.NumericUpDown();
            this.l_ChannelSelection = new System.Windows.Forms.Label();
            this.B_SecondaryShortCircuitTest = new System.Windows.Forms.Button();
            this.B_SecondaryConnectionTest = new System.Windows.Forms.Button();
            this.GB_EventBox = new System.Windows.Forms.GroupBox();
            this.TB_Event = new System.Windows.Forms.TextBox();
            this.B_Stop = new System.Windows.Forms.Button();
            this.B_Start = new System.Windows.Forms.Button();
            this.GB_ModuleSelectionBox.SuspendLayout();
            this.GB_PrimaryBox.SuspendLayout();
            this.GB_SecondaryBox.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.NUD_ChannelSelection)).BeginInit();
            this.GB_EventBox.SuspendLayout();
            this.SuspendLayout();
            // 
            // TB_Values
            // 
            this.TB_Values.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Values.Location = new System.Drawing.Point(24, 376);
            this.TB_Values.Multiline = true;
            this.TB_Values.Name = "TB_Values";
            this.TB_Values.ReadOnly = true;
            this.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_Values.Size = new System.Drawing.Size(1032, 144);
            this.TB_Values.TabIndex = 34;
            // 
            // timer1
            // 
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // GB_ModuleSelectionBox
            // 
            this.GB_ModuleSelectionBox.Controls.Add(this.B_GetModuleInformation);
            this.GB_ModuleSelectionBox.Controls.Add(this.L_MXModuleIdentifier);
            this.GB_ModuleSelectionBox.Controls.Add(this.label5);
            this.GB_ModuleSelectionBox.Controls.Add(this.label4);
            this.GB_ModuleSelectionBox.Controls.Add(this.label3);
            this.GB_ModuleSelectionBox.Controls.Add(this.label2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleSelectionBox.Controls.Add(this.label1);
            this.GB_ModuleSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_ModuleSelectionBox.Location = new System.Drawing.Point(24, 8);
            this.GB_ModuleSelectionBox.Name = "GB_ModuleSelectionBox";
            this.GB_ModuleSelectionBox.Size = new System.Drawing.Size(512, 176);
            this.GB_ModuleSelectionBox.TabIndex = 136;
            this.GB_ModuleSelectionBox.TabStop = false;
            this.GB_ModuleSelectionBox.Text = "Module selection";
            // 
            // B_GetModuleInformation
            // 
            this.B_GetModuleInformation.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_GetModuleInformation.Location = new System.Drawing.Point(384, 24);
            this.B_GetModuleInformation.Name = "B_GetModuleInformation";
            this.B_GetModuleInformation.Size = new System.Drawing.Size(112, 33);
            this.B_GetModuleInformation.TabIndex = 43;
            this.B_GetModuleInformation.Text = "&Connection to module";
            this.B_GetModuleInformation.Click += new System.EventHandler(this.B_GetModuleInformation_Click);
            // 
            // L_MXModuleIdentifier
            // 
            this.L_MXModuleIdentifier.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_MXModuleIdentifier.Location = new System.Drawing.Point(176, 72);
            this.L_MXModuleIdentifier.Name = "L_MXModuleIdentifier";
            this.L_MXModuleIdentifier.Size = new System.Drawing.Size(320, 80);
            this.L_MXModuleIdentifier.TabIndex = 42;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(132, 23);
            this.label5.TabIndex = 41;
            this.label5.Text = "MX Module Identifier :";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(328, 32);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 40;
            this.label4.Text = "-";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(272, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(216, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 38;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_3.Location = new System.Drawing.Point(336, 32);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_3.TabIndex = 37;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_2.Location = new System.Drawing.Point(288, 32);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_2.TabIndex = 36;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_1.Location = new System.Drawing.Point(232, 32);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_1.TabIndex = 35;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(176, 32);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_0.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 32);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(160, 16);
            this.label1.TabIndex = 33;
            this.label1.Text = "IP Address of the MX Module :";
            // 
            // GB_PrimaryBox
            // 
            this.GB_PrimaryBox.Controls.Add(this.B_RearmPrimary);
            this.GB_PrimaryBox.Controls.Add(this.B_PrimaryShortCircuitTest);
            this.GB_PrimaryBox.Controls.Add(this.B_PrimaryConnectionTest);
            this.GB_PrimaryBox.Controls.Add(this.B_InitPrimaryConnectionTest);
            this.GB_PrimaryBox.Enabled = false;
            this.GB_PrimaryBox.Location = new System.Drawing.Point(544, 8);
            this.GB_PrimaryBox.Name = "GB_PrimaryBox";
            this.GB_PrimaryBox.Size = new System.Drawing.Size(512, 176);
            this.GB_PrimaryBox.TabIndex = 137;
            this.GB_PrimaryBox.TabStop = false;
            this.GB_PrimaryBox.Text = "Primary tests";
            // 
            // B_RearmPrimary
            // 
            this.B_RearmPrimary.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_RearmPrimary.Location = new System.Drawing.Point(272, 104);
            this.B_RearmPrimary.Name = "B_RearmPrimary";
            this.B_RearmPrimary.Size = new System.Drawing.Size(200, 32);
            this.B_RearmPrimary.TabIndex = 48;
            this.B_RearmPrimary.Text = "Rearm Primary";
            this.B_RearmPrimary.Click += new System.EventHandler(this.B_RearmPrimary_Click);
            // 
            // B_PrimaryShortCircuitTest
            // 
            this.B_PrimaryShortCircuitTest.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_PrimaryShortCircuitTest.Location = new System.Drawing.Point(40, 104);
            this.B_PrimaryShortCircuitTest.Name = "B_PrimaryShortCircuitTest";
            this.B_PrimaryShortCircuitTest.Size = new System.Drawing.Size(200, 32);
            this.B_PrimaryShortCircuitTest.TabIndex = 47;
            this.B_PrimaryShortCircuitTest.Text = "Primary Short Circuit Test";
            this.B_PrimaryShortCircuitTest.Click += new System.EventHandler(this.B_PrimaryShortCircuitTest_Click);
            // 
            // B_PrimaryConnectionTest
            // 
            this.B_PrimaryConnectionTest.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_PrimaryConnectionTest.Location = new System.Drawing.Point(272, 32);
            this.B_PrimaryConnectionTest.Name = "B_PrimaryConnectionTest";
            this.B_PrimaryConnectionTest.Size = new System.Drawing.Size(200, 32);
            this.B_PrimaryConnectionTest.TabIndex = 46;
            this.B_PrimaryConnectionTest.Text = "Primary Connection Test";
            this.B_PrimaryConnectionTest.Click += new System.EventHandler(this.B_PrimaryConnectionTest_Click);
            // 
            // B_InitPrimaryConnectionTest
            // 
            this.B_InitPrimaryConnectionTest.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_InitPrimaryConnectionTest.Location = new System.Drawing.Point(40, 32);
            this.B_InitPrimaryConnectionTest.Name = "B_InitPrimaryConnectionTest";
            this.B_InitPrimaryConnectionTest.Size = new System.Drawing.Size(200, 32);
            this.B_InitPrimaryConnectionTest.TabIndex = 45;
            this.B_InitPrimaryConnectionTest.Text = "Init Primary Connection Test";
            this.B_InitPrimaryConnectionTest.Click += new System.EventHandler(this.B_InitPrimaryConnectionTest_Click);
            // 
            // GB_SecondaryBox
            // 
            this.GB_SecondaryBox.Controls.Add(this.NUD_ChannelSelection);
            this.GB_SecondaryBox.Controls.Add(this.l_ChannelSelection);
            this.GB_SecondaryBox.Controls.Add(this.B_SecondaryShortCircuitTest);
            this.GB_SecondaryBox.Controls.Add(this.B_SecondaryConnectionTest);
            this.GB_SecondaryBox.Enabled = false;
            this.GB_SecondaryBox.Location = new System.Drawing.Point(544, 192);
            this.GB_SecondaryBox.Name = "GB_SecondaryBox";
            this.GB_SecondaryBox.Size = new System.Drawing.Size(512, 176);
            this.GB_SecondaryBox.TabIndex = 138;
            this.GB_SecondaryBox.TabStop = false;
            this.GB_SecondaryBox.Text = "Secondary tests";
            // 
            // NUD_ChannelSelection
            // 
            this.NUD_ChannelSelection.Location = new System.Drawing.Point(248, 48);
            this.NUD_ChannelSelection.Maximum = new decimal(new int[] {
            16,
            0,
            0,
            0});
            this.NUD_ChannelSelection.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
            this.NUD_ChannelSelection.Name = "NUD_ChannelSelection";
            this.NUD_ChannelSelection.Size = new System.Drawing.Size(112, 20);
            this.NUD_ChannelSelection.TabIndex = 45;
            // 
            // l_ChannelSelection
            // 
            this.l_ChannelSelection.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.l_ChannelSelection.Location = new System.Drawing.Point(120, 48);
            this.l_ChannelSelection.Name = "l_ChannelSelection";
            this.l_ChannelSelection.Size = new System.Drawing.Size(120, 23);
            this.l_ChannelSelection.TabIndex = 44;
            this.l_ChannelSelection.Text = "Channel selection :";
            // 
            // B_SecondaryShortCircuitTest
            // 
            this.B_SecondaryShortCircuitTest.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_SecondaryShortCircuitTest.Location = new System.Drawing.Point(272, 112);
            this.B_SecondaryShortCircuitTest.Name = "B_SecondaryShortCircuitTest";
            this.B_SecondaryShortCircuitTest.Size = new System.Drawing.Size(200, 32);
            this.B_SecondaryShortCircuitTest.TabIndex = 43;
            this.B_SecondaryShortCircuitTest.Text = "Secondary Short Circuit Test";
            this.B_SecondaryShortCircuitTest.Click += new System.EventHandler(this.B_SecondaryShortCircuitTest_Click);
            // 
            // B_SecondaryConnectionTest
            // 
            this.B_SecondaryConnectionTest.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_SecondaryConnectionTest.Location = new System.Drawing.Point(40, 112);
            this.B_SecondaryConnectionTest.Name = "B_SecondaryConnectionTest";
            this.B_SecondaryConnectionTest.Size = new System.Drawing.Size(200, 32);
            this.B_SecondaryConnectionTest.TabIndex = 42;
            this.B_SecondaryConnectionTest.Text = "Secondary Connection Test";
            this.B_SecondaryConnectionTest.Click += new System.EventHandler(this.B_SecondaryConnectionTest_Click);
            // 
            // GB_EventBox
            // 
            this.GB_EventBox.Controls.Add(this.TB_Event);
            this.GB_EventBox.Controls.Add(this.B_Stop);
            this.GB_EventBox.Controls.Add(this.B_Start);
            this.GB_EventBox.Enabled = false;
            this.GB_EventBox.Location = new System.Drawing.Point(24, 192);
            this.GB_EventBox.Name = "GB_EventBox";
            this.GB_EventBox.Size = new System.Drawing.Size(512, 176);
            this.GB_EventBox.TabIndex = 139;
            this.GB_EventBox.TabStop = false;
            this.GB_EventBox.Text = "Event monitoring";
            // 
            // TB_Event
            // 
            this.TB_Event.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Event.Location = new System.Drawing.Point(16, 64);
            this.TB_Event.Multiline = true;
            this.TB_Event.Name = "TB_Event";
            this.TB_Event.ReadOnly = true;
            this.TB_Event.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_Event.Size = new System.Drawing.Size(480, 93);
            this.TB_Event.TabIndex = 141;
            // 
            // B_Stop
            // 
            this.B_Stop.Enabled = false;
            this.B_Stop.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_Stop.Location = new System.Drawing.Point(272, 24);
            this.B_Stop.Name = "B_Stop";
            this.B_Stop.Size = new System.Drawing.Size(200, 32);
            this.B_Stop.TabIndex = 37;
            this.B_Stop.Text = "Stop monitoring ioDriver event";
            this.B_Stop.Click += new System.EventHandler(this.B_Stop_Click);
            // 
            // B_Start
            // 
            this.B_Start.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_Start.Location = new System.Drawing.Point(40, 24);
            this.B_Start.Name = "B_Start";
            this.B_Start.Size = new System.Drawing.Size(200, 32);
            this.B_Start.TabIndex = 36;
            this.B_Start.Text = "Start monitoring ioDriver event ";
            this.B_Start.Click += new System.EventHandler(this.B_Start_Click);
            // 
            // F_Diagnostic
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1072, 550);
            this.Controls.Add(this.GB_EventBox);
            this.Controls.Add(this.GB_SecondaryBox);
            this.Controls.Add(this.GB_PrimaryBox);
            this.Controls.Add(this.GB_ModuleSelectionBox);
            this.Controls.Add(this.TB_Values);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_Diagnostic";
            this.Text = "Diagnostic C#";
            this.Load += new System.EventHandler(this.F_Diagnostic_Load);
            this.Click += new System.EventHandler(this.B_Start_Click);
            this.GB_ModuleSelectionBox.ResumeLayout(false);
            this.GB_ModuleSelectionBox.PerformLayout();
            this.GB_PrimaryBox.ResumeLayout(false);
            this.GB_SecondaryBox.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.NUD_ChannelSelection)).EndInit();
            this.GB_EventBox.ResumeLayout(false);
            this.GB_EventBox.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_Diagnostic());
		}
		// Global Variable
		MXCommon.MXCommon MX_Global;
		MX370x.MX370x MX_370x;
		TcpClient SocketClient;
		NetworkStream stream;
		byte S_IODRIVER = 2;
		int i_NbrOfChannel = 0;
		
        /// <summary>
        /// Get the number of transducers of the system (i.e. The number of available acquisition channels)
        /// </summary>
        /// <param name="s_ModuleType">A string that represents the module type (obtain it using GetModuleType function)</param>
        /// <returns></returns>
		private int i_GetNbrOfTransducerChannel (string s_ModuleType)
		{
            Match reg = null;

            // Check the MX37XX-IO-TYPE
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-([0-9]+)-[a-zA-Z]+");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Check the MX37XX-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Check the MSX-E37XX-DIO-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MSX-E37[0-9]+-DIO-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToInt32(reg.Groups[1].Value);

            // Fail
            return -1;
		}

		private string s_GetSysErrnoString (int isyserrno)
		{
			byte [] pb_Errno;
			MXCommon.DefaultResponse dResponse;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();

			dResponse = MX_Global.Strerror(isyserrno,out pb_Errno);
			if (dResponse.iReturnValue == 0)
				return(enc.GetString(pb_Errno));
			else
				return ("unknown error");

			

		}


		private void F_Diagnostic_Load(object sender, System.EventArgs e)
		{
			MX_Global = new MXCommon.MXCommon();
			MX_370x = new MX370x.MX370x();
			MX_Global.Timeout = 20000;
			MX_370x.Timeout = 20000;
		}

		private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_0.SelectAll();
		}

		private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_1.SelectAll();
		}

		private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_2.SelectAll();
		}

		private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_3.SelectAll();
		}

		private void B_GetModuleInformation_Click(object sender, System.EventArgs e)
		{
			byte [] pb_ModuleType = new byte [200];
			UInt64 ul_NbrOfTransducerType = 0;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			Byte []pc_Name = new Byte[255];
			
			MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "."+
				TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";

			MX_370x.Url = MX_Global.Url;
		
			try
			{
				// Get the module type
				MX_Global.GetModuleType(out pb_ModuleType);
				L_MXModuleIdentifier.Text = enc.GetString(pb_ModuleType);

                // Get the number of transducer channels
				i_NbrOfChannel = i_GetNbrOfTransducerChannel (enc.GetString(pb_ModuleType));
                if (i_NbrOfChannel <= 0)
                {
                    MessageBox.Show("Cannot find the number of transducer channels, assuming it is 16.");
                    i_NbrOfChannel = 16;
                }

				// Get the number of transducer type
				MX_370x.TransducerGetNbrOfType(out ul_NbrOfTransducerType);

				GB_PrimaryBox.Enabled = true;
				GB_SecondaryBox.Enabled = true;
				GB_EventBox.Enabled = true;
			}
			catch (Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}
		}






		private void B_InitPrimaryConnectionTest_Click(object sender, System.EventArgs e)
		{
			int iReturn = 0;
			int isyserrno = 0;

			iReturn = MX_370x.TransducerInitPrimaryConnectionTest(out isyserrno);
			if (iReturn == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerInitPrimaryConnectionTest OK ";
				B_PrimaryConnectionTest.Enabled = true;
			}
			else
			{
				TB_Values.Text = "TransducerInitPrimaryConnectionTest Error : " + iReturn.ToString();
				if (iReturn == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(isyserrno);
			}
		}

		private void B_PrimaryConnectionTest_Click(object sender, System.EventArgs e)
		{
			MX370x.DefaultResponse dResponse;
			UInt64 ulValue = 0;

			dResponse = MX_370x.TransducerTestPrimaryConnection(out ulValue);
			if (dResponse.iReturnValue == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerTestPrimaryConnection OK Status :" + ulValue.ToString();
			}
			else
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +"TransducerTestPrimaryConnection Error : " + dResponse.iReturnValue.ToString();
				if (dResponse.iReturnValue == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(dResponse.syserrno);
			}
		}

		private void B_PrimaryShortCircuitTest_Click(object sender, System.EventArgs e)
		{
			MX370x.DefaultResponse dResponse;
			UInt64 ulValue = 0;

			dResponse = MX_370x.TransducerTestPrimaryShortCircuit(out ulValue);
			if (dResponse.iReturnValue == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerTestPrimaryShortCircuit OK Status :" + ulValue.ToString();
			}
			else
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +"TransducerTestPrimaryShortCircuit Error : " + dResponse.iReturnValue.ToString();
				if (dResponse.iReturnValue == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(dResponse.syserrno);
			}
		}

		private void B_RearmPrimary_Click(object sender, System.EventArgs e)
		{
			MX370x.DefaultResponse dResponse;
			UInt64 ulValue = 0;

			dResponse = MX_370x.TransducerRearmPrimary(out ulValue);
			if (dResponse.iReturnValue == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerRearmPrimary OK Status :" + ulValue.ToString();
			}
			else
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +"TransducerRearmPrimary Error : " + dResponse.iReturnValue.ToString();
				if (dResponse.iReturnValue == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(dResponse.syserrno);
			}		
		}

		private void B_SecondaryConnectionTest_Click(object sender, System.EventArgs e)
		{
			MX370x.DefaultResponse dResponse;
			UInt64 ulValue = 0;
			UInt64 ulChannel = 0;

			ulChannel = (UInt64)NUD_ChannelSelection.Value;

			dResponse = MX_370x.TransducerTestSecondaryConnection(ulChannel-1,out ulValue);
			if (dResponse.iReturnValue == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerTestSecondaryConnection OK Channel:"+ ulChannel.ToString()+" Status :" + ulValue.ToString();
			}
			else
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +"TransducerTestSecondaryConnection Error : " + dResponse.iReturnValue.ToString();
				if (dResponse.iReturnValue == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(dResponse.syserrno);
			}		
		}

		private void B_SecondaryShortCircuitTest_Click(object sender, System.EventArgs e)
		{
			MX370x.DefaultResponse dResponse;
			UInt64 ulValue = 0;
			UInt64 ulChannel = 0;

			ulChannel = (UInt64)NUD_ChannelSelection.Value;
			dResponse = MX_370x.TransducerTestSecondaryShortCircuit(ulChannel-1,out ulValue);
			if (dResponse.iReturnValue == 0)
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +  "TransducerTestSecondaryShortCircuit OK Channel:"+ ulChannel.ToString()+" Status :" + ulValue.ToString();
			}
			else
			{
				TB_Values.Text = TB_Values.Text + Environment.NewLine +"TransducerTestSecondaryShortCircuit Error : " + dResponse.iReturnValue.ToString();
				if (dResponse.iReturnValue == -1)
					TB_Values.Text = TB_Values.Text + " "+ s_GetSysErrnoString(dResponse.syserrno);
			}			
		}

		private void B_Start_Click(object sender, System.EventArgs e)
		{
			TB_Event.Text = "Open the socket and try to connect ..." + Environment.NewLine;
			TB_Event.Refresh();

			try
			{
				SocketClient = new TcpClient();

				// Open the socket connection to receive the event
				SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "."+
					TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text,6363);

				SocketClient.ReceiveBufferSize = 1048576;

				TB_Event.Text = TB_Event.Text  +  "Socket connected" + Environment.NewLine;
				TB_Event.Refresh();

				stream = SocketClient.GetStream();

				timer1.Enabled = true;
				B_Stop.Enabled = true;
				B_Start.Enabled = false;

			
			}
			catch(Exception ex)
			{
				TB_Event.Text = "Exception occur : " + ex.Message;
			}

		}

		private void B_Stop_Click(object sender, System.EventArgs e)
		{
			timer1.Enabled = false;

			try
			{
				// Close the stream connection
				stream.Close();
			}
			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			try
			{
				// Close the socket connection
				SocketClient.Close();
			}
			catch(Exception ex)
			{
				TB_Values.Text = "Exception occur : " + ex.Message;
			}

			B_Start.Enabled = true;
			B_Stop.Enabled = false;
		}
		
		private void timer1_Tick(object sender, System.EventArgs e)
		{
			int i_Receive = 0;
			byte [] buffer;
			byte [] b_EventFormat;
			byte [] b_EventSize;
			
			b_EventFormat = new byte [1];
			b_EventSize = new byte [1];
			buffer = new byte [255];

			try
			{
				// Test if data available
				if( stream.DataAvailable == true)
					// Read the event format
					i_Receive = stream.Read(b_EventFormat,0,1);

				if (b_EventFormat[0] == 0) 
				{
					// Test if data available
					if( stream.DataAvailable == true)
						// Read the event size
						i_Receive = stream.Read(b_EventSize,0,1);

					// Test if data available
					if( stream.DataAvailable == true)
						// Read the event
						i_Receive = stream.Read(buffer,0,b_EventSize[0]);
                    

				}
				else
				{
					TB_Event.Text = TB_Event.Text + "Event format not recognized" + Environment.NewLine;
					timer1.Enabled = false;
					B_Stop_Click(sender,e);
				}


			}
			catch(Exception ex)
			{
				TB_Event.Text = TB_Event.Text + "Exception occur : " + ex.Message + Environment.NewLine;
				timer1.Enabled = false;
				B_Stop_Click(sender,e);
			}
						
			if (i_Receive == b_EventSize[0])
			{
				// Test the event type
				if (buffer [0] == S_IODRIVER)
					TB_Event.Text = TB_Event.Text + "ioDriver event received, Status :" + buffer[1].ToString() + Environment.NewLine;
			}
		}
	}
}
