using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDIControls;
using AddiData.ADDISocket;
using AddiData;
using System.Text.RegularExpressions;



namespace MinMax
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_MinMax : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.GroupBox GB_Frequency;
		internal System.Windows.Forms.ComboBox CB_TimeDivision;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.GroupBox GB_StopCondition;
        internal System.Windows.Forms.TextBox TB_StopValue;
        internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.Button B_StopMinMax;
		internal System.Windows.Forms.Button B_StartMinMax;
        internal System.Windows.Forms.TextBox Display;
		private System.Windows.Forms.GroupBox GB_MinMaxConfig;
		internal System.Windows.Forms.CheckBox CHB_Channel15;
		internal System.Windows.Forms.CheckBox CHB_Channel14;
		internal System.Windows.Forms.CheckBox CHB_Channel13;
		internal System.Windows.Forms.CheckBox CHB_Channel12;
		internal System.Windows.Forms.CheckBox CHB_Channel11;
		internal System.Windows.Forms.CheckBox CHB_Channel10;
		internal System.Windows.Forms.CheckBox CHB_Channel9;
		internal System.Windows.Forms.CheckBox CHB_Channel8;
		internal System.Windows.Forms.CheckBox CHB_Channel7;
		internal System.Windows.Forms.CheckBox CHB_Channel6;
		internal System.Windows.Forms.CheckBox CHB_Channel5;
		internal System.Windows.Forms.CheckBox CHB_Channel4;
		internal System.Windows.Forms.CheckBox CHB_Channel3;
		internal System.Windows.Forms.CheckBox CHB_Channel2;
		internal System.Windows.Forms.CheckBox CHB_Channel1;
		internal System.Windows.Forms.CheckBox CHB_Channel0;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.GroupBox GB_ModuleSelectionBox;
		internal System.Windows.Forms.Button B_GetModuleInformation;
		internal System.Windows.Forms.Label L_MXModuleIdentifier;
		internal System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		internal System.Windows.Forms.Label label3;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.TextBox TB_IPAddress_3;
		internal System.Windows.Forms.TextBox TB_IPAddress_2;
		internal System.Windows.Forms.TextBox TB_IPAddress_1;
		internal System.Windows.Forms.TextBox TB_IPAddress_0;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.GroupBox GB_TransducerSelectionBox;
		internal System.Windows.Forms.TextBox TB_TransducerTypeInfo;
		private System.Windows.Forms.Label label7;
		internal System.Windows.Forms.Label L_NbrOfTransducerType;
		internal System.Windows.Forms.Label label6;
		internal System.Windows.Forms.ComboBox CB_TransducerType;
        private System.Windows.Forms.Timer DisplayTimer;
        private System.Windows.Forms.Timer ReadTimer;
        internal CheckBox CHB_Channel15Stop;
        internal CheckBox CHB_Channel14Stop;
        internal CheckBox CHB_Channel13Stop;
        internal CheckBox CHB_Channel12Stop;
        internal CheckBox CHB_Channel11Stop;
        internal CheckBox CHB_Channel10Stop;
        internal CheckBox CHB_Channel9Stop;
        internal CheckBox CHB_Channel8Stop;
        internal CheckBox CHB_Channel7Stop;
        internal CheckBox CHB_Channel6Stop;
        internal CheckBox CHB_Channel5Stop;
        internal CheckBox CHB_Channel4Stop;
        internal CheckBox CHB_Channel3Stop;
        internal CheckBox CHB_Channel2Stop;
        internal CheckBox CHB_Channel1Stop;
        internal CheckBox CHB_Channel0Stop;
        internal Label label8;
        private Label label10;
        private RadioButton RB_Greater;
        private RadioButton RB_Less;
		private System.ComponentModel.IContainer components;

		public F_MinMax()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_MinMax));
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.GB_Frequency = new System.Windows.Forms.GroupBox();
            this.CB_TimeDivision = new System.Windows.Forms.ComboBox();
            this.Label19 = new System.Windows.Forms.Label();
            this.GB_StopCondition = new System.Windows.Forms.GroupBox();
            this.CHB_Channel15Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel14Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel13Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel12Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel11Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel10Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel9Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel8Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel7Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel6Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel5Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel4Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel3Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel2Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel1Stop = new System.Windows.Forms.CheckBox();
            this.CHB_Channel0Stop = new System.Windows.Forms.CheckBox();
            this.label8 = new System.Windows.Forms.Label();
            this.TB_StopValue = new System.Windows.Forms.TextBox();
            this.Label20 = new System.Windows.Forms.Label();
            this.B_StopMinMax = new System.Windows.Forms.Button();
            this.B_StartMinMax = new System.Windows.Forms.Button();
            this.Display = new System.Windows.Forms.TextBox();
            this.GB_MinMaxConfig = new System.Windows.Forms.GroupBox();
            this.CHB_Channel15 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel14 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel13 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel12 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel11 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel10 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel9 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel8 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel7 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel6 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel5 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel4 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel3 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel2 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel1 = new System.Windows.Forms.CheckBox();
            this.CHB_Channel0 = new System.Windows.Forms.CheckBox();
            this.Label9 = new System.Windows.Forms.Label();
            this.GB_ModuleSelectionBox = new System.Windows.Forms.GroupBox();
            this.B_GetModuleInformation = new System.Windows.Forms.Button();
            this.L_MXModuleIdentifier = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_TransducerSelectionBox = new System.Windows.Forms.GroupBox();
            this.TB_TransducerTypeInfo = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.L_NbrOfTransducerType = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_TransducerType = new System.Windows.Forms.ComboBox();
            this.ReadTimer = new System.Windows.Forms.Timer(this.components);
            this.RB_Less = new System.Windows.Forms.RadioButton();
            this.RB_Greater = new System.Windows.Forms.RadioButton();
            this.label10 = new System.Windows.Forms.Label();
            this.GB_Frequency.SuspendLayout();
            this.GB_StopCondition.SuspendLayout();
            this.GB_MinMaxConfig.SuspendLayout();
            this.GB_ModuleSelectionBox.SuspendLayout();
            this.GB_TransducerSelectionBox.SuspendLayout();
            this.SuspendLayout();
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // GB_Frequency
            // 
            this.GB_Frequency.Controls.Add(this.CB_TimeDivision);
            this.GB_Frequency.Controls.Add(this.Label19);
            this.GB_Frequency.Location = new System.Drawing.Point(16, 449);
            this.GB_Frequency.Name = "GB_Frequency";
            this.GB_Frequency.Size = new System.Drawing.Size(304, 56);
            this.GB_Frequency.TabIndex = 156;
            this.GB_Frequency.TabStop = false;
            this.GB_Frequency.Text = "Frequency time division configuration";
            // 
            // CB_TimeDivision
            // 
            this.CB_TimeDivision.Items.AddRange(new object[] {
            "5",
            "6",
            "7",
            "8",
            "9",
            "10",
            "11",
            "12",
            "13",
            "14",
            "15",
            "16",
            "17",
            "18",
            "19",
            "20",
            "21",
            "22",
            "23",
            "24",
            "25",
            "26",
            "27",
            "28",
            "29",
            "30",
            "31",
            "32",
            "33",
            "34",
            "35",
            "36",
            "37",
            "38",
            "39",
            "40",
            "41",
            "42",
            "43",
            "44",
            "45",
            "46",
            "47",
            "48",
            "49",
            "50",
            "51",
            "52",
            "53",
            "54",
            "55",
            "56",
            "57",
            "58",
            "59",
            "60",
            "61",
            "62",
            "63",
            "64",
            "65",
            "66",
            "67",
            "68",
            "69",
            "70",
            "71",
            "72",
            "73",
            "74",
            "75",
            "76",
            "77",
            "78",
            "79",
            "80",
            "81",
            "82",
            "83",
            "84",
            "85",
            "86",
            "87",
            "88",
            "89",
            "90",
            "91",
            "92",
            "93",
            "94",
            "95",
            "96",
            "97",
            "98",
            "99",
            "100",
            "101",
            "102",
            "103",
            "104",
            "105",
            "106",
            "107",
            "108",
            "109",
            "110",
            "111",
            "112",
            "113",
            "114",
            "115",
            "116",
            "117",
            "118",
            "119",
            "120",
            "121",
            "122",
            "123",
            "124",
            "125",
            "126",
            "127",
            "128",
            "129",
            "130",
            "131",
            "132",
            "133",
            "134",
            "135",
            "136",
            "137",
            "138",
            "139",
            "140",
            "141",
            "142",
            "143",
            "144",
            "145",
            "146",
            "147",
            "148",
            "149",
            "150",
            "151",
            "152",
            "153",
            "154",
            "155",
            "156",
            "157",
            "158",
            "159",
            "160",
            "161",
            "162",
            "163",
            "164",
            "165",
            "166",
            "167",
            "168",
            "169",
            "170",
            "171",
            "172",
            "173",
            "174",
            "175",
            "176",
            "177",
            "178",
            "179",
            "180",
            "181",
            "182",
            "183",
            "184",
            "185",
            "186",
            "187",
            "188",
            "189",
            "190",
            "191",
            "192",
            "193",
            "194",
            "195",
            "196",
            "197",
            "198",
            "199",
            "200",
            "201",
            "202",
            "203",
            "204",
            "205",
            "206",
            "207",
            "208",
            "209",
            "210",
            "211",
            "212",
            "213",
            "214",
            "215",
            "216",
            "217",
            "218",
            "219",
            "220",
            "221",
            "222",
            "223",
            "224",
            "225",
            "226",
            "227",
            "228",
            "229",
            "230",
            "231",
            "232",
            "233",
            "234",
            "235",
            "236",
            "237",
            "238",
            "239",
            "240",
            "241",
            "242",
            "243",
            "244",
            "245",
            "246",
            "247",
            "248",
            "249",
            "250",
            "251",
            "252",
            "253",
            "254",
            "255"});
            this.CB_TimeDivision.Location = new System.Drawing.Point(240, 24);
            this.CB_TimeDivision.Name = "CB_TimeDivision";
            this.CB_TimeDivision.Size = new System.Drawing.Size(48, 21);
            this.CB_TimeDivision.TabIndex = 147;
            this.CB_TimeDivision.Text = "15";
            // 
            // Label19
            // 
            this.Label19.Location = new System.Drawing.Point(13, 29);
            this.Label19.Name = "Label19";
            this.Label19.Size = new System.Drawing.Size(224, 16);
            this.Label19.TabIndex = 146;
            this.Label19.Text = "Frequency time division factor (minimal 5) :";
            // 
            // GB_StopCondition
            // 
            this.GB_StopCondition.Controls.Add(this.label10);
            this.GB_StopCondition.Controls.Add(this.RB_Greater);
            this.GB_StopCondition.Controls.Add(this.RB_Less);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel15Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel14Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel13Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel12Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel11Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel10Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel9Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel8Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel7Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel6Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel5Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel4Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel3Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel2Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel1Stop);
            this.GB_StopCondition.Controls.Add(this.CHB_Channel0Stop);
            this.GB_StopCondition.Controls.Add(this.label8);
            this.GB_StopCondition.Controls.Add(this.TB_StopValue);
            this.GB_StopCondition.Controls.Add(this.Label20);
            this.GB_StopCondition.Location = new System.Drawing.Point(16, 304);
            this.GB_StopCondition.Name = "GB_StopCondition";
            this.GB_StopCondition.Size = new System.Drawing.Size(888, 112);
            this.GB_StopCondition.TabIndex = 155;
            this.GB_StopCondition.TabStop = false;
            this.GB_StopCondition.Text = "Stop condition";
            // 
            // CHB_Channel15Stop
            // 
            this.CHB_Channel15Stop.Location = new System.Drawing.Point(824, 58);
            this.CHB_Channel15Stop.Name = "CHB_Channel15Stop";
            this.CHB_Channel15Stop.Size = new System.Drawing.Size(56, 24);
            this.CHB_Channel15Stop.TabIndex = 176;
            this.CHB_Channel15Stop.Text = "Ch 16";
            // 
            // CHB_Channel14Stop
            // 
            this.CHB_Channel14Stop.Location = new System.Drawing.Point(776, 58);
            this.CHB_Channel14Stop.Name = "CHB_Channel14Stop";
            this.CHB_Channel14Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel14Stop.TabIndex = 175;
            this.CHB_Channel14Stop.Text = "Ch 15";
            // 
            // CHB_Channel13Stop
            // 
            this.CHB_Channel13Stop.Location = new System.Drawing.Point(728, 58);
            this.CHB_Channel13Stop.Name = "CHB_Channel13Stop";
            this.CHB_Channel13Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel13Stop.TabIndex = 174;
            this.CHB_Channel13Stop.Text = "Ch 14";
            // 
            // CHB_Channel12Stop
            // 
            this.CHB_Channel12Stop.Location = new System.Drawing.Point(680, 58);
            this.CHB_Channel12Stop.Name = "CHB_Channel12Stop";
            this.CHB_Channel12Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel12Stop.TabIndex = 173;
            this.CHB_Channel12Stop.Text = "Ch 13";
            // 
            // CHB_Channel11Stop
            // 
            this.CHB_Channel11Stop.Location = new System.Drawing.Point(632, 58);
            this.CHB_Channel11Stop.Name = "CHB_Channel11Stop";
            this.CHB_Channel11Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel11Stop.TabIndex = 172;
            this.CHB_Channel11Stop.Text = "Ch 12";
            // 
            // CHB_Channel10Stop
            // 
            this.CHB_Channel10Stop.Location = new System.Drawing.Point(584, 58);
            this.CHB_Channel10Stop.Name = "CHB_Channel10Stop";
            this.CHB_Channel10Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel10Stop.TabIndex = 171;
            this.CHB_Channel10Stop.Text = "Ch 11";
            // 
            // CHB_Channel9Stop
            // 
            this.CHB_Channel9Stop.Location = new System.Drawing.Point(536, 58);
            this.CHB_Channel9Stop.Name = "CHB_Channel9Stop";
            this.CHB_Channel9Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel9Stop.TabIndex = 170;
            this.CHB_Channel9Stop.Text = "Ch 10";
            // 
            // CHB_Channel8Stop
            // 
            this.CHB_Channel8Stop.Location = new System.Drawing.Point(488, 58);
            this.CHB_Channel8Stop.Name = "CHB_Channel8Stop";
            this.CHB_Channel8Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel8Stop.TabIndex = 169;
            this.CHB_Channel8Stop.Text = "Ch 9";
            // 
            // CHB_Channel7Stop
            // 
            this.CHB_Channel7Stop.Location = new System.Drawing.Point(440, 58);
            this.CHB_Channel7Stop.Name = "CHB_Channel7Stop";
            this.CHB_Channel7Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel7Stop.TabIndex = 168;
            this.CHB_Channel7Stop.Text = "Ch 8";
            // 
            // CHB_Channel6Stop
            // 
            this.CHB_Channel6Stop.Location = new System.Drawing.Point(392, 58);
            this.CHB_Channel6Stop.Name = "CHB_Channel6Stop";
            this.CHB_Channel6Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel6Stop.TabIndex = 167;
            this.CHB_Channel6Stop.Text = "Ch 7";
            // 
            // CHB_Channel5Stop
            // 
            this.CHB_Channel5Stop.Location = new System.Drawing.Point(344, 58);
            this.CHB_Channel5Stop.Name = "CHB_Channel5Stop";
            this.CHB_Channel5Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel5Stop.TabIndex = 166;
            this.CHB_Channel5Stop.Text = "Ch 6";
            // 
            // CHB_Channel4Stop
            // 
            this.CHB_Channel4Stop.Location = new System.Drawing.Point(296, 58);
            this.CHB_Channel4Stop.Name = "CHB_Channel4Stop";
            this.CHB_Channel4Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel4Stop.TabIndex = 165;
            this.CHB_Channel4Stop.Text = "Ch 5";
            // 
            // CHB_Channel3Stop
            // 
            this.CHB_Channel3Stop.Location = new System.Drawing.Point(248, 58);
            this.CHB_Channel3Stop.Name = "CHB_Channel3Stop";
            this.CHB_Channel3Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel3Stop.TabIndex = 164;
            this.CHB_Channel3Stop.Text = "Ch 4";
            // 
            // CHB_Channel2Stop
            // 
            this.CHB_Channel2Stop.Location = new System.Drawing.Point(200, 58);
            this.CHB_Channel2Stop.Name = "CHB_Channel2Stop";
            this.CHB_Channel2Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel2Stop.TabIndex = 163;
            this.CHB_Channel2Stop.Text = "Ch 3";
            // 
            // CHB_Channel1Stop
            // 
            this.CHB_Channel1Stop.Location = new System.Drawing.Point(152, 58);
            this.CHB_Channel1Stop.Name = "CHB_Channel1Stop";
            this.CHB_Channel1Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel1Stop.TabIndex = 162;
            this.CHB_Channel1Stop.Text = "Ch 2";
            // 
            // CHB_Channel0Stop
            // 
            this.CHB_Channel0Stop.Checked = true;
            this.CHB_Channel0Stop.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CHB_Channel0Stop.Location = new System.Drawing.Point(104, 58);
            this.CHB_Channel0Stop.Name = "CHB_Channel0Stop";
            this.CHB_Channel0Stop.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel0Stop.TabIndex = 161;
            this.CHB_Channel0Stop.Text = "Ch 1";
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(8, 62);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(104, 20);
            this.label8.TabIndex = 160;
            this.label8.Text = "Channel selection:";
            // 
            // TB_StopValue
            // 
            this.TB_StopValue.Location = new System.Drawing.Point(334, 20);
            this.TB_StopValue.Name = "TB_StopValue";
            this.TB_StopValue.Size = new System.Drawing.Size(104, 20);
            this.TB_StopValue.TabIndex = 18;
            this.TB_StopValue.Text = "1";
            this.TB_StopValue.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // Label20
            // 
            this.Label20.Location = new System.Drawing.Point(197, 26);
            this.Label20.Name = "Label20";
            this.Label20.Size = new System.Drawing.Size(140, 14);
            this.Label20.TabIndex = 11;
            this.Label20.Text = "Stop value (0 to 16777215):";
            // 
            // B_StopMinMax
            // 
            this.B_StopMinMax.Enabled = false;
            this.B_StopMinMax.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StopMinMax.Location = new System.Drawing.Point(600, 504);
            this.B_StopMinMax.Name = "B_StopMinMax";
            this.B_StopMinMax.Size = new System.Drawing.Size(304, 32);
            this.B_StopMinMax.TabIndex = 154;
            this.B_StopMinMax.Text = "Stop min max";
            this.B_StopMinMax.Click += new System.EventHandler(this.B_StopMinMax_Click);
            // 
            // B_StartMinMax
            // 
            this.B_StartMinMax.Enabled = false;
            this.B_StartMinMax.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_StartMinMax.Location = new System.Drawing.Point(600, 464);
            this.B_StartMinMax.Name = "B_StartMinMax";
            this.B_StartMinMax.Size = new System.Drawing.Size(304, 32);
            this.B_StartMinMax.TabIndex = 153;
            this.B_StartMinMax.Text = "Start min max";
            this.B_StartMinMax.Click += new System.EventHandler(this.B_StartMinMax_Click);
            // 
            // Display
            // 
            this.Display.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Display.Location = new System.Drawing.Point(16, 552);
            this.Display.Multiline = true;
            this.Display.Name = "Display";
            this.Display.ReadOnly = true;
            this.Display.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.Display.Size = new System.Drawing.Size(888, 255);
            this.Display.TabIndex = 152;
            // 
            // GB_MinMaxConfig
            // 
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel15);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel14);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel13);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel12);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel11);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel10);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel9);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel8);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel7);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel6);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel5);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel4);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel3);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel2);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel1);
            this.GB_MinMaxConfig.Controls.Add(this.CHB_Channel0);
            this.GB_MinMaxConfig.Controls.Add(this.Label9);
            this.GB_MinMaxConfig.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_MinMaxConfig.Location = new System.Drawing.Point(16, 224);
            this.GB_MinMaxConfig.Name = "GB_MinMaxConfig";
            this.GB_MinMaxConfig.Size = new System.Drawing.Size(888, 72);
            this.GB_MinMaxConfig.TabIndex = 149;
            this.GB_MinMaxConfig.TabStop = false;
            this.GB_MinMaxConfig.Text = "Auto refresh configuration";
            // 
            // CHB_Channel15
            // 
            this.CHB_Channel15.Location = new System.Drawing.Point(824, 32);
            this.CHB_Channel15.Name = "CHB_Channel15";
            this.CHB_Channel15.Size = new System.Drawing.Size(56, 24);
            this.CHB_Channel15.TabIndex = 159;
            this.CHB_Channel15.Text = "Ch 16";
            // 
            // CHB_Channel14
            // 
            this.CHB_Channel14.Location = new System.Drawing.Point(776, 32);
            this.CHB_Channel14.Name = "CHB_Channel14";
            this.CHB_Channel14.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel14.TabIndex = 158;
            this.CHB_Channel14.Text = "Ch 15";
            // 
            // CHB_Channel13
            // 
            this.CHB_Channel13.Location = new System.Drawing.Point(728, 32);
            this.CHB_Channel13.Name = "CHB_Channel13";
            this.CHB_Channel13.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel13.TabIndex = 157;
            this.CHB_Channel13.Text = "Ch 14";
            // 
            // CHB_Channel12
            // 
            this.CHB_Channel12.Location = new System.Drawing.Point(680, 32);
            this.CHB_Channel12.Name = "CHB_Channel12";
            this.CHB_Channel12.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel12.TabIndex = 156;
            this.CHB_Channel12.Text = "Ch 13";
            // 
            // CHB_Channel11
            // 
            this.CHB_Channel11.Location = new System.Drawing.Point(632, 32);
            this.CHB_Channel11.Name = "CHB_Channel11";
            this.CHB_Channel11.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel11.TabIndex = 155;
            this.CHB_Channel11.Text = "Ch 12";
            // 
            // CHB_Channel10
            // 
            this.CHB_Channel10.Location = new System.Drawing.Point(584, 32);
            this.CHB_Channel10.Name = "CHB_Channel10";
            this.CHB_Channel10.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel10.TabIndex = 154;
            this.CHB_Channel10.Text = "Ch 11";
            // 
            // CHB_Channel9
            // 
            this.CHB_Channel9.Location = new System.Drawing.Point(536, 32);
            this.CHB_Channel9.Name = "CHB_Channel9";
            this.CHB_Channel9.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel9.TabIndex = 153;
            this.CHB_Channel9.Text = "Ch 10";
            // 
            // CHB_Channel8
            // 
            this.CHB_Channel8.Location = new System.Drawing.Point(488, 32);
            this.CHB_Channel8.Name = "CHB_Channel8";
            this.CHB_Channel8.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel8.TabIndex = 152;
            this.CHB_Channel8.Text = "Ch 9";
            // 
            // CHB_Channel7
            // 
            this.CHB_Channel7.Location = new System.Drawing.Point(440, 32);
            this.CHB_Channel7.Name = "CHB_Channel7";
            this.CHB_Channel7.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel7.TabIndex = 151;
            this.CHB_Channel7.Text = "Ch 8";
            // 
            // CHB_Channel6
            // 
            this.CHB_Channel6.Location = new System.Drawing.Point(392, 32);
            this.CHB_Channel6.Name = "CHB_Channel6";
            this.CHB_Channel6.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel6.TabIndex = 150;
            this.CHB_Channel6.Text = "Ch 7";
            // 
            // CHB_Channel5
            // 
            this.CHB_Channel5.Location = new System.Drawing.Point(344, 32);
            this.CHB_Channel5.Name = "CHB_Channel5";
            this.CHB_Channel5.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel5.TabIndex = 149;
            this.CHB_Channel5.Text = "Ch 6";
            // 
            // CHB_Channel4
            // 
            this.CHB_Channel4.Location = new System.Drawing.Point(296, 32);
            this.CHB_Channel4.Name = "CHB_Channel4";
            this.CHB_Channel4.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel4.TabIndex = 148;
            this.CHB_Channel4.Text = "Ch 5";
            // 
            // CHB_Channel3
            // 
            this.CHB_Channel3.Location = new System.Drawing.Point(248, 32);
            this.CHB_Channel3.Name = "CHB_Channel3";
            this.CHB_Channel3.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel3.TabIndex = 147;
            this.CHB_Channel3.Text = "Ch 4";
            // 
            // CHB_Channel2
            // 
            this.CHB_Channel2.Location = new System.Drawing.Point(200, 32);
            this.CHB_Channel2.Name = "CHB_Channel2";
            this.CHB_Channel2.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel2.TabIndex = 146;
            this.CHB_Channel2.Text = "Ch 3";
            // 
            // CHB_Channel1
            // 
            this.CHB_Channel1.Location = new System.Drawing.Point(152, 32);
            this.CHB_Channel1.Name = "CHB_Channel1";
            this.CHB_Channel1.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel1.TabIndex = 145;
            this.CHB_Channel1.Text = "Ch 2";
            // 
            // CHB_Channel0
            // 
            this.CHB_Channel0.Checked = true;
            this.CHB_Channel0.CheckState = System.Windows.Forms.CheckState.Checked;
            this.CHB_Channel0.Location = new System.Drawing.Point(104, 32);
            this.CHB_Channel0.Name = "CHB_Channel0";
            this.CHB_Channel0.Size = new System.Drawing.Size(64, 24);
            this.CHB_Channel0.TabIndex = 144;
            this.CHB_Channel0.Text = "Ch 1";
            // 
            // Label9
            // 
            this.Label9.Location = new System.Drawing.Point(8, 36);
            this.Label9.Name = "Label9";
            this.Label9.Size = new System.Drawing.Size(104, 20);
            this.Label9.TabIndex = 123;
            this.Label9.Text = "Channel selection:";
            // 
            // GB_ModuleSelectionBox
            // 
            this.GB_ModuleSelectionBox.Controls.Add(this.B_GetModuleInformation);
            this.GB_ModuleSelectionBox.Controls.Add(this.L_MXModuleIdentifier);
            this.GB_ModuleSelectionBox.Controls.Add(this.label5);
            this.GB_ModuleSelectionBox.Controls.Add(this.label4);
            this.GB_ModuleSelectionBox.Controls.Add(this.label3);
            this.GB_ModuleSelectionBox.Controls.Add(this.label2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleSelectionBox.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleSelectionBox.Controls.Add(this.label1);
            this.GB_ModuleSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_ModuleSelectionBox.Location = new System.Drawing.Point(16, 8);
            this.GB_ModuleSelectionBox.Name = "GB_ModuleSelectionBox";
            this.GB_ModuleSelectionBox.Size = new System.Drawing.Size(512, 208);
            this.GB_ModuleSelectionBox.TabIndex = 148;
            this.GB_ModuleSelectionBox.TabStop = false;
            this.GB_ModuleSelectionBox.Text = "Module selection";
            // 
            // B_GetModuleInformation
            // 
            this.B_GetModuleInformation.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.B_GetModuleInformation.Location = new System.Drawing.Point(384, 24);
            this.B_GetModuleInformation.Name = "B_GetModuleInformation";
            this.B_GetModuleInformation.Size = new System.Drawing.Size(112, 33);
            this.B_GetModuleInformation.TabIndex = 43;
            this.B_GetModuleInformation.Text = "&Connection to module";
            this.B_GetModuleInformation.Click += new System.EventHandler(this.B_GetModuleInformation_Click);
            // 
            // L_MXModuleIdentifier
            // 
            this.L_MXModuleIdentifier.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_MXModuleIdentifier.Location = new System.Drawing.Point(176, 72);
            this.L_MXModuleIdentifier.Name = "L_MXModuleIdentifier";
            this.L_MXModuleIdentifier.Size = new System.Drawing.Size(320, 120);
            this.L_MXModuleIdentifier.TabIndex = 42;
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(16, 72);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(132, 23);
            this.label5.TabIndex = 41;
            this.label5.Text = "MX Module Identifier :";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(328, 32);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 40;
            this.label4.Text = "-";
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(272, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(216, 32);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 38;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_3.Location = new System.Drawing.Point(336, 32);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_3.TabIndex = 37;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_2.Location = new System.Drawing.Point(288, 32);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_2.TabIndex = 36;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_1.Location = new System.Drawing.Point(232, 32);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_1.TabIndex = 35;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(176, 32);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(36, 21);
            this.TB_IPAddress_0.TabIndex = 34;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(16, 32);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(160, 16);
            this.label1.TabIndex = 33;
            this.label1.Text = "IP Address of the MX Module :";
            // 
            // GB_TransducerSelectionBox
            // 
            this.GB_TransducerSelectionBox.Controls.Add(this.TB_TransducerTypeInfo);
            this.GB_TransducerSelectionBox.Controls.Add(this.label7);
            this.GB_TransducerSelectionBox.Controls.Add(this.L_NbrOfTransducerType);
            this.GB_TransducerSelectionBox.Controls.Add(this.label6);
            this.GB_TransducerSelectionBox.Controls.Add(this.CB_TransducerType);
            this.GB_TransducerSelectionBox.Enabled = false;
            this.GB_TransducerSelectionBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.GB_TransducerSelectionBox.Location = new System.Drawing.Point(536, 8);
            this.GB_TransducerSelectionBox.Name = "GB_TransducerSelectionBox";
            this.GB_TransducerSelectionBox.Size = new System.Drawing.Size(368, 208);
            this.GB_TransducerSelectionBox.TabIndex = 147;
            this.GB_TransducerSelectionBox.TabStop = false;
            this.GB_TransducerSelectionBox.Text = "Module transducer type selection";
            // 
            // TB_TransducerTypeInfo
            // 
            this.TB_TransducerTypeInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.TB_TransducerTypeInfo.Location = new System.Drawing.Point(16, 80);
            this.TB_TransducerTypeInfo.Multiline = true;
            this.TB_TransducerTypeInfo.Name = "TB_TransducerTypeInfo";
            this.TB_TransducerTypeInfo.ReadOnly = true;
            this.TB_TransducerTypeInfo.Size = new System.Drawing.Size(336, 112);
            this.TB_TransducerTypeInfo.TabIndex = 43;
            // 
            // label7
            // 
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label7.Location = new System.Drawing.Point(16, 48);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(144, 24);
            this.label7.TabIndex = 42;
            this.label7.Text = "Transducer type selection :";
            // 
            // L_NbrOfTransducerType
            // 
            this.L_NbrOfTransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_NbrOfTransducerType.Location = new System.Drawing.Point(160, 24);
            this.L_NbrOfTransducerType.Name = "L_NbrOfTransducerType";
            this.L_NbrOfTransducerType.Size = new System.Drawing.Size(24, 23);
            this.L_NbrOfTransducerType.TabIndex = 41;
            this.L_NbrOfTransducerType.Text = "0";
            // 
            // label6
            // 
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(16, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(144, 23);
            this.label6.TabIndex = 40;
            this.label6.Text = "Nbr of transducer type       :";
            // 
            // CB_TransducerType
            // 
            this.CB_TransducerType.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.CB_TransducerType.Location = new System.Drawing.Point(160, 48);
            this.CB_TransducerType.Name = "CB_TransducerType";
            this.CB_TransducerType.Size = new System.Drawing.Size(192, 21);
            this.CB_TransducerType.TabIndex = 39;
            this.CB_TransducerType.SelectedIndexChanged += new System.EventHandler(this.CB_TransducerType_SelectedIndexChanged);
            // 
            // ReadTimer
            // 
            this.ReadTimer.Interval = 1;
            this.ReadTimer.Tick += new System.EventHandler(this.ReadTimer_Tick);
            // 
            // RB_Less
            // 
            this.RB_Less.AutoSize = true;
            this.RB_Less.Checked = true;
            this.RB_Less.Location = new System.Drawing.Point(104, 23);
            this.RB_Less.Name = "RB_Less";
            this.RB_Less.Size = new System.Drawing.Size(31, 17);
            this.RB_Less.TabIndex = 177;
            this.RB_Less.TabStop = true;
            this.RB_Less.Text = "<";
            this.RB_Less.UseVisualStyleBackColor = true;
            // 
            // RB_Greater
            // 
            this.RB_Greater.AutoSize = true;
            this.RB_Greater.Location = new System.Drawing.Point(139, 23);
            this.RB_Greater.Name = "RB_Greater";
            this.RB_Greater.Size = new System.Drawing.Size(31, 17);
            this.RB_Greater.TabIndex = 178;
            this.RB_Greater.Text = ">";
            this.RB_Greater.UseVisualStyleBackColor = true;
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 25);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(78, 13);
            this.label10.TabIndex = 179;
            this.label10.Text = "Stop condition:";
            // 
            // F_MinMax
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(944, 819);
            this.Controls.Add(this.GB_Frequency);
            this.Controls.Add(this.GB_StopCondition);
            this.Controls.Add(this.B_StopMinMax);
            this.Controls.Add(this.B_StartMinMax);
            this.Controls.Add(this.Display);
            this.Controls.Add(this.GB_MinMaxConfig);
            this.Controls.Add(this.GB_ModuleSelectionBox);
            this.Controls.Add(this.GB_TransducerSelectionBox);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_MinMax";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Min Max C#";
            this.Load += new System.EventHandler(this.F_MinMax_Load);
            this.Closed += new System.EventHandler(this.F_MinMax_Closed);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.F_MinMax_FormClosing);
            this.GB_Frequency.ResumeLayout(false);
            this.GB_StopCondition.ResumeLayout(false);
            this.GB_StopCondition.PerformLayout();
            this.GB_MinMaxConfig.ResumeLayout(false);
            this.GB_ModuleSelectionBox.ResumeLayout(false);
            this.GB_ModuleSelectionBox.PerformLayout();
            this.GB_TransducerSelectionBox.ResumeLayout(false);
            this.GB_TransducerSelectionBox.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_MinMax());
		}


		// Global Variable
		MXCommon.MXCommon MX_Global;
		MX370x.MX370x     MX_370x;
        String            DisplayText  = "";

        UInt64 ChannelMask;
        UInt64 StopChannelMask;
        UInt32 NbrOfChannel;
        CheckBox[] s_CHB_MinMax;
        CheckBox[] s_CHB_StopMinMax;

        /// <summary>
        /// Get the number of transducers of the system (i.e. The number of available acquisition channels)
        /// </summary>
        /// <param name="s_ModuleType">A string that represents the module type (obtain it using GetModuleType function)</param>
        /// <returns></returns>
		private UInt32 ul_GetNbrOfTransducerChannel (string s_ModuleType)
		{
            Match reg = null;

            // Check the MX37XX-IO-TYPE
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-([0-9]+)-[a-zA-Z]+");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Check the MX37XX-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MX37[0-9]+-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Check the MSX-E37XX-DIO-TYPE-IO
            reg = Regex.Match(s_ModuleType, @"MSX-E37[0-9]+-DIO-[a-zA-Z]+-([0-9]+)");
            if (reg.Success)
                return Convert.ToUInt32(reg.Groups[1].Value);

            // Fail
            return 0;
		}

		
		private void F_MinMax_Load(object sender, System.EventArgs e)
		{
			MX_Global = new MXCommon.MXCommon();
			MX_370x = new MX370x.MX370x();
			MX_Global.Timeout = 2000;
			MX_370x.Timeout = 2000;

			s_CHB_MinMax = new CheckBox[] {CHB_Channel0, CHB_Channel1, CHB_Channel2, CHB_Channel3, 
                                                CHB_Channel4, CHB_Channel5, CHB_Channel6, CHB_Channel7, 
                                                CHB_Channel8, CHB_Channel9, CHB_Channel10, CHB_Channel11, 
                                                CHB_Channel12, CHB_Channel13, CHB_Channel14, CHB_Channel15};
            s_CHB_StopMinMax = new CheckBox[] {CHB_Channel0Stop, CHB_Channel1Stop, CHB_Channel2Stop, CHB_Channel3Stop, 
                                                CHB_Channel4Stop, CHB_Channel5Stop, CHB_Channel6Stop, CHB_Channel7Stop, 
                                                CHB_Channel8Stop, CHB_Channel9Stop, CHB_Channel10Stop, CHB_Channel11Stop, 
                                                CHB_Channel12Stop, CHB_Channel13Stop, CHB_Channel14Stop, CHB_Channel15Stop};
		}

		private void F_MinMax_Closed(object sender, System.EventArgs e)
		{
			DisplayTimer.Enabled = false;

			if ((B_StartMinMax.Enabled == false) && (B_StopMinMax.Enabled == true))
			{
				B_StopMinMax_Click(sender,e);
			}
			MX_370x = null;
			MX_Global = null;

			System.GC.Collect();
		}

		private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_0.SelectAll();
		}

		private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_1.SelectAll();
		}

		private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_2.SelectAll();
		}

		private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
		{
			TB_IPAddress_3.SelectAll();
		}

		private UInt64 GetTransducerTypeInfo() 
		{
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex;
			byte[] pc_Name = new byte[255];
			UInt64 ul_CalibrationStatus;
			UInt64 ul_Type;
			UInt64 ul_Frequency;
			UInt64 ul_Impedance;
			double  d_Veff;
			double  d_Range;
			double  d_Sensibility;
			UInt64 ul_SelectedTransducer;

			ul_SelectedTransducer = Convert.ToUInt64(CB_TransducerType.SelectedIndex);

			TB_TransducerTypeInfo.Text = "";
			ul_TransducerSelectionIndex = 0;
			try
			{
				// Get the tranducer type information
				MX_370x.TransducerGetTypeInformation(ul_SelectedTransducer, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);

				// Display the transducer type information
				TB_TransducerTypeInfo.Text = "Transducer Selection Index : " + ul_TransducerSelectionIndex.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Name                                   : " + enc.GetString(pc_Name);
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Calibration status                  : " + ul_CalibrationStatus.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Type Value                          : " + ul_Type.ToString();
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Frequency                           : " + ul_Frequency.ToString() + " Hz";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Impedance                          : " + ul_Impedance.ToString() + " Ohm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Nominal Voltage                  : " + d_Veff.ToString() + " V";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Sensibility                            : " + d_Sensibility.ToString() + " mV/V/mm";
				TB_TransducerTypeInfo.Text = TB_TransducerTypeInfo.Text + Environment.NewLine + "Range                                 : +/-" + d_Range.ToString() + " mm";
			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}

			return (ul_TransducerSelectionIndex);
		}

		private void B_GetModuleInformation_Click(object sender, System.EventArgs e)
		{
			byte [] pb_ModuleType = new byte [200];
			UInt64 ul_NbrOfTransducerType = 0;
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			UInt64 ul_TransducerSelectionIndex = 0;
			Byte []pc_Name = new Byte[255];
			UInt64 ul_CalibrationStatus = 0;
			UInt64 ul_Type = 0;
			UInt64 ul_Frequency = 0;
			UInt64 ul_Impedance = 0;
			UInt64 Cpt = 0;
			double d_Veff = 0.0;
			double d_Sensibility = 0.0;
			double d_Range = 0.0;
			
			MX_Global.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
			MX_370x.Url = MX_Global.Url;
		
			try
			{
				// Get the module type
				MX_Global.GetModuleType(out pb_ModuleType);
				L_MXModuleIdentifier.Text = enc.GetString(pb_ModuleType);

                // Get the number of transducer channels
                NbrOfChannel = ul_GetNbrOfTransducerChannel(enc.GetString(pb_ModuleType));
                if (NbrOfChannel <= 0)
                {
                    MessageBox.Show("Cannot find the number of transducer channels, assuming it is 16.");
                    NbrOfChannel = 16;
                }

				// Get the number of transducer type
				MX_370x.TransducerGetNbrOfType(out ul_NbrOfTransducerType);
				L_NbrOfTransducerType.Text = ul_NbrOfTransducerType.ToString();

				// Get the tranducer type information
				CB_TransducerType.Items.Clear();
                for (Cpt = 0; Cpt < ul_NbrOfTransducerType; Cpt++)
				{
                    MX_370x.TransducerGetTypeInformation(Cpt, out ul_TransducerSelectionIndex, out pc_Name, out ul_CalibrationStatus, out ul_Type, out ul_Frequency, out ul_Impedance, out d_Veff, out d_Sensibility, out d_Range);
					CB_TransducerType.Items.Add (enc.GetString(pc_Name));
				}
				CB_TransducerType.SelectedIndex = 0;
				B_StartMinMax.Enabled = true;
				B_StopMinMax.Enabled = false;
				GB_TransducerSelectionBox.Enabled = true;

                for (Cpt = 0; Cpt < NbrOfChannel; Cpt++)
				{
                    s_CHB_MinMax[Cpt].Enabled = true;
                    s_CHB_StopMinMax[Cpt].Enabled = true;
                }

                for (Cpt = NbrOfChannel; Cpt < 16; Cpt++)
				{
                    s_CHB_MinMax[Cpt].Enabled = false;
                    s_CHB_StopMinMax[Cpt].Enabled = false;
                }


                for (Cpt = 0; (Cpt < NbrOfChannel) || (Cpt < 4); Cpt++)
                    s_CHB_MinMax[Cpt].Checked = true;

                for (Cpt = 4; Cpt < 16; Cpt++)
                    s_CHB_MinMax[Cpt].Checked = false;


                s_CHB_StopMinMax[0].Checked = true;

                for (Cpt = 1; Cpt < 16; Cpt++)
                    s_CHB_StopMinMax[Cpt].Checked = false;

			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		private void CB_TransducerType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetTransducerTypeInfo();
		}



		private DateTime ConvertFromTime_T(long time_t)
		{
			DateTime netTimeT;
			DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
			long tickTotal;

			tickTotal = dt70.Ticks + (time_t * 10000000);
			netTimeT = new DateTime(tickTotal);
			return (netTimeT);
		}

		private void B_StartMinMax_Click(object sender, System.EventArgs e)
		{
			int     i_Error;
			int     i_SysError;
            UInt64 Cpt;
			UInt64 ul_SelectedTransducer;
            ulong ulStopCondition;


            ChannelMask = 0;
            StopChannelMask = 0;

			try
			{
				// Get the selected transducer
				ul_SelectedTransducer = GetTransducerTypeInfo();

				// Get the min max channel mask
                for (Cpt = 0; Cpt < NbrOfChannel; Cpt++)
				{
                    ChannelMask = ChannelMask + ((Convert.ToUInt64(s_CHB_MinMax[Cpt].Checked) & 1) * Convert.ToUInt64(Math.Pow(2, Cpt)));
				}
                // Get the min max channel mask
                for (Cpt = 0; Cpt < NbrOfChannel; Cpt++)
                {
                    StopChannelMask = StopChannelMask + ((Convert.ToUInt64(s_CHB_StopMinMax[Cpt].Checked) & 1) * Convert.ToUInt64(Math.Pow(2, Cpt)));
                }

                if (RB_Less.Checked)
                    ulStopCondition = 1;
                else
                    ulStopCondition = 2;

                DisplayText = "";

				//Init and start the min max acquisition
				i_Error = MX_370x.TransducerInitAndStartMinMaxAcquisition(ul_SelectedTransducer,
                                                                          ChannelMask,
                                                                    Convert.ToUInt64(CB_TimeDivision.SelectedItem),
                                                                    StopChannelMask,
                                                                    ulStopCondition,
					                                                Convert.ToUInt64(TB_StopValue.Text), 
					                                                0, 
					                                                0, 
					                                                0, 
                                                                    0,
					                                                out i_SysError);

				// Test if no error occur
				if (i_Error == 0) 
				{
					DisplayTimer.Enabled = true;
                    ReadTimer.Enabled = true;
                    B_StopMinMax.Enabled = true;
					B_StartMinMax.Enabled = false;
					GB_MinMaxConfig.Enabled = false;
					GB_StopCondition.Enabled = false;
					GB_ModuleSelectionBox.Enabled = false;
					GB_Frequency.Enabled = false;
				}
				else
				{
					MessageBox.Show ("TransducerInitAndStartMinMax Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				}
			}
			catch (Exception ex)
			{
                MessageBox.Show("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (B_StopMinMax.Enabled == false)
            {
                B_StopMinMax_Click(sender, null);
            }
		}

		private void B_StopMinMax_Click(object sender, System.EventArgs e)
		{
			int syserrno = 0;
			int i_Error = 0;

            DisplayTimer.Enabled = false;
            ReadTimer.Enabled    = false;

            if (B_StopMinMax.Enabled == true)
            {
                try
                {
                    // Stop and release the acquisition
                    i_Error = MX_370x.TransducerStopAndReleaseMinMaxAcquisition(out syserrno);
                    if (i_Error != 0)
                    {
                        MessageBox.Show("TransducerStopAndReleaseMinMaxAcquisition Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show ("Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }

                B_StartMinMax.Enabled = true;
                B_StopMinMax.Enabled = false;
                GB_MinMaxConfig.Enabled = true;
                GB_StopCondition.Enabled = true;
                GB_ModuleSelectionBox.Enabled = true;
                GB_Frequency.Enabled = true;
                GB_StopCondition.Enabled = true;
                
            }
		}




        private void ReadTimer_Tick(object sender, EventArgs e)
        {
		    ulong[] minValues = new ulong [17];
		    ulong[] maxValues = new ulong [17];
            int    i_Error;
            UInt32 Cpt;
            UInt32 TestChannel;
            String sOutString;
            ulong ulFlag;
            ulong ulOverflow;

            // Get the min max acquisition status
            i_Error = MX_370x.TransducerGetMinMaxStatus(out ulFlag, out ulOverflow, out minValues, out maxValues);

            // Test if error occur
            if (i_Error != 0)
            {
                B_StopMinMax_Click(sender, null);
                MessageBox.Show("TransducerGetMinMaxStatus Error : " + i_Error.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                sOutString = "Channel value(s) :" + Environment.NewLine;

				// display the min max values
                for (Cpt = 0, TestChannel = 1; Cpt < NbrOfChannel; Cpt++, TestChannel = TestChannel * 2)
                {
                    // Test if channel used
                    if ((ChannelMask & TestChannel) != 0)
                    {
                        sOutString = sOutString + "Channel:" + (Cpt+1).ToString() +" min value:  " + minValues[Cpt].ToString("X") + " Hex" + " max value: " + maxValues[Cpt].ToString("X") + " Hex" + Environment.NewLine;
                    }
                }

                if (ulFlag == 2)
                {
                    sOutString = sOutString + Environment.NewLine + "Compare value reach !";
                    DisplayText = sOutString;
                    DisplayTimer_Tick(sender, null);
                    B_StopMinMax_Click(sender, null);
                }

                if (ulOverflow == 1)
                {
                    sOutString = sOutString + Environment.NewLine + "PLD Overflow";
                    DisplayText = sOutString;
                    DisplayTimer_Tick(sender, null);
                    B_StopMinMax_Click(sender, null);
                }



                DisplayText = sOutString;
            }
        }																																																										

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            Display.Text = DisplayText;
        }

        private void F_MinMax_FormClosing(object sender, FormClosingEventArgs e)
        {
            B_StopMinMax_Click(sender, null);
        }


	}
}
