/** @file Socket.h
* Socket Functions declaration 
* 
*
* @author C. Guinot
* @date 30.01.2006
* 
* @version  $LastChangedRevision$
* @version $LastChangedDate$
* 
* 
* @par LICENCE
* @verbatim
   Copyright (C) 2006  ADDI-DATA GmbH for the source code of this module.
        
        ADDI-DATA GmbH 
        Airport Boulevard B210
        D-77836 Rheinmnster Germany 
        Tel: +49(0)7229/1847-0 
        Fax: +49(0)7229/1847-200
        http://www.addi-data-com 
        info@addi-data.com 
        
   @endverbatim   
*
*
*/ 

#ifndef __SOCKET_H__
#define __SOCKET_H__

#define WIN32_LEAN_AND_MEAN

#include <winsock.h>

#define _TCP_MODE		0
#define _UDP_MODE		1

INT i_Socket_ClientOpen (PCHAR pc_ServerIPAddress,WORD w_ServerPort,SOCKET  *ps_ClientSocket);

INT i_Socket_ClientOpenEx (PCHAR pc_ServerIPAddress,WORD w_ServerPort,INT i_ReceiveBufferSize, SOCKET  *ps_ClientSocket);

INT i_Socket_ClientClose (SOCKET  s_ClientSocket);

INT i_Socket_ClientOpenUDP (WORD w_LocalPort, SOCKET  *ps_ClientSocket);

#endif